export type Status = 'OK' | 'CANCELED';
export interface ResultWrapper<T> {
    status: Status;
    data?: T;
}
/** Compress format */
export type CompressFormat = 
/** JPEG image format */
'JPEG'
/** PNG image format */
 | 'PNG';
/** The SDK license status */
export type LicenseStatus = 
/** License is valid and accepted. */
'Okay'
/** No license set yet. The SDK is in trial mode. */
 | 'Trial'
/** No license set yet. The SDKs trial mode is over. */
 | 'Expired'
/** No license active. The set license does not cover the current operating system. */
 | 'WrongOS'
/** No license active. The set license was unreadable or has an invalid format. */
 | 'Corrupted'
/** No license active. The set licenses does not cover the current apps bundle identifier. */
 | 'AppIDMismatch'
/** No license set yet. The SDKs trial mode is over. */
 | 'NotSet';
/** File encryption mode, 'AES128' or 'AES256'. */
export type FileEncryptionMode = 
/** AES128 encryption mode */
'AES128'
/** AES256 encryption mode */
 | 'AES256';
