import { BarcodeItem } from '../../barcode/BarcodeScannerTypes';
import { ToJsonConfiguration } from '../../utils/json/JsonSerializationTypes';
import type { DeepPartial } from '../../utils/utils';
import { PartiallyConstructible } from '../../utils/utils';
/**
Data about the scanned barcode.
*/
export declare class BarcodeScannerUiItem extends PartiallyConstructible {
    /**
      Scanned barcode.
      */
    readonly barcode: BarcodeItem;
    /**
      Number of scanned barcodes of this symbology and value.
      */
    readonly count: number;
    /** @param source {@displayType `DeepPartial<BarcodeScannerUiItem>`} */
    constructor(source?: DeepPartial<BarcodeScannerUiItem>);
    serialize(config?: ToJsonConfiguration): Promise<DeepPartial<BarcodeScannerUiItem>>;
    private _released;
    release(): void;
    encodeImages(): Promise<void>;
}
/**
Results of the barcode scan.
*/
export declare class BarcodeScannerUiResult extends PartiallyConstructible {
    /**
      Scanned barcode items.
      */
    readonly items: BarcodeScannerUiItem[];
    /** @param source {@displayType `DeepPartial<BarcodeScannerUiResult>`} */
    constructor(source?: DeepPartial<BarcodeScannerUiResult>);
    serialize(config?: ToJsonConfiguration): Promise<DeepPartial<BarcodeScannerUiResult>>;
    private _released;
    release(): void;
    encodeImages(): Promise<void>;
}
