import { RoundButton } from '../../ui_v2/common/Common';
import type { DeepPartial } from '../../utils/utils';
import { PartiallyConstructible } from '../../utils/utils';
/**
Configuration of the buttons available in the action bar.
*/
export declare class ActionBarConfiguration extends PartiallyConstructible {
    /**
      Configuration of the 'flash' button.
      */
    flashButton: RoundButton;
    /**
      Configuration of the 'zoom' button.
      */
    zoomButton: RoundButton;
    /**
      Configuration of the 'flip camera' button.
      */
    flipCameraButton: RoundButton;
    /** @param source {@displayType `DeepPartial<ActionBarConfiguration>`} */
    constructor(source?: DeepPartial<ActionBarConfiguration>);
}
