import { ButtonConfiguration, IconStyle, StyledText } from '../../ui_v2/common/Common';
import type { StatusBarMode } from '../../ui_v2/common/TopBarConfiguration';
import type { DeepPartial } from '../../utils/utils';
import { PartiallyConstructible } from '../../utils/utils';
/**
Configuration of the camera permission request view.
*/
export declare class CameraPermissionScreen extends PartiallyConstructible {
    /**
      Determines the visual mode for displaying the contents of the status bar.
      
      Default is DARK
      */
    statusBarMode: StatusBarMode;
    /**
      The background color of the camera permission request.
      
      Default is "?sbColorSurface"
      */
    background: string;
    /**
      The background color of the icon used in the camera permission request.
      
      Default is "?sbColorOutline"
      */
    iconBackground: string;
    /**
      Configuration of the icon used in the camera permission request.
      */
    icon: IconStyle;
    /**
      Configuration of the camera permission request's confirmation button.
      */
    enableCameraButton: ButtonConfiguration;
    /**
      Configuration of the camera permission request's close button.
      */
    closeButton: ButtonConfiguration;
    /**
      Configuration of the camera permission request's title.
      */
    enableCameraTitle: StyledText;
    /**
      Configuration of the camera permission request's explanatory text.
      */
    enableCameraExplanation: StyledText;
    /** @param source {@displayType `DeepPartial<CameraPermissionScreen>`} */
    constructor(source?: DeepPartial<CameraPermissionScreen>);
}
