import { StyledText } from '../../ui_v2/common/Common';
import type { DeepPartial } from '../../utils/utils';
import { PartiallyConstructible } from '../../utils/utils';
/**
Configuration of the overlay to be shown after the successful scan.
*/
export declare class ScanCompletionOverlay extends PartiallyConstructible {
    /**
      A caption below the icon.
      */
    message: StyledText;
    /**
      Color of the icon.
      
      Default is "?sbColorOnPrimary"
      */
    iconColor: string;
    /**
      Background color of the overlay.
      
      Default is "?sbColorSurfaceHigh"
      */
    overlayBackgroundColor: string;
    /**
      Timeout in milliseconds after which the overlay is automatically dismissed.
      
      Default is 1000
      */
    timeout: number;
    /** @param source {@displayType `DeepPartial<ScanCompletionOverlay>`} */
    constructor(source?: DeepPartial<ScanCompletionOverlay>);
}
