'use strict';

var core = require('@capacitor/core');

class PartiallyConstructible {
    /** @internal */
    _marker() { }
}
/** @internal */
function mapRTUUIResult(result, LClass) {
    return Object.assign(Object.assign({}, result), { data: result.data !== undefined ? new LClass(result.data) : undefined });
}
/** @internal */
function mapPlainResult(jsObject) {
    return jsObject.result;
}
class Point {
    constructor(x, y) {
        this.x = x;
        this.y = y;
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from core/schemas/BarcodeConfigurationTypes.yaml
/** @internal */
exports.BarcodeFormatConfigurationBase = void 0;
(function (BarcodeFormatConfigurationBase) {
    /** @internal */
    function From(source) {
        const _type = source['_type'];
        switch (_type) {
            case 'BarcodeFormatCodabarConfiguration':
                return new BarcodeFormatCodabarConfiguration(source);
            case 'BarcodeFormatCode11Configuration':
                return new BarcodeFormatCode11Configuration(source);
            case 'BarcodeFormatCode39Configuration':
                return new BarcodeFormatCode39Configuration(source);
            case 'BarcodeFormatCode93Configuration':
                return new BarcodeFormatCode93Configuration(source);
            case 'BarcodeFormatCode128Configuration':
                return new BarcodeFormatCode128Configuration(source);
            case 'BarcodeFormatCode2Of5Configuration':
                return new BarcodeFormatCode2Of5Configuration(source);
            case 'BarcodeFormatDataBarConfiguration':
                return new BarcodeFormatDataBarConfiguration(source);
            case 'BarcodeFormatDataBarExpandedConfiguration':
                return new BarcodeFormatDataBarExpandedConfiguration(source);
            case 'BarcodeFormatDataBarLimitedConfiguration':
                return new BarcodeFormatDataBarLimitedConfiguration(source);
            case 'BarcodeFormatITFConfiguration':
                return new BarcodeFormatItfConfiguration(source);
            case 'BarcodeFormatMSIPlesseyConfiguration':
                return new BarcodeFormatMsiPlesseyConfiguration(source);
            case 'BarcodeFormatUpcEanConfiguration':
                return new BarcodeFormatUpcEanConfiguration(source);
            case 'BarcodeFormatPharmaCodeConfiguration':
                return new BarcodeFormatPharmaCodeConfiguration(source);
            case 'BarcodeFormatAztecConfiguration':
                return new BarcodeFormatAztecConfiguration(source);
            case 'BarcodeFormatQRCodeConfiguration':
                return new BarcodeFormatQrCodeConfiguration(source);
            case 'BarcodeFormatPDF417Configuration':
                return new BarcodeFormatPdf417Configuration(source);
            case 'BarcodeFormatMicroPDF417Configuration':
                return new BarcodeFormatMicroPdf417Configuration(source);
            case 'BarcodeFormatDataMatrixConfiguration':
                return new BarcodeFormatDataMatrixConfiguration(source);
            case 'BarcodeFormatMaxiCodeConfiguration':
                return new BarcodeFormatMaxiCodeConfiguration(source);
            case 'BarcodeFormatAustraliaPostConfiguration':
                return new BarcodeFormatAustraliaPostConfiguration(source);
            case 'BarcodeFormatJapanPostConfiguration':
                return new BarcodeFormatJapanPostConfiguration(source);
            case 'BarcodeFormatRoyalMailConfiguration':
                return new BarcodeFormatRoyalMailConfiguration(source);
            case 'BarcodeFormatRoyalTNTPostConfiguration':
                return new BarcodeFormatRoyalTntPostConfiguration(source);
            case 'BarcodeFormatUSPSIntelligentMailConfiguration':
                return new BarcodeFormatUspsIntelligentMailConfiguration(source);
            case 'BarcodeFormatPharmaCodeTwoTrackConfiguration':
                return new BarcodeFormatPharmaCodeTwoTrackConfiguration(source);
            case 'BarcodeFormatGS1CompositeConfiguration':
                return new BarcodeFormatGs1CompositeConfiguration(source);
            case 'BarcodeFormatCommonOneDConfiguration':
                return new BarcodeFormatCommonOneDConfiguration(source);
            case 'BarcodeFormatCommonTwoDConfiguration':
                return new BarcodeFormatCommonTwoDConfiguration(source);
            case 'BarcodeFormatCommonFourStateConfiguration':
                return new BarcodeFormatCommonFourStateConfiguration(source);
            case 'BarcodeFormatCommonConfiguration':
                return new BarcodeFormatCommonConfiguration(source);
            default:
                throw `Unknown child class name: ${_type}`;
        }
    }
    BarcodeFormatConfigurationBase.From = From;
})(exports.BarcodeFormatConfigurationBase || (exports.BarcodeFormatConfigurationBase = {}));
/** @internal */
exports.BarcodeFormatOneDConfigurationBase = void 0;
(function (BarcodeFormatOneDConfigurationBase) {
    /** @internal */
    function From(source) {
        const _type = source['_type'];
        switch (_type) {
            case 'BarcodeFormatCodabarConfiguration':
                return new BarcodeFormatCodabarConfiguration(source);
            case 'BarcodeFormatCode11Configuration':
                return new BarcodeFormatCode11Configuration(source);
            case 'BarcodeFormatCode39Configuration':
                return new BarcodeFormatCode39Configuration(source);
            case 'BarcodeFormatCode93Configuration':
                return new BarcodeFormatCode93Configuration(source);
            case 'BarcodeFormatCode128Configuration':
                return new BarcodeFormatCode128Configuration(source);
            case 'BarcodeFormatCode2Of5Configuration':
                return new BarcodeFormatCode2Of5Configuration(source);
            case 'BarcodeFormatDataBarConfiguration':
                return new BarcodeFormatDataBarConfiguration(source);
            case 'BarcodeFormatDataBarExpandedConfiguration':
                return new BarcodeFormatDataBarExpandedConfiguration(source);
            case 'BarcodeFormatDataBarLimitedConfiguration':
                return new BarcodeFormatDataBarLimitedConfiguration(source);
            case 'BarcodeFormatITFConfiguration':
                return new BarcodeFormatItfConfiguration(source);
            case 'BarcodeFormatMSIPlesseyConfiguration':
                return new BarcodeFormatMsiPlesseyConfiguration(source);
            case 'BarcodeFormatUpcEanConfiguration':
                return new BarcodeFormatUpcEanConfiguration(source);
            case 'BarcodeFormatPharmaCodeConfiguration':
                return new BarcodeFormatPharmaCodeConfiguration(source);
            default:
                throw `Unknown child class name: ${_type}`;
        }
    }
    BarcodeFormatOneDConfigurationBase.From = From;
})(exports.BarcodeFormatOneDConfigurationBase || (exports.BarcodeFormatOneDConfigurationBase = {}));
/**
Codabar barcode configuration. Add to scanner configuration to scan Codabar barcodes.
*/
class BarcodeFormatCodabarConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatCodabarConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatCodabarConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          Minimum text length. Applied only to linear barcode formats that allow variable length.
          
          Default is 1
          */
        this.minimumTextLength = 1;
        /**
          Maximum text length. 0 implies no maximum. Applied only to linear barcode formats that allow variable length.
          
          Default is 0
          */
        this.maximumTextLength = 0;
        /**
          If true, return the start and end characters.
          
          Default is false
          */
        this.returnStartEnd = false;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.minimumTextLength !== undefined) {
            this.minimumTextLength = source.minimumTextLength;
        }
        if (source.maximumTextLength !== undefined) {
            this.maximumTextLength = source.maximumTextLength;
        }
        if (source.returnStartEnd !== undefined) {
            this.returnStartEnd = source.returnStartEnd;
        }
    }
}
/**
Code 11 barcode configuration. Add to scanner configuration to scan Code11 barcodes.
*/
class BarcodeFormatCode11Configuration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatCode11Configuration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatCode11Configuration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          If true, the check digits are stripped from the result.
          
          Default is false
          */
        this.stripCheckDigits = false;
        /**
          Minimum text length. Applied only to linear barcode formats that allow variable length.
          
          Default is 1
          */
        this.minimumTextLength = 1;
        /**
          Maximum text length. 0 implies no maximum. Applied only to linear barcode formats that allow variable length.
          
          Default is 0
          */
        this.maximumTextLength = 0;
        /**
          If true, return CODE_11 barcodes only if they have a valid checksum.
          
          Default is true
          */
        this.checksum = true;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.stripCheckDigits !== undefined) {
            this.stripCheckDigits = source.stripCheckDigits;
        }
        if (source.minimumTextLength !== undefined) {
            this.minimumTextLength = source.minimumTextLength;
        }
        if (source.maximumTextLength !== undefined) {
            this.maximumTextLength = source.maximumTextLength;
        }
        if (source.checksum !== undefined) {
            this.checksum = source.checksum;
        }
    }
}
/**
Code 39 barcode and derivatives configuration. Add to scanner configuration to scan Code 39, Code 32 (Italian Pharmacode), PZN7 and PZN8 (Pharmazentralnummer) barcodes.
*/
class BarcodeFormatCode39Configuration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatCode39Configuration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatCode39Configuration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          If true, the check digits are stripped from the result.
          
          Default is false
          */
        this.stripCheckDigits = false;
        /**
          Minimum text length. Applied only to linear barcode formats that allow variable length.
          
          Default is 1
          */
        this.minimumTextLength = 1;
        /**
          Maximum text length. 0 implies no maximum. Applied only to linear barcode formats that allow variable length.
          
          Default is 0
          */
        this.maximumTextLength = 0;
        /**
          If true, scan and return valid CODE_32 (Italian Pharmacode) barcodes. If false, CODE_32 barcodes are not decoded and are returned as CODE_39 instead.
          
          Default is false
          */
        this.code32 = false;
        /**
          If true, scan CODE_39 barcodes.
          
          Default is true
          */
        this.code39 = true;
        /**
          If true, scan PZN7 (legacy Pharmazentralnummer) barcodes. If false, PZN7 barcodes are not decoded and are returned as CODE_39 instead.
          
          Default is true
          */
        this.pzn7 = true;
        /**
          If true, scan PZN8 (Pharmazentralnummer) barcodes. If false, PZN8 barcodes are not decoded and are returned as CODE_39 instead.
          
          Default is true
          */
        this.pzn8 = true;
        /**
          If true, try to scan CODE_39 in extended mode.
          
          Default is false
          */
        this.tryCode39ExtendedMode = false;
        /**
          If true, return CODE_39 barcodes only if they have a valid check digit.
          
          Default is false
          */
        this.useCode39CheckDigit = false;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.stripCheckDigits !== undefined) {
            this.stripCheckDigits = source.stripCheckDigits;
        }
        if (source.minimumTextLength !== undefined) {
            this.minimumTextLength = source.minimumTextLength;
        }
        if (source.maximumTextLength !== undefined) {
            this.maximumTextLength = source.maximumTextLength;
        }
        if (source.code32 !== undefined) {
            this.code32 = source.code32;
        }
        if (source.code39 !== undefined) {
            this.code39 = source.code39;
        }
        if (source.pzn7 !== undefined) {
            this.pzn7 = source.pzn7;
        }
        if (source.pzn8 !== undefined) {
            this.pzn8 = source.pzn8;
        }
        if (source.tryCode39ExtendedMode !== undefined) {
            this.tryCode39ExtendedMode = source.tryCode39ExtendedMode;
        }
        if (source.useCode39CheckDigit !== undefined) {
            this.useCode39CheckDigit = source.useCode39CheckDigit;
        }
    }
}
/**
Code 93 barcode configuration. Add to scanner configuration to scan Code 93 barcodes.
*/
class BarcodeFormatCode93Configuration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatCode93Configuration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatCode93Configuration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          If true, the check digits are stripped from the result.
          
          Default is false
          */
        this.stripCheckDigits = false;
        /**
          Minimum text length. Applied only to linear barcode formats that allow variable length.
          
          Default is 1
          */
        this.minimumTextLength = 1;
        /**
          Maximum text length. 0 implies no maximum. Applied only to linear barcode formats that allow variable length.
          
          Default is 0
          */
        this.maximumTextLength = 0;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.stripCheckDigits !== undefined) {
            this.stripCheckDigits = source.stripCheckDigits;
        }
        if (source.minimumTextLength !== undefined) {
            this.minimumTextLength = source.minimumTextLength;
        }
        if (source.maximumTextLength !== undefined) {
            this.maximumTextLength = source.maximumTextLength;
        }
    }
}
/**
Code 128 barcode configuration. Add to scanner configuration to scan Code 128 barcodes.
*/
class BarcodeFormatCode128Configuration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatCode128Configuration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatCode128Configuration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          GS1 message handling options.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        /**
          Minimum text length. Applied only to linear barcode formats that allow variable length.
          
          Default is 1
          */
        this.minimumTextLength = 1;
        /**
          Maximum text length. 0 implies no maximum. Applied only to linear barcode formats that allow variable length.
          
          Default is 0
          */
        this.maximumTextLength = 0;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
        if (source.minimumTextLength !== undefined) {
            this.minimumTextLength = source.minimumTextLength;
        }
        if (source.maximumTextLength !== undefined) {
            this.maximumTextLength = source.maximumTextLength;
        }
    }
}
/**
Configuration for all 2-of-5 barcode types (except Interleaved 2-of-5, which is handled by ItfConfig).
Add to scanner configuration to scan Code 25, IATA 2-of-5 and Industrial 2-of-5 barcodes.

Industrial 2-of-5 barcodes are a subset of Code 25 barcodes.
Any valid Industrial 2-of-5 barcode is also a valid Code 25 barcode.
*/
class BarcodeFormatCode2Of5Configuration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatCode2Of5Configuration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatCode2Of5Configuration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          If true, the check digits are stripped from the result.
          
          Default is false
          */
        this.stripCheckDigits = false;
        /**
          Minimum text length. Applied only to linear barcode formats that allow variable length.
          
          Default is 1
          */
        this.minimumTextLength = 1;
        /**
          Maximum text length. 0 implies no maximum. Applied only to linear barcode formats that allow variable length.
          
          Default is 0
          */
        this.maximumTextLength = 0;
        /**
          If true, scan IATA 2-of-5 barcodes. If useIATA2OF5Checksum is true, only barcodes with a valid checksum are returned.
          
          Default is true
          */
        this.iata2of5 = true;
        /**
          If true, scan and return Code 25 (Code 2-of-5) barcodes. If industrial2of5 is also true, then valid Industrial 2-of-5 barcodes will preferentially be returned as such, instead of Code 25.
          
          Default is false
          */
        this.code25 = false;
        /**
          If true, scan and return valid Industrial 2-of-5 barcodes. If false, but code25 is true, Industrial 2-of-5 barcodes will be returned as Code 25 barcodes.
          
          Default is true
          */
        this.industrial2of5 = true;
        /**
          If true, return IATA_2_OF_5 barcodes only if they have a valid check digit.
          
          Default is true
          */
        this.useIATA2OF5Checksum = true;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.stripCheckDigits !== undefined) {
            this.stripCheckDigits = source.stripCheckDigits;
        }
        if (source.minimumTextLength !== undefined) {
            this.minimumTextLength = source.minimumTextLength;
        }
        if (source.maximumTextLength !== undefined) {
            this.maximumTextLength = source.maximumTextLength;
        }
        if (source.iata2of5 !== undefined) {
            this.iata2of5 = source.iata2of5;
        }
        if (source.code25 !== undefined) {
            this.code25 = source.code25;
        }
        if (source.industrial2of5 !== undefined) {
            this.industrial2of5 = source.industrial2of5;
        }
        if (source.useIATA2OF5Checksum !== undefined) {
            this.useIATA2OF5Checksum = source.useIATA2OF5Checksum;
        }
    }
}
/**
GS1 DataBar barcode configuration. Add to scanner configuration to scan GS1 DataBar-14, GS1 DataBar-14 Truncated, GS1 DataBar-14 Stacked and GS1 DataBar-14 Stacked Omnidirectional barcodes.
*/
class BarcodeFormatDataBarConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatDataBarConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatDataBarConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          GS1 message handling options.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
    }
}
/**
GS1 DataBar Expanded barcode configuration. Add to scanner configuration to scan GS1 DataBar Expanded and GS1 DataBar Expanded Stacked barcodes.
*/
class BarcodeFormatDataBarExpandedConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatDataBarExpandedConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatDataBarExpandedConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          GS1 message handling options.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
    }
}
/**
GS1 DataBar Limited barcode configuration. Add to scanner configuration to scan GS1 DataBar Limited barcodes.
*/
class BarcodeFormatDataBarLimitedConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatDataBarLimitedConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatDataBarLimitedConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          GS1 message handling options.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
    }
}
/**
ITF (Interleaved 2-of-5) barcode configuration. Add to scanner configuration to scan Interleaved 2-of-5 (ITF) barcodes.
*/
class BarcodeFormatItfConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatItfConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatITFConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          Minimum text length. Applied only to linear barcode formats that allow variable length.
          
          Default is 1
          */
        this.minimumTextLength = 1;
        /**
          Maximum text length. 0 implies no maximum. Applied only to linear barcode formats that allow variable length.
          
          Default is 0
          */
        this.maximumTextLength = 0;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.minimumTextLength !== undefined) {
            this.minimumTextLength = source.minimumTextLength;
        }
        if (source.maximumTextLength !== undefined) {
            this.maximumTextLength = source.maximumTextLength;
        }
    }
}
const MsiPlesseyChecksumAlgorithmValues = [
    'MOD_10',
    'MOD_11_IBM',
    'MOD_11_NCR',
    'MOD_10_10',
    'MOD_11_10_IBM',
    'MOD_11_10_NCR',
];
/**
MSI Plessey barcode configuration. Add to scanner configuration to scan MSI Plessey barcodes.
*/
class BarcodeFormatMsiPlesseyConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatMsiPlesseyConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatMSIPlesseyConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          If true, the check digits are stripped from the result.
          
          Default is false
          */
        this.stripCheckDigits = false;
        /**
          Minimum text length. Applied only to linear barcode formats that allow variable length.
          
          Default is 1
          */
        this.minimumTextLength = 1;
        /**
          Maximum text length. 0 implies no maximum. Applied only to linear barcode formats that allow variable length.
          
          Default is 0
          */
        this.maximumTextLength = 0;
        /**
          List of MSI Plessey checksum algorithms to apply during scanning.
          A barcode is considered valid if it passes any of the checksum algorithms in the list.
          If the list is empty, no checksum validation is performed.
          */
        this.checksumAlgorithms = ['MOD_10'];
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.stripCheckDigits !== undefined) {
            this.stripCheckDigits = source.stripCheckDigits;
        }
        if (source.minimumTextLength !== undefined) {
            this.minimumTextLength = source.minimumTextLength;
        }
        if (source.maximumTextLength !== undefined) {
            this.maximumTextLength = source.maximumTextLength;
        }
        if (source.checksumAlgorithms !== undefined) {
            this.checksumAlgorithms = source.checksumAlgorithms.map((it) => {
                return it;
            });
        }
    }
}
/**
UPC/EAN barcode configuration. Add to scanner configuration to scan EAN-8, EAN-13, UPC-E and UPC-A barcodes.
*/
class BarcodeFormatUpcEanConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatUpcEanConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatUpcEanConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          If true, the check digits are stripped from the result.
          
          Default is false
          */
        this.stripCheckDigits = false;
        /**
          If true, scan and return valid EAN-8 barcodes.
          
          Default is true
          */
        this.ean8 = true;
        /**
          If true, scan and return valid EAN-13 barcodes.
          
          Default is true
          */
        this.ean13 = true;
        /**
          If true, scan and return valid UPC-A barcodes. If false, but ean13 is true, then UPC-A barcodes will be returned as EAN-13 barcodes.
          
          Default is true
          */
        this.upca = true;
        /**
          If true, scan and return valid UPC-E barcodes.
          
          Default is true
          */
        this.upce = true;
        /**
          Behavior when scanning UPC/EAN barcodes with EAN-2 or EAN-5 extensions.
          
          Default is ALLOW_ANY
          */
        this.extensions = 'ALLOW_ANY';
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.stripCheckDigits !== undefined) {
            this.stripCheckDigits = source.stripCheckDigits;
        }
        if (source.ean8 !== undefined) {
            this.ean8 = source.ean8;
        }
        if (source.ean13 !== undefined) {
            this.ean13 = source.ean13;
        }
        if (source.upca !== undefined) {
            this.upca = source.upca;
        }
        if (source.upce !== undefined) {
            this.upce = source.upce;
        }
        if (source.extensions !== undefined) {
            this.extensions = source.extensions;
        }
    }
}
/**
PharmaCode barcode configuration. Add to scanner configuration to scan linear (1D) Laetus Pharmacode barcodes. Two-track PharmaCode scanning is configured separately through the PharmaCodeTwoTrackConfig class.
*/
class BarcodeFormatPharmaCodeConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatPharmaCodeConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatPharmaCodeConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          Minimum value for PharmaCode. Very low values are likely to produce more false positives.
          
          Default is 16
          */
        this.minimumValue = 16;
        /**
          If true, a result consisting of only narrow bars is accepted as valid. The specification does not recommend such barcodes. Default is false.
          
          Default is false
          */
        this.allowNarrowBarsOnly = false;
        /**
          If true, a result consisting of only wide bars is accepted as valid. The specification does not recommend such barcodes. Default is false.
          
          Default is false
          */
        this.allowWideBarsOnly = false;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.minimumValue !== undefined) {
            this.minimumValue = source.minimumValue;
        }
        if (source.allowNarrowBarsOnly !== undefined) {
            this.allowNarrowBarsOnly = source.allowNarrowBarsOnly;
        }
        if (source.allowWideBarsOnly !== undefined) {
            this.allowWideBarsOnly = source.allowWideBarsOnly;
        }
    }
}
/** @internal */
exports.BarcodeFormatTwoDConfigurationBase = void 0;
(function (BarcodeFormatTwoDConfigurationBase) {
    /** @internal */
    function From(source) {
        const _type = source['_type'];
        switch (_type) {
            case 'BarcodeFormatAztecConfiguration':
                return new BarcodeFormatAztecConfiguration(source);
            case 'BarcodeFormatQRCodeConfiguration':
                return new BarcodeFormatQrCodeConfiguration(source);
            case 'BarcodeFormatPDF417Configuration':
                return new BarcodeFormatPdf417Configuration(source);
            case 'BarcodeFormatMicroPDF417Configuration':
                return new BarcodeFormatMicroPdf417Configuration(source);
            case 'BarcodeFormatDataMatrixConfiguration':
                return new BarcodeFormatDataMatrixConfiguration(source);
            case 'BarcodeFormatMaxiCodeConfiguration':
                return new BarcodeFormatMaxiCodeConfiguration(source);
            default:
                throw `Unknown child class name: ${_type}`;
        }
    }
    BarcodeFormatTwoDConfigurationBase.From = From;
})(exports.BarcodeFormatTwoDConfigurationBase || (exports.BarcodeFormatTwoDConfigurationBase = {}));
/**
Aztec configuration. Add to scanner configuration to scan Aztec codes.
*/
class BarcodeFormatAztecConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatAztecConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatAztecConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          GS1 message handling options.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
    }
}
/**
QR Code configuration. Add to scanner configuration to scan QR codes, Micro QR codes and rectangular Micro QR (rMQR) codes.
*/
class BarcodeFormatQrCodeConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatQrCodeConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatQRCodeConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          GS1 message handling options.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        /**
          If true, the barcode scanner will only return barcodes that pass the strict validation checks according to standards to avoid false positives.
          
          Default is true
          */
        this.strictMode = true;
        /**
          If true, scan and return QR codes.
          
          Default is true
          */
        this.qr = true;
        /**
          If true, scan and return Micro QR codes.
          
          Default is false
          */
        this.microQr = false;
        /**
          If true, scan and return rectangular Micro QR (rMQR) codes.
          
          Default is false
          */
        this.rmqr = false;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
        if (source.strictMode !== undefined) {
            this.strictMode = source.strictMode;
        }
        if (source.qr !== undefined) {
            this.qr = source.qr;
        }
        if (source.microQr !== undefined) {
            this.microQr = source.microQr;
        }
        if (source.rmqr !== undefined) {
            this.rmqr = source.rmqr;
        }
    }
}
/**
PDF417 configuration. Add to scanner configuration to scan PDF417 codes.
*/
class BarcodeFormatPdf417Configuration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatPdf417Configuration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatPDF417Configuration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          GS1 message handling options.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        /**
          If true, the barcode scanner will only return barcodes that pass the strict validation checks according to standards to avoid false positives.
          
          Default is true
          */
        this.strictMode = true;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
        if (source.strictMode !== undefined) {
            this.strictMode = source.strictMode;
        }
    }
}
/**
MicroPDF417 configuration. Add to scanner configuration to scan MicroPDF417 codes.
*/
class BarcodeFormatMicroPdf417Configuration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatMicroPdf417Configuration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatMicroPDF417Configuration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          GS1 message handling options.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        /**
          If true, the barcode scanner will only return barcodes that pass the strict validation checks according to standards to avoid false positives.
          
          Default is true
          */
        this.strictMode = true;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
        if (source.strictMode !== undefined) {
            this.strictMode = source.strictMode;
        }
    }
}
/**
DataMatrix configuration. Add to scanner configuration to scan DataMatrix and DataMatrix rectangular extensions (DMRE) codes.
*/
class BarcodeFormatDataMatrixConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatDataMatrixConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatDataMatrixConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          GS1 message handling options.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
    }
}
/**
MaxiCode configuration. Add to scanner configuration to scan MaxiCode codes.
*/
class BarcodeFormatMaxiCodeConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatMaxiCodeConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatMaxiCodeConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
    }
}
/** @internal */
exports.BarcodeFormatFourStateConfigurationBase = void 0;
(function (BarcodeFormatFourStateConfigurationBase) {
    /** @internal */
    function From(source) {
        const _type = source['_type'];
        switch (_type) {
            case 'BarcodeFormatAustraliaPostConfiguration':
                return new BarcodeFormatAustraliaPostConfiguration(source);
            case 'BarcodeFormatJapanPostConfiguration':
                return new BarcodeFormatJapanPostConfiguration(source);
            case 'BarcodeFormatRoyalMailConfiguration':
                return new BarcodeFormatRoyalMailConfiguration(source);
            case 'BarcodeFormatRoyalTNTPostConfiguration':
                return new BarcodeFormatRoyalTntPostConfiguration(source);
            case 'BarcodeFormatUSPSIntelligentMailConfiguration':
                return new BarcodeFormatUspsIntelligentMailConfiguration(source);
            case 'BarcodeFormatPharmaCodeTwoTrackConfiguration':
                return new BarcodeFormatPharmaCodeTwoTrackConfiguration(source);
            default:
                throw `Unknown child class name: ${_type}`;
        }
    }
    BarcodeFormatFourStateConfigurationBase.From = From;
})(exports.BarcodeFormatFourStateConfigurationBase || (exports.BarcodeFormatFourStateConfigurationBase = {}));
const AustraliaPostCustomerFormatValues = ['NUMERIC', 'ALPHA_NUMERIC'];
/**
Australia Post barcode configuration. Add to scanner configuration to scan Australia Post barcodes.
*/
class BarcodeFormatAustraliaPostConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatAustraliaPostConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatAustraliaPostConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Can be either numeric or alpha-numeric and is only relevant for Format Codes 59 and 62.
          
          Default is ALPHA_NUMERIC
          */
        this.australiaPostCustomerFormat = 'ALPHA_NUMERIC';
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.australiaPostCustomerFormat !== undefined) {
            this.australiaPostCustomerFormat = source.australiaPostCustomerFormat;
        }
    }
}
/**
Japan Post barcode configuration. Add to scanner configuration to scan Japan Post barcodes.
*/
class BarcodeFormatJapanPostConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatJapanPostConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatJapanPostConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
    }
}
/**
Royal Mail barcode configuration. Add to scanner configuration to scan Royal Mail (a.k.a. RM4SCC, CBC, BPO 4-State) barcodes.
*/
class BarcodeFormatRoyalMailConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatRoyalMailConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatRoyalMailConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          If true, the check digits are stripped from the result.
          
          Default is false
          */
        this.stripCheckDigits = false;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.stripCheckDigits !== undefined) {
            this.stripCheckDigits = source.stripCheckDigits;
        }
    }
}
/**
Royal TNT Post barcode configuration. Add to scanner configuration to scan Royal TNT Post (a.k.a. KIX, Klant IndeX) barcodes.
*/
class BarcodeFormatRoyalTntPostConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatRoyalTntPostConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatRoyalTNTPostConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
    }
}
/**
USPS Intelligent Mail barcode configuration. Add to scanner configuration to scan USPS Intelligent Mail (a.k.a. USPS OneCode, USPS-STD-11) barcodes.
*/
class BarcodeFormatUspsIntelligentMailConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatUspsIntelligentMailConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatUSPSIntelligentMailConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
    }
}
/**
PHARMA_CODE_TWO_TRACK barcode configuration. Add to scanner configuration to scan Laetus two-track PharmaCode barcodes. Linear (i.e. one-track) PharmaCode scanning is configured separately through the PharmaCodeConfig class.
*/
class BarcodeFormatPharmaCodeTwoTrackConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatPharmaCodeTwoTrackConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatPharmaCodeTwoTrackConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum value for PHARMA_CODE_TWO_TRACK. Very low values are likely to produce more false positives.
          
          Default is 364
          */
        this.minimumValue = 364;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimumValue !== undefined) {
            this.minimumValue = source.minimumValue;
        }
    }
}
/**
GS1 Composite configuration. Add to scanner configuration to scan GS1 Composite barcodes.

When not enabled, the individual parts of GS1 Composite barcodes will be returned as separate items,
if the respective formats are enabled (UPC-A, Code 128, MicroPDF417, PDF417).
Those barcode items will have their isGS1CompositePart field set to true.
If GS1 Composite scanning is enabled, the individual parts are never returned, even if their respective formats
are enabled, except when the linear component is a UPC or EAN barcode. In that case the linear component might still
occasionally be returned as a separate result. If this situation needs to be avoided, remove the UPC and EAN formats from
the enabled formats.

If GS1 Composite scanning is disabled, but GS1 message validation is enabled, then the parts of the composite barcode may
fail validation and be rejected.
*/
class BarcodeFormatGs1CompositeConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatGs1CompositeConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatGS1CompositeConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          GS1 message handling options.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        /**
          If true, the barcode scanner will only return barcodes that pass the strict validation checks according to standards to avoid false positives.
          
          Default is true
          */
        this.strictMode = true;
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
        if (source.strictMode !== undefined) {
            this.strictMode = source.strictMode;
        }
    }
}
/**
Convenience configuration for enabling the scanning of multiple linear (1D) barcode formats with a common configuration.
Add to scanner configuration to enable and configure the scanning of multiple linear (1D) barcode formats.

The given configuration will be applied to all enabled barcode formats, if they support it.
You can override the common configuration for individual barcode formats by additionally adding
their specific configuration to the scanner's configuration.
*/
class BarcodeFormatCommonOneDConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatCommonOneDConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatCommonOneDConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          If true, the check digits are stripped from the result.
          
          Default is false
          */
        this.stripCheckDigits = false;
        /**
          Minimum text length. Applied only to linear barcode formats that allow variable length.
          
          Default is 1
          */
        this.minimumTextLength = 1;
        /**
          Maximum text length. 0 implies no maximum. Applied only to linear barcode formats that allow variable length.
          
          Default is 0
          */
        this.maximumTextLength = 0;
        /**
          GS1 message handling options.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        /**
          List of linear (1D) barcode formats to scan.
          */
        this.formats = [
            'CODABAR',
            'CODE_11',
            'CODE_25',
            'CODE_32',
            'CODE_39',
            'CODE_93',
            'CODE_128',
            'DATABAR',
            'DATABAR_EXPANDED',
            'DATABAR_LIMITED',
            'EAN_8',
            'EAN_13',
            'IATA_2_OF_5',
            'INDUSTRIAL_2_OF_5',
            'ITF',
            'MSI_PLESSEY',
            'PHARMA_CODE',
            'PZN_7',
            'PZN_8',
            'UPC_A',
            'UPC_E',
        ];
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.stripCheckDigits !== undefined) {
            this.stripCheckDigits = source.stripCheckDigits;
        }
        if (source.minimumTextLength !== undefined) {
            this.minimumTextLength = source.minimumTextLength;
        }
        if (source.maximumTextLength !== undefined) {
            this.maximumTextLength = source.maximumTextLength;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
        if (source.formats !== undefined) {
            this.formats = source.formats.map((it) => {
                return it;
            });
        }
    }
}
/**
Convenience configuration for enabling the scanning of multiple 2D codes with a common configuration.
Add to scanner configuration to enable and configure the scanning of multiple 2D codes.

The given configuration will be applied to all enabled barcode formats, if they support it.
You can override the common configuration for individual barcode formats by additionally adding
their specific configuration to the scanner's configuration.
*/
class BarcodeFormatCommonTwoDConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatCommonTwoDConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatCommonTwoDConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          GS1 message handling options.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        /**
          If true, the barcode scanner will only return barcodes that pass the strict validation checks according to standards to avoid false positives.
          
          Default is true
          */
        this.strictMode = true;
        /**
          List of 2D codes to scan.
          */
        this.formats = [
            'AZTEC',
            'DATA_MATRIX',
            'MAXI_CODE',
            'MICRO_QR_CODE',
            'MICRO_PDF_417',
            'PDF_417',
            'QR_CODE',
            'RMQR_CODE',
        ];
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
        if (source.strictMode !== undefined) {
            this.strictMode = source.strictMode;
        }
        if (source.formats !== undefined) {
            this.formats = source.formats.map((it) => {
                return it;
            });
        }
    }
}
/**
Convenience configuration for enabling the scanning of multiple four-state barcode formats with a common configuration.
Add to scanner configuration to enable and configure the scanning of multiple four-state codes.

The given configuration will be applied to all enabled barcode formats, if they support it.
You can override the common configuration for individual barcode formats by additionally adding
their specific configuration to the scanner's configuration.
*/
class BarcodeFormatCommonFourStateConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatCommonFourStateConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatCommonFourStateConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          List of four-state barcode formats to scan.
          */
        this.formats = [
            'AUSTRALIA_POST',
            'JAPAN_POST',
            'ROYAL_MAIL',
            'ROYAL_TNT_POST',
            'USPS_INTELLIGENT_MAIL',
        ];
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.formats !== undefined) {
            this.formats = source.formats.map((it) => {
                return it;
            });
        }
    }
}
/**
Convenience configuration for enabling the scanning of multiple barcode formats with a common configuration.
Add to scanner configuration to enable and configure the scanning of multiple barcodes.

The given configuration will be applied to all enabled barcode formats, if they support it.
You can override the common configuration for individual barcode formats by additionally adding
their specific configuration to the scanner's configuration.
*/
class BarcodeFormatCommonConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormatCommonConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'BarcodeFormatCommonConfiguration';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off).
          
          Default is ""
          */
        this.regexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1).
          Barcodes with a sizeScore less than this value will not be scanned.
          When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          If true, we process the barcode scanning with an artificial quiet zone that we add to the input image.
          This flag should be used to scan sharp crops of a barcode in single-shot mode.
          
          Default is false
          */
        this.addAdditionalQuietZone = false;
        /**
          Minimum quiet zone size on the left and right sides of a 1D barcode, measured in number of modules.
          The quiet zone is only for 1D barcodes with weak start/stop patterns, i.e. Iata2Of5, Industrial2Of5, Code25, Itf, Codabar, MsiPlessey, and Code11.
          
          Default is 6
          */
        this.minimum1DQuietZoneSize = 6;
        /**
          If true, the check digits are stripped from the result.
          
          Default is false
          */
        this.stripCheckDigits = false;
        /**
          Minimum text length. Applied only to linear barcode formats that allow variable length.
          
          Default is 1
          */
        this.minimumTextLength = 1;
        /**
          Maximum text length. 0 implies no maximum. Applied only to linear barcode formats that allow variable length.
          
          Default is 0
          */
        this.maximumTextLength = 0;
        /**
          GS1 message handling options.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        /**
          If true, the barcode scanner will only return barcodes that pass the strict validation checks according to standards to avoid false positives.
          
          Default is true
          */
        this.strictMode = true;
        /**
          List of barcode formats to scan. By default, the most commonly used formats are enabled.
          */
        this.formats = [
            'AZTEC',
            'CODABAR',
            'CODE_39',
            'CODE_93',
            'CODE_128',
            'DATA_MATRIX',
            'DATABAR',
            'DATABAR_EXPANDED',
            'DATABAR_LIMITED',
            'EAN_13',
            'EAN_8',
            'ITF',
            'MICRO_QR_CODE',
            'PDF_417',
            'QR_CODE',
            'UPC_A',
            'UPC_E',
        ];
        if (source.regexFilter !== undefined) {
            this.regexFilter = source.regexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.addAdditionalQuietZone !== undefined) {
            this.addAdditionalQuietZone = source.addAdditionalQuietZone;
        }
        if (source.minimum1DQuietZoneSize !== undefined) {
            this.minimum1DQuietZoneSize = source.minimum1DQuietZoneSize;
        }
        if (source.stripCheckDigits !== undefined) {
            this.stripCheckDigits = source.stripCheckDigits;
        }
        if (source.minimumTextLength !== undefined) {
            this.minimumTextLength = source.minimumTextLength;
        }
        if (source.maximumTextLength !== undefined) {
            this.maximumTextLength = source.maximumTextLength;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
        if (source.strictMode !== undefined) {
            this.strictMode = source.strictMode;
        }
        if (source.formats !== undefined) {
            this.formats = source.formats.map((it) => {
                return it;
            });
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from core/schemas/CommonFieldType.yaml
const CommonFieldTypeValues = [
    'ID',
    'SURNAME',
    'MAIDEN_NAME',
    'GIVEN_NAMES',
    'BIRTH_DATE',
    'NATIONALITY',
    'BIRTHPLACE',
    'EXPIRY_DATE',
    'EYE_COLOR',
    'HEIGHT',
    'ISSUE_DATE',
    'ISSUING_AUTHORITY',
    'ADDRESS',
    'PSEUDONYM',
    'MRZ',
    'COUNTRY_CODE',
    'GENDER',
    'SIGNATURE',
    'PHOTO',
    'VALID_FROM_DATE',
    'ROUTING_NUMBER',
    'ACCOUNT_NUMBER',
    'PLACE_OF_ISSUE',
    'TITLE_TYPE',
    'REMARKS',
    'NAME',
    'CARD_ACCESS_NUMBER',
];

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from core/schemas/JSONSerializationTypes.yaml
/**
Configuration used to serialize an object to json.
*/
class ToJsonConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ToJsonConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Serialize images in the object to json. If false, then fields that contain images are not serialized.
          
          Default is true
          */
        this.serializeImages = true;
        /**
          image serialization mode.
          
          Default is REFERENCE
          */
        this.imageSerializationMode = 'REFERENCE';
        if (source.serializeImages !== undefined) {
            this.serializeImages = source.serializeImages;
        }
        if (source.imageSerializationMode !== undefined) {
            this.imageSerializationMode = source.imageSerializationMode;
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            serializeImages: this.serializeImages,
            imageSerializationMode: this.imageSerializationMode,
        };
    }
}
const ImageSerializationModeValues = ['REFERENCE', 'BUFFER'];

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from core/schemas/ObjectPoolTypes.yaml
/**
Profile info of a reference-counted stored object.
*/
class RefCountedObjectProfile extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<RefCountedObjectProfile>`} */
    constructor(source = {}) {
        super();
        /**
          Number of strong references associated with the object. The strong reference count increases when a new instance of a platform ImageRef class is created from the object's unique ID and decreases when the ImageRef instance is destroyed.
          
          Default is 0
          */
        this.strongReferences = 0;
        /**
          Number of serialized references to the object. The serialized reference count increases when an ImageRef is written to JSON or a Parcel on Android and decrease when the respective JSON or Parcel is deserialized.
          
          Default is 0
          */
        this.serializedReferences = 0;
        if (source.uniqueId !== undefined) {
            this.uniqueId = source.uniqueId;
        }
        else {
            throw new Error('uniqueId must be present in constructor argument');
        }
        if (source.timestampCreated !== undefined) {
            this.timestampCreated = source.timestampCreated;
        }
        else {
            throw new Error('timestampCreated must be present in constructor argument');
        }
        if (source.strongReferences !== undefined) {
            this.strongReferences = source.strongReferences;
        }
        if (source.serializedReferences !== undefined) {
            this.serializedReferences = source.serializedReferences;
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            uniqueId: this.uniqueId,
            timestampCreated: this.timestampCreated,
            strongReferences: this.strongReferences,
            serializedReferences: this.serializedReferences,
        };
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from core/schemas/ImageRefTypes.yaml
/**
Image Info.
*/
class ImageInfo extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ImageInfo>`} */
    constructor(source = {}) {
        super();
        if (source.height !== undefined) {
            this.height = source.height;
        }
        else {
            throw new Error('height must be present in constructor argument');
        }
        if (source.width !== undefined) {
            this.width = source.width;
        }
        else {
            throw new Error('width must be present in constructor argument');
        }
        if (source.maxByteSize !== undefined) {
            this.maxByteSize = source.maxByteSize;
        }
        else {
            throw new Error('maxByteSize must be present in constructor argument');
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            height: this.height,
            width: this.width,
            maxByteSize: this.maxByteSize,
        };
    }
}
const PathLoadModeValues = ['EAGER', 'LAZY', 'LAZY_WITH_COPY'];
const BufferLoadModeValues = ['EAGER', 'LAZY'];
const EncodingFormatValues = ['JPEG', 'PNG'];
const EncryptionModeValues = ['REQUIRED', 'DISABLED', 'IF_AVAILABLE'];
/**
Basic options for loading image.
*/
class BasicImageLoadOptions extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BasicImageLoadOptions>`} */
    constructor(source = {}) {
        super();
        /**
          Region of interest.
          */
        this.roi = { x: 0, y: 0, width: 0, height: 0 };
        if (source.roi !== undefined) {
            this.roi = { x: source.roi.x, y: source.roi.y, width: source.roi.width, height: source.roi.height };
        }
    }
}
/**
Options for loading images that come from sensor.
*/
class RawImageLoadOptions extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<RawImageLoadOptions>`} */
    constructor(source = {}) {
        super();
        /**
          Region of interest.
          */
        this.roi = { x: 0, y: 0, width: 0, height: 0 };
        /**
          Rotation that should be applied to the image to recover correct orientation.
          
          Default is NONE
          */
        this.orientation = 'NONE';
        if (source.roi !== undefined) {
            this.roi = { x: source.roi.x, y: source.roi.y, width: source.roi.width, height: source.roi.height };
        }
        if (source.orientation !== undefined) {
            this.orientation = source.orientation;
        }
    }
}
/**
Options for loading image from path.
*/
class PathImageLoadOptions extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<PathImageLoadOptions>`} */
    constructor(source = {}) {
        super();
        /**
          Region of interest.
          */
        this.roi = { x: 0, y: 0, width: 0, height: 0 };
        /**
          Load mode.
          
          Default is EAGER
          */
        this.loadMode = 'EAGER';
        /**
          Encryption mode.
          
          Default is IF_AVAILABLE
          */
        this.encryptionMode = 'IF_AVAILABLE';
        if (source.roi !== undefined) {
            this.roi = { x: source.roi.x, y: source.roi.y, width: source.roi.width, height: source.roi.height };
        }
        if (source.loadMode !== undefined) {
            this.loadMode = source.loadMode;
        }
        if (source.encryptionMode !== undefined) {
            this.encryptionMode = source.encryptionMode;
        }
    }
}
/**
Options for loading image from buffer.
*/
class BufferImageLoadOptions extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BufferImageLoadOptions>`} */
    constructor(source = {}) {
        super();
        /**
          Region of interest.
          */
        this.roi = { x: 0, y: 0, width: 0, height: 0 };
        /**
          Load mode.
          
          Default is EAGER
          */
        this.loadMode = 'EAGER';
        if (source.roi !== undefined) {
            this.roi = { x: source.roi.x, y: source.roi.y, width: source.roi.width, height: source.roi.height };
        }
        if (source.loadMode !== undefined) {
            this.loadMode = source.loadMode;
        }
    }
}
/**
Options for saving image to a path.
*/
class SaveImageOptions extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<SaveImageOptions>`} */
    constructor(source = {}) {
        super();
        /**
          Quality parameter is for jpeg only and is in range 0 to 100. If -1, then settings from hibernation are used.
          In case when the Image Ref was created with a lazy load mode and originally has the same format as the requested to save,
          then setting quality to -1 leads to simply copying from source to destination,
          which is time efficient and prevents quality loss caused by jpeg encoding/decoding.
          
          Default is -1
          */
        this.quality = -1;
        /**
          Encryption mode.
          
          Default is IF_AVAILABLE
          */
        this.encryptionMode = 'IF_AVAILABLE';
        if (source.quality !== undefined) {
            this.quality = source.quality;
        }
        if (source.encryptionMode !== undefined) {
            this.encryptionMode = source.encryptionMode;
        }
    }
}
/**
Options for encoding image.
*/
class EncodeImageOptions extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<EncodeImageOptions>`} */
    constructor(source = {}) {
        super();
        /**
          Quality parameter is for jpeg only and is in range 0 to 100. If -1, then settings from hibernation are used.
          In case when the Image Ref was created with a lazy load mode and originally has the same format as the requested to save,
          then setting quality to -1 leads to simply copying from source to destination,
          which is time efficient and prevents quality loss caused by jpeg encoding/decoding.
          
          Default is -1
          */
        this.quality = -1;
        /**
          Image format.
          
          Default is JPEG
          */
        this.format = 'JPEG';
        if (source.quality !== undefined) {
            this.quality = source.quality;
        }
        if (source.format !== undefined) {
            this.format = source.format;
        }
    }
}
const ImageSourceTypeValues = ['API', 'PLATFORM_IMAGE', 'CAMERA', 'FILE', 'BUFFER', 'OTHER'];
/**
Description of source from which the ImageRef was created.
*/
class ImageSource extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ImageSource>`} */
    constructor(source = {}) {
        super();
        if (source.type !== undefined) {
            this.type = source.type;
        }
        else {
            throw new Error('type must be present in constructor argument');
        }
        if (source.filePath !== undefined) {
            this.filePath = source.filePath != null ? source.filePath : null;
        }
        else {
            throw new Error('filePath must be present in constructor argument');
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            type: this.type,
            filePath: this.filePath != null ? this.filePath : null,
        };
    }
}
/**
ImageRef profile part specific to image information.
*/
class ImageProfile extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ImageProfile>`} */
    constructor(source = {}) {
        super();
        /**
          Memory consumption of a memory-backed bitmap. Zero, if the image is hibernating.
          
          Default is 0
          */
        this.bitmapMemoryConsumption = 0;
        /**
          Memory consumption of the hibernation buffer. Zero, if the image is not hibernating, or is hibernated to a file.
          
          Default is 0
          */
        this.hibernationMemoryConsumption = 0;
        if (source.bitmapMemoryConsumption !== undefined) {
            this.bitmapMemoryConsumption = source.bitmapMemoryConsumption;
        }
        if (source.hibernationMemoryConsumption !== undefined) {
            this.hibernationMemoryConsumption = source.hibernationMemoryConsumption;
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            bitmapMemoryConsumption: this.bitmapMemoryConsumption,
            hibernationMemoryConsumption: this.hibernationMemoryConsumption,
        };
    }
}
/**
ImageRef profile which provides detailed information about stored object.
*/
class ImageRefProfile extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ImageRefProfile>`} */
    constructor(source = {}) {
        super();
        if (source.refInfo !== undefined) {
            this.refInfo = new RefCountedObjectProfile(source.refInfo);
        }
        else {
            throw new Error('refInfo must be present in constructor argument');
        }
        if (source.imageInfo !== undefined) {
            this.imageInfo = new ImageProfile(source.imageInfo);
        }
        else {
            throw new Error('imageInfo must be present in constructor argument');
        }
        if (source.imageSource !== undefined) {
            this.imageSource = source.imageSource != null ? new ImageSource(source.imageSource) : null;
        }
        else {
            throw new Error('imageSource must be present in constructor argument');
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            refInfo: this.refInfo.serialize(config),
            imageInfo: this.imageInfo.serialize(config),
            imageSource: this.imageSource != null ? this.imageSource.serialize(config) : null,
        };
    }
}
/**
Snapshot of all alive ImageRefs.
*/
class ImageRefPoolSnapshot extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ImageRefPoolSnapshot>`} */
    constructor(source = {}) {
        super();
        /**
          Estimation of total memory consumption of ImageRefs.
          
          Default is 0
          */
        this.totalMemoryConsumption = 0;
        if (source.imageRefProfiles !== undefined) {
            this.imageRefProfiles = source.imageRefProfiles.map((it) => {
                return new ImageRefProfile(it);
            });
        }
        else {
            throw new Error('imageRefProfiles must be present in constructor argument');
        }
        if (source.totalMemoryConsumption !== undefined) {
            this.totalMemoryConsumption = source.totalMemoryConsumption;
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            imageRefProfiles: this.imageRefProfiles.map((it) => {
                return it.serialize(config);
            }),
            totalMemoryConsumption: this.totalMemoryConsumption,
        };
    }
}
/**
difference between two snapshots.
*/
class ImageRefPoolSnapshotsDiff extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ImageRefPoolSnapshotsDiff>`} */
    constructor(source = {}) {
        super();
        /**
          Difference between total memory consumption in two snapshots.
          
          Default is 0
          */
        this.totalMemoryConsumptionDiff = 0;
        if (source.totalMemoryConsumptionDiff !== undefined) {
            this.totalMemoryConsumptionDiff = source.totalMemoryConsumptionDiff;
        }
        if (source.removed !== undefined) {
            this.removed = source.removed.map((it) => {
                return it;
            });
        }
        else {
            throw new Error('removed must be present in constructor argument');
        }
        if (source.added !== undefined) {
            this.added = source.added.map((it) => {
                return it;
            });
        }
        else {
            throw new Error('added must be present in constructor argument');
        }
        if (source.modified !== undefined) {
            this.modified = source.modified.map((it) => {
                return it;
            });
        }
        else {
            throw new Error('modified must be present in constructor argument');
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            totalMemoryConsumptionDiff: this.totalMemoryConsumptionDiff,
            removed: this.removed.map((it) => {
                return it;
            }),
            added: this.added.map((it) => {
                return it;
            }),
            modified: this.modified.map((it) => {
                return it;
            }),
        };
    }
}

class AutoReleasePool {
    constructor() {
        this.poolObjects = [];
    }
    releaseAll() {
        for (const obj of this.poolObjects) {
            if (!obj.isRetained()) {
                obj.release();
            }
        }
    }
    addObject(obj) {
        this.poolObjects.push(obj);
    }
}
AutoReleasePool.globalPull = null;
AutoReleasePool.globalPullReferences = 0;
async function autorelease(computation) {
    if (AutoReleasePool.globalPull === null) {
        AutoReleasePool.globalPull = new AutoReleasePool();
    }
    AutoReleasePool.globalPullReferences++;
    const releasePoolRef = () => {
        AutoReleasePool.globalPullReferences--;
        if (AutoReleasePool.globalPullReferences === 0) {
            AutoReleasePool.globalPull.releaseAll();
            AutoReleasePool.globalPull = null;
        }
    };
    try {
        return await computation();
    }
    finally {
        releasePoolRef();
    }
}
class AutoReleasable extends PartiallyConstructible {
    constructor(uniqueId) {
        super();
        this.retained = false;
        if (uniqueId) {
            if (AutoReleasePool.globalPull === null) {
                const errorMessage = 'Initializing an object that contains a ScanbotImage instance as REFERENCE must be wrapped inside an autorelease pool. For example:' +
                    '\n autorelease(()=>{' +
                    '\n  const barcodeItem = new BarcodeItem(source);' +
                    '\n });';
                throw new Error(errorMessage);
            }
            AutoReleasePool.globalPull.addObject(this);
        }
    }
    isRetained() {
        return this.retained;
    }
    retain() {
        this.retained = true;
    }
}
class ImageRef extends AutoReleasable {
    get buffer() {
        return this._buffer;
    }
    constructor(uniqueId, buffer) {
        super(uniqueId);
        this.released = false;
        this.uniqueId = uniqueId;
        this._buffer = buffer;
    }
    static From(source) {
        if (source.buffer) {
            return new ImageRef(undefined, source.buffer);
        }
        else {
            return ImageRef.deserialize(source);
        }
    }
    static deserialize(serializedRef) {
        if (!serializedRef.uniqueId) {
            throw new Error('uniqueId must be present in serializedRef argument');
        }
        // The promise is intentionally not awaited here
        ScanbotBarcodeSDKPlugin.imageRefDeserialize({
            uniqueId: serializedRef.uniqueId,
        })
            .catch((error) => {
            console.error(`Error while deserializing ImageRef with uniqueId ${serializedRef.uniqueId}: ${error}`);
        })
            .then((jsResultObject) => {
            const success = mapPlainResult(jsResultObject);
            if (!success) {
                console.error(`Unsuccessful deserialization of ImageRef with uniqueId ${serializedRef.uniqueId}`);
            }
        });
        return new ImageRef(serializedRef.uniqueId, undefined);
    }
    /**
     * Converts the Image Ref to Json representation
     */
    async serialize(imageSerializationMode) {
        if (imageSerializationMode === 'BUFFER') {
            const encodedImage = await this.encodeImage();
            if (encodedImage) {
                return { buffer: encodedImage };
            }
            else {
                return null;
            }
        }
        else {
            this.throwErrorIfUniqueIdIsMissing();
            this.throwErrorIfReleased();
            // The promise is intentionally not awaited here
            ScanbotBarcodeSDKPlugin.imageRefSerialize({ uniqueId: this.uniqueId })
                .catch((error) => {
                console.error(`Error while serializing ImageRef with uniqueId ${this.uniqueId}: ${error}`);
            })
                .then((jsResultObject) => {
                const success = mapPlainResult(jsResultObject);
                if (!success) {
                    console.error(`Unsuccessful serialization of ImageRef with uniqueId ${this.uniqueId}`);
                }
            });
            return { uniqueId: this.uniqueId };
        }
    }
    /**
     * Creates ImageRef with uniqueId from the file uri to an image.
     */
    static async fromImageFileUri(uri, options = new PathImageLoadOptions()) {
        try {
            const serializedImageRefUniqueId = await ScanbotBarcodeSDKPlugin.imageRefFromImageFileUri({
                uri: uri,
                options: options,
            }).then((jsResultObject) => mapPlainResult(jsResultObject));
            return ImageRef.deserialize({ uniqueId: serializedImageRefUniqueId });
        }
        catch (error) {
            console.error(error);
            return null;
        }
    }
    /**
     * Creates ImageRef with uniqueId from base64 encoded buffer, e.g. from jpeg.
     */
    static async fromEncodedBuffer(buffer, options = new BufferImageLoadOptions()) {
        try {
            const serializedImageRefUniqueId = await ScanbotBarcodeSDKPlugin.imageRefFromEncodedBuffer({
                buffer: buffer,
                options: options,
            }).then((jsResultObject) => mapPlainResult(jsResultObject));
            return ImageRef.deserialize({ uniqueId: serializedImageRefUniqueId });
        }
        catch (error) {
            console.error(error);
            return null;
        }
    }
    /**
     * Creates a deep copy of the image.
     * If uniqueId is not set or the image is already released, an exception will be thrown.
     */
    async clone() {
        this.throwErrorIfUniqueIdIsMissing();
        this.throwErrorIfReleased();
        try {
            const serializedImageRefUniqueId = await ScanbotBarcodeSDKPlugin.imageRefClone({
                uniqueId: this.uniqueId,
            }).then((jsResultObject) => mapPlainResult(jsResultObject));
            return ImageRef.deserialize({ uniqueId: serializedImageRefUniqueId });
        }
        catch (error) {
            console.error(error);
            return null;
        }
    }
    /**
     * Compresses ImageRef and stores it either on disk or in memory according to global settings.
     * If uniqueId is not set or the image is already released, an exception will be thrown.
     */
    async hibernate() {
        this.throwErrorIfUniqueIdIsMissing();
        this.throwErrorIfReleased();
        try {
            await ScanbotBarcodeSDKPlugin.imageRefHibernate({
                uniqueId: this.uniqueId,
            });
        }
        catch (error) {
            console.error(error);
        }
    }
    /**
     * Releases native resources stored by the ref.
     * If two different ImageRef objects have the same uniqueId both of them become cleared.
     * If uniqueId is not set or the image is already released, an exception will be thrown.
     */
    async clear() {
        this.throwErrorIfUniqueIdIsMissing();
        this.throwErrorIfReleased();
        try {
            await ScanbotBarcodeSDKPlugin.imageRefClear({ uniqueId: this.uniqueId });
        }
        catch (error) {
            console.error(error);
        }
    }
    /**
     * Information about stored image as reference.
     * If uniqueId is not set or the image is already released, an exception will be thrown.
     */
    async info() {
        this.throwErrorIfUniqueIdIsMissing();
        this.throwErrorIfReleased();
        try {
            const imageInfo = await ScanbotBarcodeSDKPlugin.imageRefInfo({
                uniqueId: this.uniqueId,
            });
            return new ImageInfo(imageInfo);
        }
        catch (error) {
            console.error(error);
            return null;
        }
    }
    /**
     * Saves the stored image with the given options.
     * If uniqueId is not set or the image is already released, an exception will be thrown.
     */
    async saveImage(path, options = new SaveImageOptions()) {
        this.throwErrorIfUniqueIdIsMissing();
        this.throwErrorIfReleased();
        try {
            return await ScanbotBarcodeSDKPlugin.imageRefSaveImage({
                uniqueId: this.uniqueId,
                path: path,
                options: options,
            }).then((jsResultObject) => mapPlainResult(jsResultObject));
        }
        catch (error) {
            console.error(error);
            return false;
        }
    }
    /**
     * Encode image.
     */
    async encodeInPlace() {
        if (this._buffer) ;
        else {
            this.throwErrorIfUniqueIdIsMissing();
            this.throwErrorIfReleased();
            try {
                const imageAsBuffer = await ScanbotBarcodeSDKPlugin.imageRefEncodeImage({
                    uniqueId: this.uniqueId,
                    options: new EncodeImageOptions(),
                }).then((jsResultObject) => mapPlainResult(jsResultObject));
                if (imageAsBuffer) {
                    this._buffer = imageAsBuffer;
                }
            }
            catch (error) {
                console.error(error);
            }
        }
    }
    /**
     * Returns the stored image as base64.
     */
    async encodeImage(options) {
        if (this._buffer) {
            if (options) {
                throw new Error('EncodeImageOptions are not available when image is already encoded to base64');
            }
            return this._buffer;
        }
        else {
            this.throwErrorIfUniqueIdIsMissing();
            this.throwErrorIfReleased();
            try {
                return await ScanbotBarcodeSDKPlugin.imageRefEncodeImage({
                    uniqueId: this.uniqueId,
                    options: options !== null && options !== void 0 ? options : new EncodeImageOptions(),
                }).then((jsResultObject) => mapPlainResult(jsResultObject));
            }
            catch (error) {
                console.error(error);
                return null;
            }
        }
    }
    /**
     * Releases strong reference to the image.
     * If uniqueId to the image is not set, an exception will be thrown.
     */
    release() {
        this.throwErrorIfUniqueIdIsMissing();
        if (!this.released) {
            // The promise is intentionally not awaited here
            ScanbotBarcodeSDKPlugin.imageRefRelease({
                uniqueId: this.uniqueId,
            }).catch((error) => {
                console.error(`Error while releasing ImageRef with uniqueId ${this.uniqueId}: ${error}`);
            });
            this.released = true;
        }
    }
    /**
     * Returns a snapshot of all alive ImageRefs.
     * The snapshot contains a list of ImageRefs with information such as in-memory size.
     */
    static async makeSnapshot() {
        try {
            const snapshot = await ScanbotBarcodeSDKPlugin.makeSnapshot();
            return new ImageRefPoolSnapshot(snapshot);
        }
        catch (error) {
            console.error(error);
            return null;
        }
    }
    /**
     * Releases all alive images despite any existing references.
     */
    static releaseAll() {
        // The promise is intentionally not awaited here
        ScanbotBarcodeSDKPlugin.imageRefReleaseAll().catch(() => { });
    }
    throwErrorIfUniqueIdIsMissing() {
        if (!this.uniqueId) {
            throw new Error('uniqueId is missing');
        }
    }
    throwErrorIfReleased() {
        if (this.released) {
            throw new Error(`ImageRef with uniqueId ${this.uniqueId} has been released`);
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from core/schemas/GenericDocument.yaml
/**
Result of OCR text recognition.
*/
class OcrResult extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<OcrResult>`} */
    constructor(source = {}) {
        super();
        if (source.text !== undefined) {
            this.text = source.text;
        }
        else {
            throw new Error('text must be present in constructor argument');
        }
        if (source.confidence !== undefined) {
            this.confidence = source.confidence;
        }
        else {
            throw new Error('confidence must be present in constructor argument');
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            text: this.text,
            confidence: this.confidence,
        };
    }
}
const FieldValidationStatusValues = [
    'INVALID',
    'NONE',
    'CONFIRMED',
    'INFERRED',
    'VALID',
    'IGNORED',
];
const FieldDataFormatValues = [
    'ISO_DATE',
    'ISO_COUNTRY_ALPHA_2',
    'ISO_COUNTRY_ALPHA_3',
    'ISO_COUNTRY_NUMERIC',
    'ISO_COUNTRY_NAME',
    'GENDER',
];
/**
Parsed data.
*/
class FieldParsedData extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<FieldParsedData>`} */
    constructor(source = {}) {
        super();
        if (source.type !== undefined) {
            this.type = source.type;
        }
        else {
            throw new Error('type must be present in constructor argument');
        }
        if (source.value !== undefined) {
            this.value = source.value;
        }
        else {
            throw new Error('value must be present in constructor argument');
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            type: this.type,
            value: this.value,
        };
    }
}
/**
Generic Document Type.
*/
class FieldType extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<FieldType>`} */
    constructor(source = {}) {
        super();
        /**
          A document can contain multiple fields of the same name, the property serves for storing natural order of such fields, null if multiple entries aren't allowed for this field.
          */
        this.listIndex = null;
        if (source.name !== undefined) {
            this.name = source.name;
        }
        else {
            throw new Error('name must be present in constructor argument');
        }
        if (source.fullName !== undefined) {
            this.fullName = source.fullName;
        }
        else {
            throw new Error('fullName must be present in constructor argument');
        }
        if (source.normalizedName !== undefined) {
            this.normalizedName = source.normalizedName;
        }
        else {
            throw new Error('normalizedName must be present in constructor argument');
        }
        if (source.commonType !== undefined) {
            this.commonType =
                source.commonType != null
                    ? CommonFieldTypeValues.includes(source.commonType)
                        ? source.commonType
                        : null
                    : null;
        }
        else {
            throw new Error('commonType must be present in constructor argument');
        }
        if (source.listIndex !== undefined) {
            this.listIndex = source.listIndex != null ? source.listIndex : null;
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            name: this.name,
            fullName: this.fullName,
            normalizedName: this.normalizedName,
            commonType: this.commonType != null ? this.commonType : null,
            listIndex: this.listIndex != null ? this.listIndex : null,
        };
    }
}
/**
Generic document field.
*/
class Field extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<Field>`} */
    constructor(source = {}) {
        super();
        /**
          Confidence weight.
          
          Default is 1.0
          */
        this.confidenceWeight = 1.0;
        /**
          Crop of the field.
          */
        this.image = null;
        /**
          Field validation status. Applicable only to fields that support some kind of validation.
          
          Default is NONE
          */
        this.validationStatus = 'NONE';
        /**
          Parsed data.
          */
        this.parsedData = [];
        this._released = false;
        if (source.type !== undefined) {
            this.type = new FieldType(source.type);
        }
        else {
            throw new Error('type must be present in constructor argument');
        }
        if (source.value !== undefined) {
            this.value = source.value != null ? new OcrResult(source.value) : null;
        }
        else {
            throw new Error('value must be present in constructor argument');
        }
        if (source.confidenceWeight !== undefined) {
            this.confidenceWeight = source.confidenceWeight;
        }
        if (source.image !== undefined) {
            this.image = source.image != null ? ImageRef.From(source.image) : null;
        }
        if (source.polygonInRoot !== undefined) {
            this.polygonInRoot = source.polygonInRoot.map((it) => {
                return { x: it.x, y: it.y };
            });
        }
        else {
            throw new Error('polygonInRoot must be present in constructor argument');
        }
        if (source.validationStatus !== undefined) {
            this.validationStatus = source.validationStatus;
        }
        if (source.parsedData !== undefined) {
            this.parsedData = source.parsedData.map((it) => {
                return new FieldParsedData(it);
            });
        }
    }
    async serialize(config = new ToJsonConfiguration()) {
        return {
            type: this.type.serialize(config),
            value: this.value != null ? this.value.serialize(config) : null,
            confidenceWeight: this.confidenceWeight,
            image: config.serializeImages
                ? this.image != null
                    ? await this.image.serialize(config.imageSerializationMode)
                    : null
                : undefined,
            polygonInRoot: this.polygonInRoot.map((it) => {
                return it;
            }),
            validationStatus: this.validationStatus,
            parsedData: this.parsedData.map((it) => {
                return it.serialize(config);
            }),
        };
    }
    release() {
        if (this._released) {
            return;
        }
        {
            if (this.image != null) {
                this.image.release();
            }
        }
        this._released = true;
    }
    async encodeImages() {
        if (this.image != null) {
            await this.image.encodeInPlace();
        }
    }
}
/**
Generic Document Type.
*/
class GenericDocumentType extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<GenericDocumentType>`} */
    constructor(source = {}) {
        super();
        /**
          A document can contain multiple fields of the same name, the property serves for storing natural order of such fields, null if multiple entries aren't allowed for this field.
          */
        this.listIndex = null;
        if (source.name !== undefined) {
            this.name = source.name;
        }
        else {
            throw new Error('name must be present in constructor argument');
        }
        if (source.fullName !== undefined) {
            this.fullName = source.fullName;
        }
        else {
            throw new Error('fullName must be present in constructor argument');
        }
        if (source.normalizedName !== undefined) {
            this.normalizedName = source.normalizedName;
        }
        else {
            throw new Error('normalizedName must be present in constructor argument');
        }
        if (source.listIndex !== undefined) {
            this.listIndex = source.listIndex != null ? source.listIndex : null;
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            name: this.name,
            fullName: this.fullName,
            normalizedName: this.normalizedName,
            listIndex: this.listIndex != null ? this.listIndex : null,
        };
    }
}
/**
Generic document.
*/
class GenericDocument extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<GenericDocument>`} */
    constructor(source = {}) {
        super();
        /**
          Image crop of the document.
          */
        this.crop = null;
        /**
          The average confidence in the accuracy of the document recognition result.
          
          Default is 0
          */
        this.confidence = 0.0;
        /**
          The weight of the confidence. Can be used to calculate the weighted average confidence of two documents.
          
          Default is 0
          */
        this.confidenceWeight = 0.0;
        this._released = false;
        if (source.type !== undefined) {
            this.type = new GenericDocumentType(source.type);
        }
        else {
            throw new Error('type must be present in constructor argument');
        }
        if (source.fields !== undefined) {
            this.fields = source.fields.map((it) => {
                return new Field(it);
            });
        }
        else {
            throw new Error('fields must be present in constructor argument');
        }
        if (source.children !== undefined) {
            this.children = source.children.map((it) => {
                return new GenericDocument(it);
            });
        }
        else {
            throw new Error('children must be present in constructor argument');
        }
        if (source.quad !== undefined) {
            this.quad = source.quad.map((it) => {
                return { x: it.x, y: it.y };
            });
        }
        else {
            throw new Error('quad must be present in constructor argument');
        }
        if (source.quadInRoot !== undefined) {
            this.quadInRoot = source.quadInRoot.map((it) => {
                return { x: it.x, y: it.y };
            });
        }
        else {
            throw new Error('quadInRoot must be present in constructor argument');
        }
        if (source.crop !== undefined) {
            this.crop = source.crop != null ? ImageRef.From(source.crop) : null;
        }
        if (source.confidence !== undefined) {
            this.confidence = source.confidence;
        }
        if (source.confidenceWeight !== undefined) {
            this.confidenceWeight = source.confidenceWeight;
        }
    }
    async serialize(config = new ToJsonConfiguration()) {
        return {
            type: this.type.serialize(config),
            fields: await Promise.all(this.fields.map(async (it) => {
                return await it.serialize(config);
            })),
            children: await Promise.all(this.children.map(async (it) => {
                return await it.serialize(config);
            })),
            quad: this.quad.map((it) => {
                return it;
            }),
            quadInRoot: this.quadInRoot.map((it) => {
                return it;
            }),
            crop: config.serializeImages
                ? this.crop != null
                    ? await this.crop.serialize(config.imageSerializationMode)
                    : null
                : undefined,
            confidence: this.confidence,
            confidenceWeight: this.confidenceWeight,
        };
    }
    release() {
        if (this._released) {
            return;
        }
        this.fields.forEach((it) => {
            it.release();
        });
        this.children.forEach((it) => {
            it.release();
        });
        {
            if (this.crop != null) {
                this.crop.release();
            }
        }
        this._released = true;
    }
    async encodeImages() {
        await Promise.all(this.fields.map(async (it) => {
            await it.encodeImages();
        }));
        await Promise.all(this.children.map(async (it) => {
            await it.encodeImages();
        }));
        if (this.crop != null) {
            await this.crop.encodeInPlace();
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from core/schemas/BarcodeScannerTypes.yaml
/**
A single barcode found in the input image. Barcodes with the same content but different locations in the image are considered separate barcodes.
*/
class BarcodeItem extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeItem>`} */
    constructor(source = {}) {
        super();
        /**
          Barcode format.
          
          Default is NONE
          */
        this.format = 'NONE';
        /**
          True if this is a 1D barcode that is printed upside-down, that is, the barcode was scanned right-to-left.
          
          Default is false
          */
        this.isUpsideDown = false;
        /**
          A crop from the input image containing the barcode.
          */
        this.sourceImage = null;
        /**
          True if the barcode contains a GS1 message. Requires GS1 handling to be enabled in the decoding option.
          
          Default is false
          */
        this.isGS1Message = false;
        /**
          True if this result is the 2D part of a GS1 Composite barcode.
          Can only happen if GS1_COMPOSITE scanning is disabled and a part of the composite (1D) or (2D) is scanned separately.
          When GS1_COMPOSITE scanning is enabled, parts of the composite barcode are never returned separately, even if their respective
          format is enabled in the decoding options.
          
          Default is false
          */
        this.isGS1CompositePart = false;
        /**
          The number of 1D stacks in the barcode. Applies only to DATABAR and DATABAR_EXPANDED barcodes.
          
          Default is 1
          */
        this.dataBarStackSize = 1;
        /**
          The size score is a floating point value between 0 and 1 that represents the relative size of the barcode in the input image.
          Barcodes taking up a small portion of the input image will have a score close to 0, while barcodes that take a large portion will have a score close to 1.
          
          Default is 0
          */
        this.sizeScore = 0.0;
        this._released = false;
        if (source.text !== undefined) {
            this.text = source.text;
        }
        else {
            throw new Error('text must be present in constructor argument');
        }
        if (source.format !== undefined) {
            this.format = source.format;
        }
        if (source.quad !== undefined) {
            this.quad = source.quad.map((it) => {
                return { x: it.x, y: it.y };
            });
        }
        else {
            throw new Error('quad must be present in constructor argument');
        }
        if (source.quadNormalized !== undefined) {
            this.quadNormalized = source.quadNormalized.map((it) => {
                return { x: it.x, y: it.y };
            });
        }
        else {
            throw new Error('quadNormalized must be present in constructor argument');
        }
        if (source.isUpsideDown !== undefined) {
            this.isUpsideDown = source.isUpsideDown;
        }
        if (source.sourceImage !== undefined) {
            this.sourceImage = source.sourceImage != null ? ImageRef.From(source.sourceImage) : null;
        }
        if (source.rawBytes !== undefined) {
            this.rawBytes = source.rawBytes;
        }
        else {
            throw new Error('rawBytes must be present in constructor argument');
        }
        if (source.upcEanExtension !== undefined) {
            this.upcEanExtension = source.upcEanExtension;
        }
        else {
            throw new Error('upcEanExtension must be present in constructor argument');
        }
        if (source.isGS1Message !== undefined) {
            this.isGS1Message = source.isGS1Message;
        }
        if (source.isGS1CompositePart !== undefined) {
            this.isGS1CompositePart = source.isGS1CompositePart;
        }
        if (source.dataBarStackSize !== undefined) {
            this.dataBarStackSize = source.dataBarStackSize;
        }
        if (source.sizeScore !== undefined) {
            this.sizeScore = source.sizeScore;
        }
        if (source.extractedDocument !== undefined) {
            this.extractedDocument = source.extractedDocument != null ? new GenericDocument(source.extractedDocument) : null;
        }
        else {
            throw new Error('extractedDocument must be present in constructor argument');
        }
    }
    async serialize(config = new ToJsonConfiguration()) {
        return {
            text: this.text,
            format: this.format,
            quad: this.quad.map((it) => {
                return it;
            }),
            quadNormalized: this.quadNormalized.map((it) => {
                return it;
            }),
            isUpsideDown: this.isUpsideDown,
            sourceImage: config.serializeImages
                ? this.sourceImage != null
                    ? await this.sourceImage.serialize(config.imageSerializationMode)
                    : null
                : undefined,
            rawBytes: this.rawBytes,
            upcEanExtension: this.upcEanExtension,
            isGS1Message: this.isGS1Message,
            isGS1CompositePart: this.isGS1CompositePart,
            dataBarStackSize: this.dataBarStackSize,
            sizeScore: this.sizeScore,
            extractedDocument: this.extractedDocument != null ? await this.extractedDocument.serialize(config) : null,
        };
    }
    release() {
        if (this._released) {
            return;
        }
        {
            if (this.sourceImage != null) {
                this.sourceImage.release();
            }
        }
        {
            if (this.extractedDocument != null) {
                this.extractedDocument.release();
            }
        }
        this._released = true;
    }
    async encodeImages() {
        if (this.sourceImage != null) {
            await this.sourceImage.encodeInPlace();
        }
        if (this.extractedDocument != null) {
            await this.extractedDocument.encodeImages();
        }
    }
}
const BarcodeScannerEngineModeValues = [
    'LEGACY',
    'NEXT_GEN_LOW_POWER',
    'NEXT_GEN',
    'NEXT_GEN_LOW_POWER_FAR_DISTANCE',
    'NEXT_GEN_FAR_DISTANCE',
];
/**
Configuration for the barcode scanner.
*/
class BarcodeScannerConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeScannerConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Options for barcode decoding.
          */
        this.barcodeFormatConfigurations = [new BarcodeFormatCommonConfiguration({})];
        /**
          List of document formats to be extracted.
          Barcodes that decode to one of the extracted document formats will have extractedDocument field in BarcodeItem populated with the parsed document.
          By default all supported barcode document formats are accepted.
          If empty, no barcodes will be parsed into documents.
          To only accept the document formats listed in extractedDocumentFormats, the property onlyAcceptDocuments must be true.
          */
        this.extractedDocumentFormats = [
            'AAMVA',
            'BOARDING_PASS',
            'DE_MEDICAL_PLAN',
            'MEDICAL_CERTIFICATE',
            'ID_CARD_PDF_417',
            'SEPA',
            'SWISS_QR',
            'VCARD',
            'GS1',
            'HIBC',
        ];
        /**
          If true and extractedDocumentFormats is not empty, then barcodes that don't decode to one of the extracted document formats will be ignored.
          
          Default is false
          */
        this.onlyAcceptDocuments = false;
        /**
          If true, the barcode image will be returned in the BarcodeItem.
          
          Default is false
          */
        this.returnBarcodeImage = false;
        /**
          The engine mode for barcode scanning.
          
          Default is NEXT_GEN
          */
        this.engineMode = 'NEXT_GEN';
        /**
          If true, the quads of linear (1D) barcodes will be further refined to more closely match the barcode's outline in the input image.
          This will also produce stabler barcode outlines across frames for use cases such as AR.
          
          Default is false
          */
        this.optimizedForOverlays = false;
        if (source.barcodeFormatConfigurations !== undefined) {
            this.barcodeFormatConfigurations = source.barcodeFormatConfigurations.map((it) => {
                return exports.BarcodeFormatConfigurationBase.From(it);
            });
        }
        if (source.extractedDocumentFormats !== undefined) {
            this.extractedDocumentFormats = source.extractedDocumentFormats.map((it) => {
                return it;
            });
        }
        if (source.onlyAcceptDocuments !== undefined) {
            this.onlyAcceptDocuments = source.onlyAcceptDocuments;
        }
        if (source.returnBarcodeImage !== undefined) {
            this.returnBarcodeImage = source.returnBarcodeImage;
        }
        if (source.engineMode !== undefined) {
            this.engineMode = source.engineMode;
        }
        if (source.optimizedForOverlays !== undefined) {
            this.optimizedForOverlays = source.optimizedForOverlays;
        }
    }
}
/**
The result of barcode scanning.
*/
class BarcodeScannerResult extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeScannerResult>`} */
    constructor(source = {}) {
        super();
        this._released = false;
        if (source.barcodes !== undefined) {
            this.barcodes = source.barcodes.map((it) => {
                return new BarcodeItem(it);
            });
        }
        else {
            throw new Error('barcodes must be present in constructor argument');
        }
        if (source.success !== undefined) {
            this.success = source.success;
        }
        else {
            throw new Error('success must be present in constructor argument');
        }
    }
    async serialize(config = new ToJsonConfiguration()) {
        return {
            barcodes: await Promise.all(this.barcodes.map(async (it) => {
                return await it.serialize(config);
            })),
            success: this.success,
        };
    }
    release() {
        if (this._released) {
            return;
        }
        this.barcodes.forEach((it) => {
            it.release();
        });
        this._released = true;
    }
    async encodeImages() {
        await Promise.all(this.barcodes.map(async (it) => {
            await it.encodeImages();
        }));
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/common/Common.yaml
/**
Value palette describing the colors of the scanner screens.
*/
class Palette extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<Palette>`} */
    constructor(source = {}) {
        super();
        /**
          The primary color used for enabled elements.
          
          Default is "#C8193C"
          */
        this.sbColorPrimary = '#C8193C';
        /**
          The primary color used for disabled elements.
          
          Default is "#F5F5F5"
          */
        this.sbColorPrimaryDisabled = '#F5F5F5';
        /**
          The color used to convey a negative meaning.
          
          Default is "#FF3737"
          */
        this.sbColorNegative = '#FF3737';
        /**
          The color used to convey a positive meaning.
          
          Default is "#4EFFB4"
          */
        this.sbColorPositive = '#4EFFB4';
        /**
          The color used to convey warnings.
          
          Default is "#FFCE5C"
          */
        this.sbColorWarning = '#FFCE5C';
        /**
          The secondary color used for enabled elements.
          
          Default is "#FFEDEE"
          */
        this.sbColorSecondary = '#FFEDEE';
        /**
          The secondary color used for disabled elements.
          
          Default is "#F5F5F5"
          */
        this.sbColorSecondaryDisabled = '#F5F5F5';
        /**
          The color used for displaying elements on top of the primary color.
          
          Default is "#FFFFFF"
          */
        this.sbColorOnPrimary = '#FFFFFF';
        /**
          The color used for displaying elements on top of the secondary color.
          
          Default is "#C8193C"
          */
        this.sbColorOnSecondary = '#C8193C';
        /**
          The color used for surfaces.
          
          Default is "#FFFFFF"
          */
        this.sbColorSurface = '#FFFFFF';
        /**
          The color used for outlines.
          
          Default is "#EFEFEF"
          */
        this.sbColorOutline = '#EFEFEF';
        /**
          The alternative color used on top of surfaces.
          
          Default is "#707070"
          */
        this.sbColorOnSurfaceVariant = '#707070';
        /**
          The color used on top of surfaces.
          
          Default is "#000000"
          */
        this.sbColorOnSurface = '#000000';
        /**
          The color with a low alpha (transparency) value used for certain surfaces.
          
          Default is "#00000026"
          */
        this.sbColorSurfaceLow = '#00000026';
        /**
          The color with a high alpha (transparency) value used for certain surfaces.
          
          Default is "#0000007A"
          */
        this.sbColorSurfaceHigh = '#0000007A';
        /**
          The color with a very high alpha (transparency) value used to fill certain overlays.
          
          Default is "#000000A3"
          */
        this.sbColorModalOverlay = '#000000A3';
        if (source.sbColorPrimary !== undefined) {
            this.sbColorPrimary = source.sbColorPrimary;
        }
        if (source.sbColorPrimaryDisabled !== undefined) {
            this.sbColorPrimaryDisabled = source.sbColorPrimaryDisabled;
        }
        if (source.sbColorNegative !== undefined) {
            this.sbColorNegative = source.sbColorNegative;
        }
        if (source.sbColorPositive !== undefined) {
            this.sbColorPositive = source.sbColorPositive;
        }
        if (source.sbColorWarning !== undefined) {
            this.sbColorWarning = source.sbColorWarning;
        }
        if (source.sbColorSecondary !== undefined) {
            this.sbColorSecondary = source.sbColorSecondary;
        }
        if (source.sbColorSecondaryDisabled !== undefined) {
            this.sbColorSecondaryDisabled = source.sbColorSecondaryDisabled;
        }
        if (source.sbColorOnPrimary !== undefined) {
            this.sbColorOnPrimary = source.sbColorOnPrimary;
        }
        if (source.sbColorOnSecondary !== undefined) {
            this.sbColorOnSecondary = source.sbColorOnSecondary;
        }
        if (source.sbColorSurface !== undefined) {
            this.sbColorSurface = source.sbColorSurface;
        }
        if (source.sbColorOutline !== undefined) {
            this.sbColorOutline = source.sbColorOutline;
        }
        if (source.sbColorOnSurfaceVariant !== undefined) {
            this.sbColorOnSurfaceVariant = source.sbColorOnSurfaceVariant;
        }
        if (source.sbColorOnSurface !== undefined) {
            this.sbColorOnSurface = source.sbColorOnSurface;
        }
        if (source.sbColorSurfaceLow !== undefined) {
            this.sbColorSurfaceLow = source.sbColorSurfaceLow;
        }
        if (source.sbColorSurfaceHigh !== undefined) {
            this.sbColorSurfaceHigh = source.sbColorSurfaceHigh;
        }
        if (source.sbColorModalOverlay !== undefined) {
            this.sbColorModalOverlay = source.sbColorModalOverlay;
        }
    }
}
/**
Configuration of the text field appearance.
*/
class StyledText extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<StyledText>`} */
    constructor(source = {}) {
        super();
        /**
          Determines whether the text field is visible or not.
          
          Default is true
          */
        this.visible = true;
        /**
          The value of the text field.
          
          Default is ""
          */
        this.text = '';
        /**
          The text color.
          
          Default is "#FFFFFF"
          */
        this.color = '#FFFFFF';
        /**
          Determines whether to enable drop shadows for the text.
          
          Default is false
          */
        this.useShadow = false;
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.text !== undefined) {
            this.text = source.text;
        }
        if (source.color !== undefined) {
            this.color = source.color;
        }
        if (source.useShadow !== undefined) {
            this.useShadow = source.useShadow;
        }
    }
}
/**
Configuration of the icon appearance.
*/
class IconStyle extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<IconStyle>`} */
    constructor(source = {}) {
        super();
        /**
          Determines whether the icon is visible or not.
          
          Default is true
          */
        this.visible = true;
        /**
          The icon color.
          
          Default is "#FFFFFF"
          */
        this.color = '#FFFFFF';
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.color !== undefined) {
            this.color = source.color;
        }
    }
}
/**
Configuration of the icon appearance on a button.
*/
class IconButton extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<IconButton>`} */
    constructor(source = {}) {
        super();
        /**
          Determines whether the icon is visible on the button.
          
          Default is true
          */
        this.visible = true;
        /**
          The icon color.
          
          Default is "#FFFFFF"
          */
        this.color = '#FFFFFF';
        /**
          The text to be read when the button is selected through accessibility mode.
          
          Default is ""
          */
        this.accessibilityDescription = '';
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.color !== undefined) {
            this.color = source.color;
        }
        if (source.accessibilityDescription !== undefined) {
            this.accessibilityDescription = source.accessibilityDescription;
        }
    }
}
/**
Configuration of the polygon appearance.
*/
class PolygonStyle extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<PolygonStyle>`} */
    constructor(source = {}) {
        super();
        /**
          The color of the polygon outline.
          
          Default is "#FFFFFFFF"
          */
        this.strokeColor = '#FFFFFFFF';
        /**
          The fill color of the polygon.
          
          Default is "#FFFFFF30"
          */
        this.fillColor = '#FFFFFF30';
        /**
          The width of the polygon outline in dp.
          
          Default is 2.0
          */
        this.strokeWidth = 2.0;
        /**
          The corner radius of the polygon in dp.
          
          Default is 0.0
          */
        this.cornerRadius = 0.0;
        if (source.strokeColor !== undefined) {
            this.strokeColor = source.strokeColor;
        }
        if (source.fillColor !== undefined) {
            this.fillColor = source.fillColor;
        }
        if (source.strokeWidth !== undefined) {
            this.strokeWidth = source.strokeWidth;
        }
        if (source.cornerRadius !== undefined) {
            this.cornerRadius = source.cornerRadius;
        }
    }
}
/**
Configuration of the background appearance for buttons and hints.
*/
class BackgroundStyle extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BackgroundStyle>`} */
    constructor(source = {}) {
        super();
        /**
          The color of the outline.
          
          Default is "#FFFFFFFF"
          */
        this.strokeColor = '#FFFFFFFF';
        /**
          The fill color.
          
          Default is "#FFFFFF30"
          */
        this.fillColor = '#FFFFFF30';
        /**
          The width of the outline in dp.
          
          Default is 2.0
          */
        this.strokeWidth = 2.0;
        if (source.strokeColor !== undefined) {
            this.strokeColor = source.strokeColor;
        }
        if (source.fillColor !== undefined) {
            this.fillColor = source.fillColor;
        }
        if (source.strokeWidth !== undefined) {
            this.strokeWidth = source.strokeWidth;
        }
    }
}
/**
Configuration of the appearance for foreground elements (e.g. text and/or icons, etc).
*/
class ForegroundStyle extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ForegroundStyle>`} */
    constructor(source = {}) {
        super();
        /**
          Determines whether the icon is visible or not.
          
          Default is true
          */
        this.iconVisible = true;
        /**
          The color used for foreground elements.
          
          Default is "#FFFFFF"
          */
        this.color = '#FFFFFF';
        /**
          Determines whether to use drop shadows for foreground elements.
          
          Default is false
          */
        this.useShadow = false;
        if (source.iconVisible !== undefined) {
            this.iconVisible = source.iconVisible;
        }
        if (source.color !== undefined) {
            this.color = source.color;
        }
        if (source.useShadow !== undefined) {
            this.useShadow = source.useShadow;
        }
    }
}
/**
Configuration of the badge.
*/
class BadgeStyle extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BadgeStyle>`} */
    constructor(source = {}) {
        super();
        /**
          Determines whether the badge is visible or not.
          
          Default is true
          */
        this.visible = true;
        /**
          Configuration of the background appearance for the badge.
          */
        this.background = new BackgroundStyle({});
        /**
          The color of the badge's foreground (icon, text).
          
          Default is "?sbColorOnSurface"
          */
        this.foregroundColor = '?sbColorOnSurface';
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.background !== undefined) {
            this.background = new BackgroundStyle(source.background);
        }
        if (source.foregroundColor !== undefined) {
            this.foregroundColor = source.foregroundColor;
        }
    }
}
/**
Configuration of the round button.
*/
class RoundButton extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<RoundButton>`} */
    constructor(source = {}) {
        super();
        /**
          Determines whether the button is visible or not.
          
          Default is true
          */
        this.visible = true;
        /**
          The text to be read when the button is selected through accessibility mode.
          
          Default is ""
          */
        this.accessibilityDescription = '';
        /**
          The color of the button's background.
          
          Default is "#0000007A"
          */
        this.backgroundColor = '#0000007A';
        /**
          The color of the button's foreground (icon, text).
          
          Default is "#FFFFFF"
          */
        this.foregroundColor = '#FFFFFF';
        /**
          The color of the button's background when the button is active (selected, toggled).
          
          Default is "#FFCE5C"
          */
        this.activeBackgroundColor = '#FFCE5C';
        /**
          The color of the button's foreground (icon, text) when the button is active (selected, toggled).
          
          Default is "#1C1B1F"
          */
        this.activeForegroundColor = '#1C1B1F';
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.accessibilityDescription !== undefined) {
            this.accessibilityDescription = source.accessibilityDescription;
        }
        if (source.backgroundColor !== undefined) {
            this.backgroundColor = source.backgroundColor;
        }
        if (source.foregroundColor !== undefined) {
            this.foregroundColor = source.foregroundColor;
        }
        if (source.activeBackgroundColor !== undefined) {
            this.activeBackgroundColor = source.activeBackgroundColor;
        }
        if (source.activeForegroundColor !== undefined) {
            this.activeForegroundColor = source.activeForegroundColor;
        }
    }
}
/**
Configuration of the button with a badge.
*/
class BadgedButton extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BadgedButton>`} */
    constructor(source = {}) {
        super();
        /**
          The color of the badge's background.
          
          Default is "#FFFFFF"
          */
        this.badgeBackgroundColor = '#FFFFFF';
        /**
          The color of the badge's foreground (icon, text).
          
          Default is "#C8193C"
          */
        this.badgeForegroundColor = '#C8193C';
        /**
          Determines whether the button is visible or not.
          
          Default is true
          */
        this.visible = true;
        /**
          The color of the button's background.
          
          Default is "#0000007A"
          */
        this.backgroundColor = '#0000007A';
        /**
          The color of the button's foreground (icon, text).
          
          Default is "#FFFFFF"
          */
        this.foregroundColor = '#FFFFFF';
        /**
          The color of the button's background when the button is active (selected, toggled).
          
          Default is "#FFCE5C"
          */
        this.activeBackgroundColor = '#FFCE5C';
        /**
          The color of the button's foreground (icon, text) when the button is active (selected, toggled).
          
          Default is "#1C1B1F"
          */
        this.activeForegroundColor = '#1C1B1F';
        if (source.badgeBackgroundColor !== undefined) {
            this.badgeBackgroundColor = source.badgeBackgroundColor;
        }
        if (source.badgeForegroundColor !== undefined) {
            this.badgeForegroundColor = source.badgeForegroundColor;
        }
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.backgroundColor !== undefined) {
            this.backgroundColor = source.backgroundColor;
        }
        if (source.foregroundColor !== undefined) {
            this.foregroundColor = source.foregroundColor;
        }
        if (source.activeBackgroundColor !== undefined) {
            this.activeBackgroundColor = source.activeBackgroundColor;
        }
        if (source.activeForegroundColor !== undefined) {
            this.activeForegroundColor = source.activeForegroundColor;
        }
    }
}
/**
Configuration of the button.
*/
class ButtonConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ButtonConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Determines whether the button is visible or not.
          
          Default is true
          */
        this.visible = true;
        /**
          The text to be displayed on the button.
          
          Default is ""
          */
        this.text = '';
        /**
          The text to be read when the button is selected through accessibility mode.
          
          Default is ""
          */
        this.accessibilityDescription = '';
        /**
          Configuration of the background appearance for the button.
          */
        this.background = new BackgroundStyle({});
        /**
          Configuration of the appearance for foreground elements (e.g. text and/or icons, etc) of the button.
          */
        this.foreground = new ForegroundStyle({});
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.text !== undefined) {
            this.text = source.text;
        }
        if (source.accessibilityDescription !== undefined) {
            this.accessibilityDescription = source.accessibilityDescription;
        }
        if (source.background !== undefined) {
            this.background = new BackgroundStyle(source.background);
        }
        if (source.foreground !== undefined) {
            this.foreground = new ForegroundStyle(source.foreground);
        }
    }
}
/**
Configuration for the popup menu items.
*/
class PopupMenuItem extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<PopupMenuItem>`} */
    constructor(source = {}) {
        super();
        /**
          The text to be displayed on the button.
          */
        this.title = new StyledText({});
        /**
          The text to be read when the button is selected through accessibility mode.
          
          Default is ""
          */
        this.accessibilityDescription = '';
        /**
          Configuration of the icon appearance.
          */
        this.icon = new IconStyle({});
        if (source.title !== undefined) {
            this.title = new StyledText(source.title);
        }
        if (source.accessibilityDescription !== undefined) {
            this.accessibilityDescription = source.accessibilityDescription;
        }
        if (source.icon !== undefined) {
            this.icon = new IconStyle(source.icon);
        }
    }
}
/**
Configuration of the button located on a bar.
*/
class BarButtonConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarButtonConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Determines whether the button is visible or not.
          
          Default is true
          */
        this.visible = true;
        /**
          The text to be displayed on the button.
          */
        this.title = new StyledText({});
        /**
          The text to be read when the button is selected through accessibility mode.
          
          Default is ""
          */
        this.accessibilityDescription = '';
        /**
          Configuration of the background appearance for the button.
          */
        this.background = new BackgroundStyle({});
        /**
          Configuration of the icon appearance.
          */
        this.icon = new IconStyle({});
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.title !== undefined) {
            this.title = new StyledText(source.title);
        }
        if (source.accessibilityDescription !== undefined) {
            this.accessibilityDescription = source.accessibilityDescription;
        }
        if (source.background !== undefined) {
            this.background = new BackgroundStyle(source.background);
        }
        if (source.icon !== undefined) {
            this.icon = new IconStyle(source.icon);
        }
    }
}
const OrientationLockModeValues = ['NONE', 'PORTRAIT', 'LANDSCAPE'];
const CameraPreviewModeValues = ['FIT_IN', 'FILL_IN'];
const SoundTypeValues = ['MODERN_BEEP', 'CLASSIC_BEEP'];
/**
Configuration for the sound.
*/
class Sound extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<Sound>`} */
    constructor(source = {}) {
        super();
        /**
          Determine whether the beep sound should be enabled or not when a barcode is detected.
          
          Default is true
          */
        this.successBeepEnabled = true;
        /**
          Determines the successful detection sound.
          
          Default is MODERN_BEEP
          */
        this.soundType = 'MODERN_BEEP';
        if (source.successBeepEnabled !== undefined) {
            this.successBeepEnabled = source.successBeepEnabled;
        }
        if (source.soundType !== undefined) {
            this.soundType = source.soundType;
        }
    }
}
/**
Configure the vibration.
*/
class Vibration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<Vibration>`} */
    constructor(source = {}) {
        super();
        /**
          Determine whether vibration should be enabled or not when a barcode is detected.
          
          Default is false
          */
        this.enabled = false;
        if (source.enabled !== undefined) {
            this.enabled = source.enabled;
        }
    }
}
/**
Configuration of timeouts.
*/
class Timeouts extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<Timeouts>`} */
    constructor(source = {}) {
        super();
        /**
          Sets the length of time, in milliseconds, when the scanner should auto close. Default is 0 (disabled).
          
          Default is 0
          */
        this.autoCancelTimeout = 0;
        /**
          Sets the length of time, in milliseconds, that the first scan will be delayed by. Default is 0 (disabled).
          
          Default is 0
          */
        this.initialScanDelay = 0;
        if (source.autoCancelTimeout !== undefined) {
            this.autoCancelTimeout = source.autoCancelTimeout;
        }
        if (source.initialScanDelay !== undefined) {
            this.initialScanDelay = source.initialScanDelay;
        }
    }
}
/**
Represents the insets of a rectangle.
*/
class EdgeInsets extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<EdgeInsets>`} */
    constructor(source = {}) {
        super();
        /**
          The top inset.
          
          Default is 0.0
          */
        this.top = 0.0;
        /**
          The left inset.
          
          Default is 0.0
          */
        this.left = 0.0;
        /**
          The bottom inset.
          
          Default is 0.0
          */
        this.bottom = 0.0;
        /**
          The right inset.
          
          Default is 0.0
          */
        this.right = 0.0;
        if (source.top !== undefined) {
            this.top = source.top;
        }
        if (source.left !== undefined) {
            this.left = source.left;
        }
        if (source.bottom !== undefined) {
            this.bottom = source.bottom;
        }
        if (source.right !== undefined) {
            this.right = source.right;
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/barcode/ArTrackingOverlayConfiguration.yaml
/**
Configuration of the overlay polygon displayed on top of a barcode in the camera preview.
*/
class ArOverlayPolygonConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ArOverlayPolygonConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Control the visibility of the overlay polygon.
          
          Default is true
          */
        this.visible = true;
        /**
          Appearance of the overlay polygon when a barcode is not selected.
          */
        this.deselected = new PolygonStyle({
            strokeColor: '?sbColorSurface',
            fillColor: '#00000000',
            strokeWidth: 2.0,
            cornerRadius: 2.0,
        });
        /**
          Appearance of the overlay polygon after a barcode has been selected.
          */
        this.selected = new PolygonStyle({
            strokeColor: '?sbColorPositive',
            fillColor: '#00000000',
            strokeWidth: 2.0,
            cornerRadius: 2.0,
        });
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.deselected !== undefined) {
            this.deselected = new PolygonStyle(source.deselected);
        }
        if (source.selected !== undefined) {
            this.selected = new PolygonStyle(source.selected);
        }
    }
}
const BarcodeItemInfoPositionValues = ['DISABLED', 'STACKED', 'BELOW', 'ABOVE'];
/**
Configuration of the barcode info box displayed in the camera preview.
*/
class BarcodeItemConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeItemConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Control the visibility of the barcode image in the info box.
          
          Default is true
          */
        this.imageVisible = true;
        /**
          Configuration of the text displaying a barcode's value in the info box when the barcode has been selected.
          */
        this.titleSelected = new StyledText({ text: 'BARCODE_TITLE', color: '?sbColorOnSurface' });
        /**
          Configuration of the text displaying a barcode's symbology in the info box when the barcode has been selected.
          */
        this.subtitleSelected = new StyledText({ text: 'BARCODE_SUBTITLE', color: '?sbColorOnSurfaceVariant' });
        /**
          Configuration of the text displaying a barcode's value in the info box when the barcode is yet to be selected.
          */
        this.titleDeselected = new StyledText({ text: 'BARCODE_TITLE', color: '?sbColorOnSurface' });
        /**
          Configuration of the text displaying a barcode's symbology in the info box when the barcode is yet to be selected.
          */
        this.subtitleDeselected = new StyledText({
            text: 'BARCODE_SUBTITLE',
            color: '?sbColorOnSurfaceVariant',
        });
        /**
          Appearance of the barcode info box's background when a barcode has been selected.
          */
        this.backgroundSelected = new PolygonStyle({
            strokeColor: '?sbColorPositive',
            fillColor: '?sbColorPositive',
            strokeWidth: 0.0,
            cornerRadius: 10.0,
        });
        /**
          Appearance of the barcode info box's background when a barcode is yet to be selected.
          */
        this.backgroundDeselected = new PolygonStyle({
            strokeColor: '?sbColorSurface',
            fillColor: '?sbColorSurface',
            strokeWidth: 0.0,
            cornerRadius: 10.0,
        });
        if (source.imageVisible !== undefined) {
            this.imageVisible = source.imageVisible;
        }
        if (source.titleSelected !== undefined) {
            this.titleSelected = new StyledText(source.titleSelected);
        }
        if (source.subtitleSelected !== undefined) {
            this.subtitleSelected = new StyledText(source.subtitleSelected);
        }
        if (source.titleDeselected !== undefined) {
            this.titleDeselected = new StyledText(source.titleDeselected);
        }
        if (source.subtitleDeselected !== undefined) {
            this.subtitleDeselected = new StyledText(source.subtitleDeselected);
        }
        if (source.backgroundSelected !== undefined) {
            this.backgroundSelected = new PolygonStyle(source.backgroundSelected);
        }
        if (source.backgroundDeselected !== undefined) {
            this.backgroundDeselected = new PolygonStyle(source.backgroundDeselected);
        }
    }
}
/**
Configuration of the AR overlay displayed on top of barcodes in the camera preview.
*/
class ArOverlayGeneralConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ArOverlayGeneralConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Control the visibility of the user guidance.
          
          Default is false
          */
        this.visible = false;
        /**
          Parameters of the counter badge appearance e.g. color of background its stroke and text/icon color.
          */
        this.counterBadge = new BadgeStyle({
            background: new BackgroundStyle({}),
            foregroundColor: '?sbColorOnSurface',
        });
        /**
          If enabled, the scanner will always immediately scan a barcode in the viewfinder or the camera view. The overlay will mark the scanned barcodes and stays above them.
          
          Default is false
          */
        this.automaticSelectionEnabled = false;
        /**
          Where to display the barcode info box in the camera preview.
          
          Default is BELOW
          */
        this.barcodeItemInfoPosition = 'BELOW';
        /**
          Configuration of the overlay polygon displayed on top of a barcode in the camera preview.
          */
        this.polygon = new ArOverlayPolygonConfiguration({
            visible: true,
            deselected: new PolygonStyle({}),
            selected: new PolygonStyle({}),
        });
        /**
          Configuration of the barcode info box displayed in the camera preview.
          */
        this.barcodeItemConfiguration = new BarcodeItemConfiguration({
            imageVisible: true,
            titleSelected: new StyledText({ text: 'BARCODE_TITLE', color: '?sbColorOnSurface' }),
            subtitleSelected: new StyledText({ text: 'BARCODE_SUBTITLE', color: '?sbColorOnSurfaceVariant' }),
            titleDeselected: new StyledText({ text: 'BARCODE_TITLE', color: '?sbColorOnSurface' }),
            subtitleDeselected: new StyledText({ text: 'BARCODE_SUBTITLE', color: '?sbColorOnSurfaceVariant' }),
            backgroundSelected: new PolygonStyle({
                strokeColor: '?sbColorPositive',
                fillColor: '?sbColorPositive',
                strokeWidth: 1.0,
                cornerRadius: 5.0,
            }),
            backgroundDeselected: new PolygonStyle({
                strokeColor: '?sbColorSurface',
                fillColor: '?sbColorSurface',
                strokeWidth: 1.0,
                cornerRadius: 5.0,
            }),
        });
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.counterBadge !== undefined) {
            this.counterBadge = new BadgeStyle(source.counterBadge);
        }
        if (source.automaticSelectionEnabled !== undefined) {
            this.automaticSelectionEnabled = source.automaticSelectionEnabled;
        }
        if (source.barcodeItemInfoPosition !== undefined) {
            this.barcodeItemInfoPosition = source.barcodeItemInfoPosition;
        }
        if (source.polygon !== undefined) {
            this.polygon = new ArOverlayPolygonConfiguration(source.polygon);
        }
        if (source.barcodeItemConfiguration !== undefined) {
            this.barcodeItemConfiguration = new BarcodeItemConfiguration(source.barcodeItemConfiguration);
        }
    }
}
/**
Configuration of the overlay polygon displayed on top of a barcode in the camera preview.
*/
class FindAndPickArOverlayPolygonConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<FindAndPickArOverlayPolygonConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Control the visibility of the overlay polygon.
          
          Default is true
          */
        this.visible = true;
        /**
          Appearance of the overlay polygon when a barcode is partially scanned.
          */
        this.partiallyScanned = new PolygonStyle({
            strokeColor: '?sbColorWarning',
            fillColor: '#00000000',
            strokeWidth: 3.0,
            cornerRadius: 5.0,
        });
        /**
          Appearance of the overlay polygon when a barcode is rejected.
          */
        this.rejected = new PolygonStyle({
            strokeColor: '?sbColorSurface',
            fillColor: '#00000000',
            strokeWidth: 3.0,
            cornerRadius: 5.0,
        });
        /**
          Appearance of the overlay polygon when a barcode is completed.
          */
        this.completed = new PolygonStyle({
            strokeColor: '?sbColorPositive',
            fillColor: '#00000000',
            strokeWidth: 3.0,
            cornerRadius: 5.0,
        });
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.partiallyScanned !== undefined) {
            this.partiallyScanned = new PolygonStyle(source.partiallyScanned);
        }
        if (source.rejected !== undefined) {
            this.rejected = new PolygonStyle(source.rejected);
        }
        if (source.completed !== undefined) {
            this.completed = new PolygonStyle(source.completed);
        }
    }
}
/**
Configuration of the round badge on find and pick ar layer.
*/
class FindAndPickBadgeConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<FindAndPickBadgeConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Appearance of the badge when a barcode is partially scanned.
          */
        this.partiallyScanned = new BadgeStyle({
            visible: true,
            background: new BackgroundStyle({ strokeColor: '#FFFFFF30', fillColor: '?sbColorWarning', strokeWidth: 0.0 }),
            foregroundColor: '?sbColorOnSurface',
        });
        /**
          Appearance of the badge when a barcode is rejected.
          */
        this.rejected = new BadgeStyle({
            visible: true,
            background: new BackgroundStyle({ strokeColor: '#FFFFFF30', fillColor: '?sbColorNegative', strokeWidth: 0.0 }),
            foregroundColor: '?sbColorOnSurface',
        });
        /**
          Appearance of the badge when a barcode is completed.
          */
        this.completed = new BadgeStyle({
            visible: true,
            background: new BackgroundStyle({ strokeColor: '#FFFFFF30', fillColor: '?sbColorPositive', strokeWidth: 0.0 }),
            foregroundColor: '?sbColorOnSurface',
        });
        if (source.partiallyScanned !== undefined) {
            this.partiallyScanned = new BadgeStyle(source.partiallyScanned);
        }
        if (source.rejected !== undefined) {
            this.rejected = new BadgeStyle(source.rejected);
        }
        if (source.completed !== undefined) {
            this.completed = new BadgeStyle(source.completed);
        }
    }
}
/**
Configuration of the AR overlay.
*/
class ArOverlayFindAndPickConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ArOverlayFindAndPickConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Control the visibility of the user guidance.
          
          Default is false
          */
        this.visible = false;
        /**
          If enabled, the scanner will always immediately scan a barcode in the viewfinder or the camera view. The overlay will mark the scanned barcodes and stays above them.
          
          Default is true
          */
        this.automaticSelectionEnabled = true;
        /**
          Configuration of the overlay polygon displayed on top of a barcode in the camera preview.
          */
        this.polygon = new FindAndPickArOverlayPolygonConfiguration({});
        /**
          Configuration of the round badge on find and pick ar layer.
          */
        this.badge = new FindAndPickBadgeConfiguration({});
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.automaticSelectionEnabled !== undefined) {
            this.automaticSelectionEnabled = source.automaticSelectionEnabled;
        }
        if (source.polygon !== undefined) {
            this.polygon = new FindAndPickArOverlayPolygonConfiguration(source.polygon);
        }
        if (source.badge !== undefined) {
            this.badge = new FindAndPickBadgeConfiguration(source.badge);
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/barcode/BarcodeInfoMapping.yaml
/**
Configuration of the mapper's error dialog.
*/
class BarcodeItemErrorState extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeItemErrorState>`} */
    constructor(source = {}) {
        super();
        /**
          Title displayed above the error message.
          */
        this.title = new StyledText({ text: 'Connection Error!', color: '?sbColorOnSurface' });
        /**
          Error message.
          */
        this.subtitle = new StyledText({
            text: 'There was an issue and the data requested was not fetched. You could try again or discard this result to start a new scan.',
            color: '?sbColorOnSurfaceVariant',
        });
        /**
          Configuration of the retry button.
          */
        this.retryButton = new ButtonConfiguration({});
        /**
          Configuration of the cancel button.
          */
        this.cancelButton = new ButtonConfiguration({});
        if (source.title !== undefined) {
            this.title = new StyledText(source.title);
        }
        if (source.subtitle !== undefined) {
            this.subtitle = new StyledText(source.subtitle);
        }
        if (source.retryButton !== undefined) {
            this.retryButton = new ButtonConfiguration(source.retryButton);
        }
        if (source.cancelButton !== undefined) {
            this.cancelButton = new ButtonConfiguration(source.cancelButton);
        }
    }
}
/**
Format of the mapped barcode data.
*/
class BarcodeMappedData extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeMappedData>`} */
    constructor(source = {}) {
        super();
        if (source.title !== undefined) {
            this.title = source.title;
        }
        else {
            throw new Error('title must be present in constructor argument');
        }
        if (source.subtitle !== undefined) {
            this.subtitle = source.subtitle;
        }
        else {
            throw new Error('subtitle must be present in constructor argument');
        }
        if (source.barcodeImage !== undefined) {
            this.barcodeImage = source.barcodeImage;
        }
        else {
            throw new Error('barcodeImage must be present in constructor argument');
        }
    }
}
(function (BarcodeMappedData) {
    /**
      Use this key to display the original barcode image.
      
      Default is "BARCODE_IMAGE"
      */
    BarcodeMappedData.BARCODE_IMAGE_KEY = 'BARCODE_IMAGE';
})(BarcodeMappedData || (BarcodeMappedData = {}));
/**
Configuration of the barcode data mapping.
*/
class BarcodeInfoMapping extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeInfoMapping>`} */
    constructor(source = {}) {
        super();
        /**
          Callback to map the barcode data to the data of the corresponding product.
          */
        this.barcodeItemMapper = null;
        /**
          Background color of the barcode info dialog.
          
          Default is "?sbColorSurface"
          */
        this.sheetColor = '?sbColorSurface';
        /**
          Color of the divider and separator lines in the barcode info dialog.
          
          Default is "?sbColorOutline"
          */
        this.dividerColor = '?sbColorOutline';
        /**
          Background color of the overlay surrounding the barcode mapping error dialog.
          
          Default is "?sbColorModalOverlay"
          */
        this.modalOverlayColor = '?sbColorModalOverlay';
        /**
          Text being displayed while a barcode is being mapped.
          */
        this.loadingMessage = new StyledText({
            text: 'Loading message for barcode info mapping.',
            color: '?sbColorPrimary',
        });
        /**
          Configuration of the error state displayed when processing a barcode fails.
          */
        this.errorState = new BarcodeItemErrorState({});
        if (source.barcodeItemMapper !== undefined) {
            this.barcodeItemMapper = source.barcodeItemMapper != null ? source.barcodeItemMapper : null;
        }
        if (source.sheetColor !== undefined) {
            this.sheetColor = source.sheetColor;
        }
        if (source.dividerColor !== undefined) {
            this.dividerColor = source.dividerColor;
        }
        if (source.modalOverlayColor !== undefined) {
            this.modalOverlayColor = source.modalOverlayColor;
        }
        if (source.loadingMessage !== undefined) {
            this.loadingMessage = new StyledText(source.loadingMessage);
        }
        if (source.errorState !== undefined) {
            this.errorState = new BarcodeItemErrorState(source.errorState);
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/barcode/BarcodeScannerConfiguration.yaml
/**
Configuration of the scanning behavior.
*/
class CommonBarcodeScannerConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<CommonBarcodeScannerConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          List of document formats to be extracted.
          
          Defaults to all document formats.
          */
        this.extractedDocumentFormats = [
            'AAMVA',
            'BOARDING_PASS',
            'DE_MEDICAL_PLAN',
            'MEDICAL_CERTIFICATE',
            'ID_CARD_PDF_417',
            'SEPA',
            'SWISS_QR',
            'VCARD',
            'GS1',
            'HIBC',
        ];
        /**
          If `true` and extractedDocumentFormats is not empty, then barcodes that do not decode to one of the accepted document formats will be ignored.
          
          Default is false
          */
        this.onlyAcceptDocuments = false;
        /**
          Filter for extended EAN and UPC barcodes.
          
          Default is ALLOW_ANY
          */
        this.extensions = 'ALLOW_ANY';
        /**
          Regular expression filter for barcode text. If the barcode text does not match the regular expression, it will not be scanned. The default is an empty string (setting is turned off). This option overrides `barcodesExtensionFilter` option.
          
          Default is ""
          */
        this.barcodesRegexFilter = '';
        /**
          Minimum acceptable value of a result BarcodeItem's sizeScore (between 0 and 1). Barcodes with a sizeScore less than this value will not be scanned. When set to 0, barcodes are returned no matter what their size is.
          
          Default is 0
          */
        this.minimumSizeScore = 0.0;
        /**
          Optional minimum required text length of the detected barcode. The default is 0 (setting is turned off). NOTE - This feature works on ITF barcodes only.
          
          Default is 0
          */
        this.minimumTextLength = 0;
        /**
          Optional maximum text length of the detected barcode. The default is 0 (setting is turned off). NOTE - This feature works on ITF barcodes only.
          
          Default is 0
          */
        this.maximumTextLength = 0;
        /**
          Optional minimum required quiet zone on the barcode. Measured in modules (the smallest bar size on a barcode). The default is 10. NOTE - This feature works on ITF barcodes only.
          
          Default is 10
          */
        this.minimum1DBarcodesQuietZone = 10;
        /**
          If `true`, check digits for UPC, EAN and MSI Plessey codes are removed from the result. Has no effect if both single and double digit MSI Plessey checksums are enabled. The default is `false`.
          
          Default is false
          */
        this.stripCheckDigits = false;
        /**
          If `true`, the optional check digit for IATA_2_OF_5 codes is used in validation. The default is `true`.
          
          Default is true
          */
        this.useIATA2OF5Checksum = true;
        /**
          If `true`, the optional check digit for CODE_11 codes is used in validation. The default is `true`.
          
          Default is true
          */
        this.useCode11Checksum = true;
        /**
          List of accepted barcode symbologies.
          
          Defaults to common types.
          */
        this.barcodeFormats = [
            'AZTEC',
            'CODABAR',
            'CODE_39',
            'CODE_93',
            'CODE_128',
            'DATA_MATRIX',
            'DATABAR',
            'DATABAR_EXPANDED',
            'DATABAR_LIMITED',
            'EAN_13',
            'EAN_8',
            'ITF',
            'MICRO_QR_CODE',
            'PDF_417',
            'QR_CODE',
            'UPC_A',
            'UPC_E',
        ];
        /**
          Checksum algorithm used for MSI Plessey barcodes. The default value is MOD_10.
          
          Default is MOD_10
          */
        this.msiPlesseyChecksumAlgorithm = 'MOD_10';
        /**
          The customer format used in AUSTRALIA_POST codes. The default value is ALPHA_NUMERIC.
          
          Default is ALPHA_NUMERIC
          */
        this.australiaPostCustomerFormat = 'ALPHA_NUMERIC';
        /**
          If `true`, enables a mode that slightly decreases scanning quality and energy consumption. Increases scanning speed. If `false`, the mode is disabled. The default is `false`. Android only.
          
          Default is false
          */
        this.lowPowerMode = false;
        /**
          The expected way of handling GS1_COMPOSITE barcodes.
          
          Default is PARSE
          */
        this.gs1Handling = 'PARSE';
        /**
          If `true`, the barcode image is returned in the result.
          
          Default is false
          */
        this.returnBarcodeImage = false;
        if (source.extractedDocumentFormats !== undefined) {
            this.extractedDocumentFormats = source.extractedDocumentFormats.map((it) => {
                return it;
            });
        }
        if (source.onlyAcceptDocuments !== undefined) {
            this.onlyAcceptDocuments = source.onlyAcceptDocuments;
        }
        if (source.extensions !== undefined) {
            this.extensions = source.extensions;
        }
        if (source.barcodesRegexFilter !== undefined) {
            this.barcodesRegexFilter = source.barcodesRegexFilter;
        }
        if (source.minimumSizeScore !== undefined) {
            this.minimumSizeScore = source.minimumSizeScore;
        }
        if (source.minimumTextLength !== undefined) {
            this.minimumTextLength = source.minimumTextLength;
        }
        if (source.maximumTextLength !== undefined) {
            this.maximumTextLength = source.maximumTextLength;
        }
        if (source.minimum1DBarcodesQuietZone !== undefined) {
            this.minimum1DBarcodesQuietZone = source.minimum1DBarcodesQuietZone;
        }
        if (source.stripCheckDigits !== undefined) {
            this.stripCheckDigits = source.stripCheckDigits;
        }
        if (source.useIATA2OF5Checksum !== undefined) {
            this.useIATA2OF5Checksum = source.useIATA2OF5Checksum;
        }
        if (source.useCode11Checksum !== undefined) {
            this.useCode11Checksum = source.useCode11Checksum;
        }
        if (source.barcodeFormats !== undefined) {
            this.barcodeFormats = source.barcodeFormats.map((it) => {
                return it;
            });
        }
        if (source.msiPlesseyChecksumAlgorithm !== undefined) {
            this.msiPlesseyChecksumAlgorithm = source.msiPlesseyChecksumAlgorithm;
        }
        if (source.australiaPostCustomerFormat !== undefined) {
            this.australiaPostCustomerFormat = source.australiaPostCustomerFormat;
        }
        if (source.lowPowerMode !== undefined) {
            this.lowPowerMode = source.lowPowerMode;
        }
        if (source.gs1Handling !== undefined) {
            this.gs1Handling = source.gs1Handling;
        }
        if (source.returnBarcodeImage !== undefined) {
            this.returnBarcodeImage = source.returnBarcodeImage;
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/barcode/BarcodeTextLocalization.yaml
/**
Configuration of the all strings for barcode scanner.
*/
class BarcodeTextLocalization extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeTextLocalization>`} */
    constructor(source = {}) {
        super();
        /**
          Cancel button text for the top bar.
          
          Default is "Cancel"
          */
        this.topBarCancelButton = 'Cancel';
        /**
          Title for the top bar.
          
          Default is "Scan Item"
          */
        this.topBarTitle = 'Scan Item';
        /**
          User guidance text.
          
          Default is "Move the finder over a barcode"
          */
        this.userGuidance = 'Move the finder over a barcode';
        /**
          Loading message for barcode info mapping.
          
          Default is "Loading details..."
          */
        this.barcodeInfoMappingLoadingMessage = 'Loading details...';
        /**
          Title for the barcode info mapping error state.
          
          Default is "Connection Error!"
          */
        this.barcodeInfoMappingErrorStateTitle = 'Connection Error!';
        /**
          Subtitle for the barcode info mapping error state.
          
          Default is "There was an issue and the data requested was not fetched. You could try again or discard this result to start a new scan."
          */
        this.barcodeInfoMappingErrorStateSubtitle = 'There was an issue and the data requested was not fetched. You could try again or discard this result to start a new scan.';
        /**
          Retry button text for the barcode info mapping error state.
          
          Default is "Retry"
          */
        this.barcodeInfoMappingErrorStateRetryButton = 'Retry';
        /**
          Cancel button text for the barcode info mapping error state.
          
          Default is "Cancel"
          */
        this.barcodeInfoMappingErrorStateCancelButton = 'Cancel';
        /**
          Title for the manual count edit dialog.
          
          Default is "Update count"
          */
        this.manualCountEditDialogTitle = 'Update count';
        /**
          Info for the manual count edit dialog.
          
          Default is "Adjust the number of items you scanned."
          */
        this.manualCountEditDialogInfo = 'Adjust the number of items you scanned.';
        /**
          Update button text for the manual count edit dialog.
          
          Default is "Update"
          */
        this.manualCountEditDialogUpdateButton = 'Update';
        /**
          Cancel button text for the manual count edit dialog.
          
          Default is "Cancel"
          */
        this.manualCountEditDialogCancelButton = 'Cancel';
        /**
          Reset button text for the barcode sheet.
          
          Default is "Reset"
          */
        this.sheetResetButton = 'Reset';
        /**
          Clear all button text for the barcode sheet.
          
          Default is "Clear all"
          */
        this.sheetClearAllButton = 'Clear all';
        /**
          Submit button text for the barcode sheet.
          
          Default is "Submit"
          */
        this.sheetSubmitButton = 'Submit';
        /**
          Start scanning button text for the barcode sheet.
          
          Default is "Start scanning"
          */
        this.sheetStartScanningButton = 'Start scanning';
        /**
          Title for the barcode sheet placeholder.
          
          Default is "No barcodes here!"
          */
        this.sheetPlaceholderTitle = 'No barcodes here!';
        /**
          Subtitle for the barcode sheet placeholder.
          
          Default is "The barcode list is currently empty. Close this sheet and scan your items to add them."
          */
        this.sheetPlaceholderSubtitle = 'The barcode list is currently empty. Close this sheet and scan your items to add them.';
        /**
          Cancel button text for the single mode confirmation dialog.
          
          Default is "Close"
          */
        this.singleModeConfirmationCancelButton = 'Close';
        /**
          Title for the multiple mode barcode sheet.
          
          Default is "%d items"
          */
        this.multipleModeSheetTitle = '%d items';
        /**
          Title for the find and pick barcode sheet.
          
          Default is "%d/%d scanned"
          */
        this.findAndPickSheetTitle = '%d/%d scanned';
        /**
          Subtitle for the find and pick barcode sheet.
          
          Default is "%d/%d added"
          */
        this.findAndPickSheetBarcodeItemSubtitle = '%d/%d added';
        /**
          Title for the find and pick partial alert.
          
          Default is "Incomplete scan!"
          */
        this.findAndPickPartialAlertTitle = 'Incomplete scan!';
        /**
          Subtitle for the find and pick partial alert.
          
          Default is "Some codes are yet to be scanned. Proceed with submission anyway?"
          */
        this.findAndPickPartialAlertSubtitle = 'Some codes are yet to be scanned. Proceed with submission anyway?';
        /**
          Cancel button text for the find and pick partial alert.
          
          Default is "Cancel"
          */
        this.findAndPickPartialAlertCancelButton = 'Cancel';
        /**
          Submit button text for the find and pick partial alert.
          
          Default is "Yes, Submit"
          */
        this.findAndPickPartialAlertSubmitButton = 'Yes, Submit';
        /**
          Title for the find and pick complete alert.
          
          Default is "All codes found!"
          */
        this.findAndPickCompleteAlertTitle = 'All codes found!';
        /**
          Subtitle for the find and pick complete alert.
          
          Default is "You have successfully scanned all codes. Proceed with submission?"
          */
        this.findAndPickCompleteAlertSubtitle = 'You have successfully scanned all codes. Proceed with submission?';
        /**
          Cancel button text for the find and pick complete alert.
          
          Default is "Dismiss"
          */
        this.findAndPickCompleteAlertCancelButton = 'Dismiss';
        /**
          Submit button text for the find and pick complete alert.
          
          Default is "Submit"
          */
        this.findAndPickCompleteAlertSubmitButton = 'Submit';
        /**
          Accessibility description for the 'cancel' button in the top bar.
          
          Default is "Cancel"
          */
        this.accessibilityDescriptionCancelButton = 'Cancel';
        /**
          Accessibility description for the flash button.
          
          Default is "Toggle flash"
          */
        this.accessibilityDescriptionFlashButton = 'Toggle flash';
        /**
          Accessibility description for the zoom button.
          
          Default is "Toggle camera zoom"
          */
        this.accessibilityDescriptionZoomButton = 'Toggle camera zoom';
        /**
          Accessibility description for the flip camera button.
          
          Default is "Flip camera"
          */
        this.accessibilityDescriptionFlipCameraButton = 'Flip camera';
        /**
          The title of the camera permission dialog.
          
          Default is "Camera permission denied!"
          */
        this.cameraPermissionEnableCameraTitle = 'Camera permission denied!';
        /**
          The explanation text of the camera permission dialog.
          
          Default is "Please allow the usage of the camera to start the scanning process."
          */
        this.cameraPermissionEnableCameraExplanation = 'Please allow the usage of the camera to start the scanning process.';
        /**
          The 'enable' button title of the camera permission dialog.
          
          Default is "Grant permission"
          */
        this.cameraPermissionEnableCameraButton = 'Grant permission';
        /**
          The 'close' button title of the camera permission dialog.
          
          Default is "Close"
          */
        this.cameraPermissionCloseButton = 'Close';
        /**
          The accessibility hint for the 'enable' button of the camera permission dialog.
          
          Default is "Tap to grant camera permission"
          */
        this.accessibilityDescriptionCameraPermissionEnableCameraButton = 'Tap to grant camera permission';
        /**
          The accessibility hint for the 'close' button of the camera permission dialog.
          
          Default is "Close screen without granting permission"
          */
        this.accessibilityDescriptionCameraPermissionCloseButton = 'Close screen without granting permission';
        if (source.topBarCancelButton !== undefined) {
            this.topBarCancelButton = source.topBarCancelButton;
        }
        if (source.topBarTitle !== undefined) {
            this.topBarTitle = source.topBarTitle;
        }
        if (source.userGuidance !== undefined) {
            this.userGuidance = source.userGuidance;
        }
        if (source.barcodeInfoMappingLoadingMessage !== undefined) {
            this.barcodeInfoMappingLoadingMessage = source.barcodeInfoMappingLoadingMessage;
        }
        if (source.barcodeInfoMappingErrorStateTitle !== undefined) {
            this.barcodeInfoMappingErrorStateTitle = source.barcodeInfoMappingErrorStateTitle;
        }
        if (source.barcodeInfoMappingErrorStateSubtitle !== undefined) {
            this.barcodeInfoMappingErrorStateSubtitle = source.barcodeInfoMappingErrorStateSubtitle;
        }
        if (source.barcodeInfoMappingErrorStateRetryButton !== undefined) {
            this.barcodeInfoMappingErrorStateRetryButton = source.barcodeInfoMappingErrorStateRetryButton;
        }
        if (source.barcodeInfoMappingErrorStateCancelButton !== undefined) {
            this.barcodeInfoMappingErrorStateCancelButton = source.barcodeInfoMappingErrorStateCancelButton;
        }
        if (source.manualCountEditDialogTitle !== undefined) {
            this.manualCountEditDialogTitle = source.manualCountEditDialogTitle;
        }
        if (source.manualCountEditDialogInfo !== undefined) {
            this.manualCountEditDialogInfo = source.manualCountEditDialogInfo;
        }
        if (source.manualCountEditDialogUpdateButton !== undefined) {
            this.manualCountEditDialogUpdateButton = source.manualCountEditDialogUpdateButton;
        }
        if (source.manualCountEditDialogCancelButton !== undefined) {
            this.manualCountEditDialogCancelButton = source.manualCountEditDialogCancelButton;
        }
        if (source.sheetResetButton !== undefined) {
            this.sheetResetButton = source.sheetResetButton;
        }
        if (source.sheetClearAllButton !== undefined) {
            this.sheetClearAllButton = source.sheetClearAllButton;
        }
        if (source.sheetSubmitButton !== undefined) {
            this.sheetSubmitButton = source.sheetSubmitButton;
        }
        if (source.sheetStartScanningButton !== undefined) {
            this.sheetStartScanningButton = source.sheetStartScanningButton;
        }
        if (source.sheetPlaceholderTitle !== undefined) {
            this.sheetPlaceholderTitle = source.sheetPlaceholderTitle;
        }
        if (source.sheetPlaceholderSubtitle !== undefined) {
            this.sheetPlaceholderSubtitle = source.sheetPlaceholderSubtitle;
        }
        if (source.singleModeConfirmationCancelButton !== undefined) {
            this.singleModeConfirmationCancelButton = source.singleModeConfirmationCancelButton;
        }
        if (source.multipleModeSheetTitle !== undefined) {
            this.multipleModeSheetTitle = source.multipleModeSheetTitle;
        }
        if (source.findAndPickSheetTitle !== undefined) {
            this.findAndPickSheetTitle = source.findAndPickSheetTitle;
        }
        if (source.findAndPickSheetBarcodeItemSubtitle !== undefined) {
            this.findAndPickSheetBarcodeItemSubtitle = source.findAndPickSheetBarcodeItemSubtitle;
        }
        if (source.findAndPickPartialAlertTitle !== undefined) {
            this.findAndPickPartialAlertTitle = source.findAndPickPartialAlertTitle;
        }
        if (source.findAndPickPartialAlertSubtitle !== undefined) {
            this.findAndPickPartialAlertSubtitle = source.findAndPickPartialAlertSubtitle;
        }
        if (source.findAndPickPartialAlertCancelButton !== undefined) {
            this.findAndPickPartialAlertCancelButton = source.findAndPickPartialAlertCancelButton;
        }
        if (source.findAndPickPartialAlertSubmitButton !== undefined) {
            this.findAndPickPartialAlertSubmitButton = source.findAndPickPartialAlertSubmitButton;
        }
        if (source.findAndPickCompleteAlertTitle !== undefined) {
            this.findAndPickCompleteAlertTitle = source.findAndPickCompleteAlertTitle;
        }
        if (source.findAndPickCompleteAlertSubtitle !== undefined) {
            this.findAndPickCompleteAlertSubtitle = source.findAndPickCompleteAlertSubtitle;
        }
        if (source.findAndPickCompleteAlertCancelButton !== undefined) {
            this.findAndPickCompleteAlertCancelButton = source.findAndPickCompleteAlertCancelButton;
        }
        if (source.findAndPickCompleteAlertSubmitButton !== undefined) {
            this.findAndPickCompleteAlertSubmitButton = source.findAndPickCompleteAlertSubmitButton;
        }
        if (source.accessibilityDescriptionCancelButton !== undefined) {
            this.accessibilityDescriptionCancelButton = source.accessibilityDescriptionCancelButton;
        }
        if (source.accessibilityDescriptionFlashButton !== undefined) {
            this.accessibilityDescriptionFlashButton = source.accessibilityDescriptionFlashButton;
        }
        if (source.accessibilityDescriptionZoomButton !== undefined) {
            this.accessibilityDescriptionZoomButton = source.accessibilityDescriptionZoomButton;
        }
        if (source.accessibilityDescriptionFlipCameraButton !== undefined) {
            this.accessibilityDescriptionFlipCameraButton = source.accessibilityDescriptionFlipCameraButton;
        }
        if (source.cameraPermissionEnableCameraTitle !== undefined) {
            this.cameraPermissionEnableCameraTitle = source.cameraPermissionEnableCameraTitle;
        }
        if (source.cameraPermissionEnableCameraExplanation !== undefined) {
            this.cameraPermissionEnableCameraExplanation = source.cameraPermissionEnableCameraExplanation;
        }
        if (source.cameraPermissionEnableCameraButton !== undefined) {
            this.cameraPermissionEnableCameraButton = source.cameraPermissionEnableCameraButton;
        }
        if (source.cameraPermissionCloseButton !== undefined) {
            this.cameraPermissionCloseButton = source.cameraPermissionCloseButton;
        }
        if (source.accessibilityDescriptionCameraPermissionEnableCameraButton !== undefined) {
            this.accessibilityDescriptionCameraPermissionEnableCameraButton =
                source.accessibilityDescriptionCameraPermissionEnableCameraButton;
        }
        if (source.accessibilityDescriptionCameraPermissionCloseButton !== undefined) {
            this.accessibilityDescriptionCameraPermissionCloseButton =
                source.accessibilityDescriptionCameraPermissionCloseButton;
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/barcode/MultipleScanningModeUseCase.yaml
const MultipleBarcodesScanningModeValues = ['COUNTING', 'UNIQUE'];
const SheetModeValues = ['BUTTON', 'COLLAPSED_SHEET'];
const CollapsedVisibleHeightValues = ['SMALL', 'LARGE'];
/**
Configuration of the preview mode for scanning multiple barcodes.
*/
class Sheet extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<Sheet>`} */
    constructor(source = {}) {
        super();
        /**
          Mode used for the preview for scanning multiple barcodes.
          
          Default is COLLAPSED_SHEET
          */
        this.mode = 'COLLAPSED_SHEET';
        /**
          Height of the collapsed result sheet.
          
          Default is SMALL
          */
        this.collapsedVisibleHeight = 'SMALL';
        /**
          Configuration of the list button.
          */
        this.listButton = new BadgedButton({});
        if (source.mode !== undefined) {
            this.mode = source.mode;
        }
        if (source.collapsedVisibleHeight !== undefined) {
            this.collapsedVisibleHeight = source.collapsedVisibleHeight;
        }
        if (source.listButton !== undefined) {
            this.listButton = new BadgedButton(source.listButton);
        }
    }
}
/**
Configuration of the swipe-to-delete button.
*/
class SwipeToDelete extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<SwipeToDelete>`} */
    constructor(source = {}) {
        super();
        /**
          Whether swipe to delete is enabled or not.
          
          Default is true
          */
        this.enabled = true;
        /**
          Color of the swipe-to-delete button.
          
          Default is "?sbColorNegative"
          */
        this.backgroundColor = '?sbColorNegative';
        /**
          Color of the icon on the swipe-to-delete button.
          
          Default is "?sbColorOnPrimary"
          */
        this.iconColor = '?sbColorOnPrimary';
        if (source.enabled !== undefined) {
            this.enabled = source.enabled;
        }
        if (source.backgroundColor !== undefined) {
            this.backgroundColor = source.backgroundColor;
        }
        if (source.iconColor !== undefined) {
            this.iconColor = source.iconColor;
        }
    }
}
/**
Configuration of the dialog to manually edit the barcode count.
*/
class ManualCountEditDialog extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ManualCountEditDialog>`} */
    constructor(source = {}) {
        super();
        /**
          Color of the edit dialog's background.
          
          Default is "?sbColorSurface"
          */
        this.sheetColor = '?sbColorSurface';
        /**
          Color of the divider and separator lines in the edit dialog.
          
          Default is "?sbColorOutline"
          */
        this.dividerColor = '?sbColorOutline';
        /**
          Background color of the overlay surrounding the edit dialog.
          
          Default is "?sbColorModalOverlay"
          */
        this.modalOverlayColor = '?sbColorModalOverlay';
        /**
          Configuration of the edit dialog's title.
          */
        this.title = new StyledText({ text: 'Update count', color: '?sbColorOnSurface' });
        /**
          Configuration of the edit dialog's info text.
          */
        this.info = new StyledText({
            text: 'Adjust the number of items you scanned.',
            color: '?sbColorOnSurfaceVariant',
        });
        /**
          Configuration of the edit dialog's confirm button. Hiding both the update and cancel buttons simultaneously is an undefined behavior.
          */
        this.updateButton = new ButtonConfiguration({
            visible: true,
            text: 'Update',
            background: new BackgroundStyle({ strokeColor: '?sbColorPrimary', fillColor: '?sbColorPrimary', strokeWidth: 1.0 }),
            foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorOnPrimary', useShadow: false }),
        });
        /**
          Configuration of the edit dialog's cancel button. Hiding both the update and cancel buttons simultaneously is an undefined behavior.
          */
        this.cancelButton = new ButtonConfiguration({
            visible: true,
            text: 'Cancel',
            background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
            foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorPrimary', useShadow: false }),
        });
        /**
          Configuration of the edit dialog's button to clear the entered count number.
          */
        this.clearTextButton = new IconStyle({ visible: true, color: '?sbColorOnSurfaceVariant' });
        if (source.sheetColor !== undefined) {
            this.sheetColor = source.sheetColor;
        }
        if (source.dividerColor !== undefined) {
            this.dividerColor = source.dividerColor;
        }
        if (source.modalOverlayColor !== undefined) {
            this.modalOverlayColor = source.modalOverlayColor;
        }
        if (source.title !== undefined) {
            this.title = new StyledText(source.title);
        }
        if (source.info !== undefined) {
            this.info = new StyledText(source.info);
        }
        if (source.updateButton !== undefined) {
            this.updateButton = new ButtonConfiguration(source.updateButton);
        }
        if (source.cancelButton !== undefined) {
            this.cancelButton = new ButtonConfiguration(source.cancelButton);
        }
        if (source.clearTextButton !== undefined) {
            this.clearTextButton = new IconStyle(source.clearTextButton);
        }
    }
}
/**
Configuration of the list containing the barcodes that have already been scanned.
*/
class SheetContent extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<SheetContent>`} */
    constructor(source = {}) {
        super();
        /**
          Color of the list's background.
          
          Default is "?sbColorSurface"
          */
        this.sheetColor = '?sbColorSurface';
        /**
          The color of the dividers in the list sheet.
          
          Default is "?sbColorOutline"
          */
        this.dividerColor = '?sbColorOutline';
        /**
          Enables the user to change the number of scanned items by pressing +,-, or changing the number using a keyboard.
          
          Default is true
          */
        this.manualCountChangeEnabled = true;
        /**
          The color of the outline of the manual counting buttons in the list sheet.
          
          Default is "?sbColorOutline"
          */
        this.manualCountOutlineColor = '?sbColorOutline';
        /**
          Color of the buttons for manually changing the barcode count.
          
          Default is "?sbColorPrimary"
          */
        this.manualCountChangeColor = '?sbColorPrimary';
        /**
          Configuration of the barcode list's title. By default displays the total number of scanned barcodes.
          */
        this.title = new StyledText({ text: '%d items', color: '?sbColorOnSurface' });
        /**
          Configuration of the button for clearing the barcode list.
          */
        this.clearAllButton = new ButtonConfiguration({
            visible: true,
            text: 'Clear all',
            background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
            foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorOnSurface', useShadow: false }),
        });
        /**
          Configuration of the title of a barcode list entry (displaying the barcode's value).
          */
        this.barcodeItemTitle = new StyledText({
            visible: true,
            text: 'BARCODE_TITLE',
            color: '?sbColorOnSurface',
            useShadow: false,
        });
        /**
          Configuration of the subtitle of a barcode list entry (displaying the barcode's symbology).
          */
        this.barcodeItemSubtitle = new StyledText({
            text: 'BARCODE_SUBTITLE',
            color: '?sbColorOnSurfaceVariant',
        });
        /**
          Visibility of the barcode image in a barcode list entry.
          
          Default is true
          */
        this.barcodeItemImageVisible = true;
        /**
          Configuration of the barcode list's submit button.
          */
        this.submitButton = new ButtonConfiguration({
            visible: true,
            text: 'Submit',
            background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
            foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorOnSurface', useShadow: false }),
        });
        /**
          Configuration of the button to start scanning displayed in an empty barcode list.
          */
        this.startScanningButton = new ButtonConfiguration({
            visible: true,
            text: 'Start scanning',
            background: new BackgroundStyle({ strokeColor: '?sbColorPrimary', fillColor: '?sbColorPrimary', strokeWidth: 1.0 }),
            foreground: new ForegroundStyle({ iconVisible: true, color: '?sbColorOnPrimary', useShadow: false }),
        });
        /**
          Configuration of the title displayed in an empty barcode list.
          */
        this.placeholderTitle = new StyledText({ text: 'No barcodes here!', color: '?sbColorOnSurface' });
        /**
          Configuration of the subtitle displayed in an empty barcode list.
          */
        this.placeholderSubtitle = new StyledText({
            text: 'The barcode list is currently empty. Close this sheet and scan your items to add them.',
            color: '?sbColorOnSurfaceVariant',
        });
        /**
          Background color of the icon displayed in an empty barcode list.
          
          Default is "?sbColorOutline"
          */
        this.placeholderIconBackground = '?sbColorOutline';
        /**
          Configuration of the icon displayed in an empty barcode list.
          */
        this.placeholderIcon = new IconStyle({ visible: true, color: '?sbColorOnSurface' });
        /**
          The style of the swipe-to-delete button.
          */
        this.swipeToDelete = new SwipeToDelete({
            enabled: true,
            backgroundColor: '?sbColorNegative',
            iconColor: '?sbColorOnPrimary',
        });
        if (source.sheetColor !== undefined) {
            this.sheetColor = source.sheetColor;
        }
        if (source.dividerColor !== undefined) {
            this.dividerColor = source.dividerColor;
        }
        if (source.manualCountChangeEnabled !== undefined) {
            this.manualCountChangeEnabled = source.manualCountChangeEnabled;
        }
        if (source.manualCountOutlineColor !== undefined) {
            this.manualCountOutlineColor = source.manualCountOutlineColor;
        }
        if (source.manualCountChangeColor !== undefined) {
            this.manualCountChangeColor = source.manualCountChangeColor;
        }
        if (source.title !== undefined) {
            this.title = new StyledText(source.title);
        }
        if (source.clearAllButton !== undefined) {
            this.clearAllButton = new ButtonConfiguration(source.clearAllButton);
        }
        if (source.barcodeItemTitle !== undefined) {
            this.barcodeItemTitle = new StyledText(source.barcodeItemTitle);
        }
        if (source.barcodeItemSubtitle !== undefined) {
            this.barcodeItemSubtitle = new StyledText(source.barcodeItemSubtitle);
        }
        if (source.barcodeItemImageVisible !== undefined) {
            this.barcodeItemImageVisible = source.barcodeItemImageVisible;
        }
        if (source.submitButton !== undefined) {
            this.submitButton = new ButtonConfiguration(source.submitButton);
        }
        if (source.startScanningButton !== undefined) {
            this.startScanningButton = new ButtonConfiguration(source.startScanningButton);
        }
        if (source.placeholderTitle !== undefined) {
            this.placeholderTitle = new StyledText(source.placeholderTitle);
        }
        if (source.placeholderSubtitle !== undefined) {
            this.placeholderSubtitle = new StyledText(source.placeholderSubtitle);
        }
        if (source.placeholderIconBackground !== undefined) {
            this.placeholderIconBackground = source.placeholderIconBackground;
        }
        if (source.placeholderIcon !== undefined) {
            this.placeholderIcon = new IconStyle(source.placeholderIcon);
        }
        if (source.swipeToDelete !== undefined) {
            this.swipeToDelete = new SwipeToDelete(source.swipeToDelete);
        }
    }
}
/**
Configuration of the mode for scanning multiple barcodes.
*/
class MultipleScanningMode extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<MultipleScanningMode>`} */
    constructor(source = {}) {
        super();
        this._type = 'MultipleScanningMode';
        /**
          Time interval in milliseconds before a barcode is counted again. 0 = no delay. The default value is 1000.
          
          Default is 1000
          */
        this.countingRepeatDelay = 1000;
        /**
          Whether the user can submit an empty barcode list.
          
          Default is false
          */
        this.allowEmptySubmission = false;
        /**
          Mode used for scanning multiple barcodes.
          
          Default is COUNTING
          */
        this.mode = 'COUNTING';
        /**
          Configuration of the preview mode for scanning multiple barcodes.
          */
        this.sheet = new Sheet({
            mode: 'COLLAPSED_SHEET',
            collapsedVisibleHeight: 'SMALL',
            listButton: new BadgedButton({
                badgeBackgroundColor: '?sbColorSurface',
                badgeForegroundColor: '?sbColorPrimary',
                visible: true,
                backgroundColor: '?sbColorSurfaceHigh',
                foregroundColor: '?sbColorOnPrimary',
                activeBackgroundColor: '?sbColorSurfaceHigh',
                activeForegroundColor: '?sbColorOnPrimary',
            }),
        });
        /**
          Configuration of the list containing the barcodes that have already been scanned.
          */
        this.sheetContent = new SheetContent({
            sheetColor: '?sbColorSurface',
            dividerColor: '?sbColorOutline',
            manualCountChangeEnabled: true,
            manualCountOutlineColor: '?sbColorOutline',
            manualCountChangeColor: '?sbColorPrimary',
            title: new StyledText({ text: '?multipleModeSheetTitle', color: '?sbColorOnSurface' }),
            clearAllButton: new ButtonConfiguration({
                visible: true,
                text: '?sheetClearAllButton',
                background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorOnSurface', useShadow: false }),
            }),
            barcodeItemTitle: new StyledText({
                visible: true,
                text: 'BARCODE_TITLE',
                color: '?sbColorOnSurface',
                useShadow: false,
            }),
            barcodeItemSubtitle: new StyledText({
                visible: true,
                text: 'BARCODE_SUBTITLE',
                color: '?sbColorOnSurfaceVariant',
                useShadow: false,
            }),
            barcodeItemImageVisible: true,
            submitButton: new ButtonConfiguration({
                visible: true,
                text: '?sheetSubmitButton',
                background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorOnSurface', useShadow: false }),
            }),
            startScanningButton: new ButtonConfiguration({
                visible: true,
                text: '?sheetStartScanningButton',
                background: new BackgroundStyle({
                    strokeColor: '?sbColorPrimary',
                    fillColor: '?sbColorPrimary',
                    strokeWidth: 1.0,
                }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorOnPrimary', useShadow: false }),
            }),
            placeholderTitle: new StyledText({
                visible: true,
                text: '?sheetPlaceholderTitle',
                color: '?sbColorOnSurface',
                useShadow: false,
            }),
            placeholderSubtitle: new StyledText({
                visible: true,
                text: '?sheetPlaceholderSubtitle',
                color: '?sbColorOnSurfaceVariant',
                useShadow: false,
            }),
            placeholderIconBackground: '?sbColorOutline',
            placeholderIcon: new IconStyle({ visible: true, color: '?sbColorOnSurface' }),
            swipeToDelete: new SwipeToDelete({
                enabled: true,
                backgroundColor: '?sbColorNegative',
                iconColor: '?sbColorOnPrimary',
            }),
        });
        /**
          Configuration of the dialog to manually edit the barcode count.
          */
        this.manualCountEditDialog = new ManualCountEditDialog({
            sheetColor: '?sbColorSurface',
            dividerColor: '?sbColorOutline',
            modalOverlayColor: '?sbColorModalOverlay',
            title: new StyledText({ text: '?manualCountEditDialogTitle', color: '?sbColorOnSurface' }),
            info: new StyledText({ text: '?manualCountEditDialogInfo', color: '?sbColorOnSurfaceVariant' }),
            updateButton: new ButtonConfiguration({
                visible: true,
                text: '?manualCountEditDialogUpdateButton',
                background: new BackgroundStyle({
                    strokeColor: '?sbColorPrimary',
                    fillColor: '?sbColorPrimary',
                    strokeWidth: 1.0,
                }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorOnPrimary', useShadow: false }),
            }),
            cancelButton: new ButtonConfiguration({
                visible: true,
                text: '?manualCountEditDialogCancelButton',
                background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorPrimary', useShadow: false }),
            }),
            clearTextButton: new IconStyle({ visible: true, color: '?sbColorOnSurfaceVariant' }),
        });
        /**
          Appearance of the barcode info mapping.
          */
        this.barcodeInfoMapping = new BarcodeInfoMapping({
            sheetColor: '?sbColorSurface',
            dividerColor: '?sbColorOutline',
            modalOverlayColor: '?sbColorModalOverlay',
            loadingMessage: new StyledText({ text: '?barcodeInfoMappingLoadingMessage', color: '?sbColorPrimary' }),
            errorState: new BarcodeItemErrorState({
                title: new StyledText({ text: '?barcodeInfoMappingErrorStateTitle', color: '?sbColorOnSurface' }),
                subtitle: new StyledText({ text: '?barcodeInfoMappingErrorStateSubtitle', color: '?sbColorOnSurfaceVariant' }),
                retryButton: new ButtonConfiguration({
                    visible: true,
                    text: '?barcodeInfoMappingErrorStateRetryButton',
                    background: new BackgroundStyle({
                        strokeColor: '?sbColorPrimary',
                        fillColor: '?sbColorPrimary',
                        strokeWidth: 1.0,
                    }),
                    foreground: new ForegroundStyle({ iconVisible: true, color: '?sbColorOnPrimary', useShadow: false }),
                }),
                cancelButton: new ButtonConfiguration({
                    visible: true,
                    text: '?barcodeInfoMappingErrorStateCancelButton',
                    background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
                    foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorPrimary', useShadow: false }),
                }),
            }),
        });
        /**
          Configuration of the AR overlay.
          */
        this.arOverlay = new ArOverlayGeneralConfiguration({
            visible: false,
            counterBadge: new BadgeStyle({
                visible: true,
                background: new BackgroundStyle({ strokeColor: '#FF000000', fillColor: '?sbColorPositive', strokeWidth: 0.0 }),
                foregroundColor: '?sbColorOnSurface',
            }),
            automaticSelectionEnabled: false,
            barcodeItemInfoPosition: 'BELOW',
            polygon: new ArOverlayPolygonConfiguration({
                visible: true,
                deselected: new PolygonStyle({
                    strokeColor: '?sbColorSurface',
                    fillColor: '#00000000',
                    strokeWidth: 3.0,
                    cornerRadius: 5.0,
                }),
                selected: new PolygonStyle({
                    strokeColor: '?sbColorPositive',
                    fillColor: '#00000000',
                    strokeWidth: 3.0,
                    cornerRadius: 5.0,
                }),
            }),
            barcodeItemConfiguration: new BarcodeItemConfiguration({
                imageVisible: true,
                titleSelected: new StyledText({ text: 'BARCODE_TITLE', color: '?sbColorOnSurface' }),
                subtitleSelected: new StyledText({
                    visible: true,
                    text: 'BARCODE_SUBTITLE',
                    color: '?sbColorOnSurfaceVariant',
                    useShadow: false,
                }),
                titleDeselected: new StyledText({
                    visible: true,
                    text: 'BARCODE_TITLE',
                    color: '?sbColorOnSurface',
                    useShadow: false,
                }),
                subtitleDeselected: new StyledText({ text: 'BARCODE_SUBTITLE', color: '?sbColorOnSurfaceVariant' }),
                backgroundSelected: new PolygonStyle({
                    strokeColor: '?sbColorPositive',
                    fillColor: '?sbColorPositive',
                    strokeWidth: 1.0,
                    cornerRadius: 5.0,
                }),
                backgroundDeselected: new PolygonStyle({
                    strokeColor: '?sbColorSurface',
                    fillColor: '?sbColorSurface',
                    strokeWidth: 1.0,
                    cornerRadius: 5.0,
                }),
            }),
        });
        if (source.countingRepeatDelay !== undefined) {
            this.countingRepeatDelay = source.countingRepeatDelay;
        }
        if (source.allowEmptySubmission !== undefined) {
            this.allowEmptySubmission = source.allowEmptySubmission;
        }
        if (source.mode !== undefined) {
            this.mode = source.mode;
        }
        if (source.sheet !== undefined) {
            this.sheet = new Sheet(source.sheet);
        }
        if (source.sheetContent !== undefined) {
            this.sheetContent = new SheetContent(source.sheetContent);
        }
        if (source.manualCountEditDialog !== undefined) {
            this.manualCountEditDialog = new ManualCountEditDialog(source.manualCountEditDialog);
        }
        if (source.barcodeInfoMapping !== undefined) {
            this.barcodeInfoMapping = new BarcodeInfoMapping(source.barcodeInfoMapping);
        }
        if (source.arOverlay !== undefined) {
            this.arOverlay = new ArOverlayGeneralConfiguration(source.arOverlay);
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/common/ScanbotAlertDialog.yaml
/**
Configuration of the standard alert dialog.
*/
class ScanbotAlertDialog extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ScanbotAlertDialog>`} */
    constructor(source = {}) {
        super();
        /**
          The title displayed above the message.
          */
        this.title = new StyledText({ text: 'Title', color: '?sbColorOnSurface' });
        /**
          The explanation message.
          */
        this.subtitle = new StyledText({
            text: 'Standard explanation message text.',
            color: '?sbColorOnSurfaceVariant',
        });
        /**
          The background color of the alert dialog.
          
          Default is "?sbColorSurface"
          */
        this.sheetColor = '?sbColorSurface';
        /**
          The dialog overlay color.
          
          Default is "?sbColorModalOverlay"
          */
        this.modalOverlayColor = '?sbColorModalOverlay';
        /**
          The color of the divider line.
          
          Default is "?sbColorOutline"
          */
        this.dividerColor = '?sbColorOutline';
        /**
          Configuration of the 'OK' button.
          */
        this.okButton = new ButtonConfiguration({
            background: new BackgroundStyle({ fillColor: '?sbColorPrimary' }),
        });
        /**
          Configuration of the middle button for dialogs with tree buttons.
          */
        this.actionButton = new ButtonConfiguration({
            visible: false,
            background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 0.0 }),
        });
        /**
          Configuration of the 'cancel' button.
          */
        this.cancelButton = new ButtonConfiguration({
            visible: true,
            background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 0.0 }),
        });
        if (source.title !== undefined) {
            this.title = new StyledText(source.title);
        }
        if (source.subtitle !== undefined) {
            this.subtitle = new StyledText(source.subtitle);
        }
        if (source.sheetColor !== undefined) {
            this.sheetColor = source.sheetColor;
        }
        if (source.modalOverlayColor !== undefined) {
            this.modalOverlayColor = source.modalOverlayColor;
        }
        if (source.dividerColor !== undefined) {
            this.dividerColor = source.dividerColor;
        }
        if (source.okButton !== undefined) {
            this.okButton = new ButtonConfiguration(source.okButton);
        }
        if (source.actionButton !== undefined) {
            this.actionButton = new ButtonConfiguration(source.actionButton);
        }
        if (source.cancelButton !== undefined) {
            this.cancelButton = new ButtonConfiguration(source.cancelButton);
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/barcode/FindAndPickScanningModeUseCase.yaml
/**
Configuration of the barcode to find and scan.
*/
class ExpectedBarcode extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ExpectedBarcode>`} */
    constructor(source = {}) {
        super();
        /**
          Title of the barcode to find.
          */
        this.title = null;
        /**
          Image of the barcode to find.
          */
        this.image = null;
        /**
          Number of barcodes with given symbology/value required to scan.
          
          Default is 1
          */
        this.count = 1;
        if (source.barcodeValue !== undefined) {
            this.barcodeValue = source.barcodeValue;
        }
        else {
            throw new Error('barcodeValue must be present in constructor argument');
        }
        if (source.title !== undefined) {
            this.title = source.title != null ? source.title : null;
        }
        if (source.image !== undefined) {
            this.image = source.image != null ? source.image : null;
        }
        if (source.count !== undefined) {
            this.count = source.count;
        }
    }
}
(function (ExpectedBarcode) {
    /**
      Use this key to display the original barcode image.
      
      Default is "BARCODE_IMAGE"
      */
    ExpectedBarcode.BARCODE_IMAGE_KEY = 'BARCODE_IMAGE';
})(ExpectedBarcode || (ExpectedBarcode = {}));
/**
Configuration of the Find and Pick barcode scanning mode.
*/
class FindAndPickScanningMode extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<FindAndPickScanningMode>`} */
    constructor(source = {}) {
        super();
        this._type = 'FindAndPickScanningMode';
        /**
          Color of the selected barcode.
          
          Default is "?sbColorPositive"
          */
        this.scanningCompletedColor = '?sbColorPositive';
        /**
          Color of the partially scanned barcode.
          
          Default is "?sbColorWarning"
          */
        this.scanningPartiallyColor = '?sbColorWarning';
        /**
          Color of the not scanned barcode .
          
          Default is "?sbColorOutline"
          */
        this.scanningNotScannedColor = '?sbColorOutline';
        /**
          If the user is allowed to finish the scanning process without scanning all the expected barcodes.
          
          Default is false
          */
        this.allowPartialScan = false;
        /**
          List of barcodes that the user has to find and scan.
          */
        this.expectedBarcodes = [];
        /**
          Time interval in milliseconds before a barcode is counted again. 0 = no delay. The default value is 1000.
          
          Default is 1000
          */
        this.countingRepeatDelay = 1000;
        /**
          Configuration of the preview mode for the barcodes required to be found and scanned.
          */
        this.sheet = new Sheet({
            mode: 'COLLAPSED_SHEET',
            collapsedVisibleHeight: 'SMALL',
            listButton: new BadgedButton({
                badgeBackgroundColor: '?sbColorSurface',
                badgeForegroundColor: '?sbColorPrimary',
                visible: true,
                backgroundColor: '?sbColorSurfaceHigh',
                foregroundColor: '?sbColorOnPrimary',
                activeBackgroundColor: '?sbColorSurfaceHigh',
                activeForegroundColor: '?sbColorOnPrimary',
            }),
        });
        /**
          Configuration of the list of barcodes required to be found and scanned.
          */
        this.sheetContent = new SheetContent({
            sheetColor: '?sbColorSurface',
            dividerColor: '?sbColorOutline',
            manualCountChangeEnabled: true,
            manualCountOutlineColor: '?sbColorOutline',
            manualCountChangeColor: '?sbColorPrimary',
            title: new StyledText({
                visible: true,
                text: '?findAndPickSheetTitle',
                color: '?sbColorOnSurface',
                useShadow: false,
            }),
            clearAllButton: new ButtonConfiguration({
                visible: true,
                text: '?sheetResetButton',
                background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorOnSurface', useShadow: false }),
            }),
            barcodeItemTitle: new StyledText({ text: 'BARCODE_TITLE', color: '?sbColorOnSurface' }),
            barcodeItemSubtitle: new StyledText({
                text: '?findAndPickSheetBarcodeItemSubtitle',
                color: '?sbColorOnSurfaceVariant',
            }),
            barcodeItemImageVisible: true,
            submitButton: new ButtonConfiguration({
                visible: true,
                text: '?sheetSubmitButton',
                background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorOnSurface', useShadow: false }),
            }),
            startScanningButton: new ButtonConfiguration({
                visible: true,
                text: '?sheetStartScanningButton',
                background: new BackgroundStyle({
                    strokeColor: '?sbColorPrimary',
                    fillColor: '?sbColorPrimary',
                    strokeWidth: 1.0,
                }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorOnPrimary', useShadow: false }),
            }),
            placeholderTitle: new StyledText({ text: '?sheetPlaceholderTitle', color: '?sbColorOnSurface' }),
            placeholderSubtitle: new StyledText({ text: '?sheetPlaceholderSubtitle', color: '?sbColorOnSurfaceVariant' }),
            placeholderIconBackground: '?sbColorOutline',
            placeholderIcon: new IconStyle({ visible: true, color: '?sbColorOnSurface' }),
            swipeToDelete: new SwipeToDelete({
                enabled: false,
                backgroundColor: '?sbColorNegative',
                iconColor: '?sbColorOnPrimary',
            }),
        });
        /**
          Configuration of the dialog to manually edit the barcode count.
          */
        this.manualCountEditDialog = new ManualCountEditDialog({
            sheetColor: '?sbColorSurface',
            dividerColor: '?sbColorOutline',
            modalOverlayColor: '?sbColorModalOverlay',
            title: new StyledText({ text: '?manualCountEditDialogTitle', color: '?sbColorOnSurface' }),
            info: new StyledText({ text: '?manualCountEditDialogInfo', color: '?sbColorOnSurfaceVariant' }),
            updateButton: new ButtonConfiguration({
                visible: true,
                text: '?manualCountEditDialogUpdateButton',
                background: new BackgroundStyle({
                    strokeColor: '?sbColorPrimary',
                    fillColor: '?sbColorPrimary',
                    strokeWidth: 1.0,
                }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorOnPrimary', useShadow: false }),
            }),
            cancelButton: new ButtonConfiguration({
                visible: true,
                text: '?manualCountEditDialogCancelButton',
                background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorPrimary', useShadow: false }),
            }),
            clearTextButton: new IconStyle({ visible: true, color: '?sbColorOnSurfaceVariant' }),
        });
        /**
          Configuration of the AR overlay.
          */
        this.arOverlay = new ArOverlayFindAndPickConfiguration({
            visible: true,
            automaticSelectionEnabled: true,
            polygon: new FindAndPickArOverlayPolygonConfiguration({
                partiallyScanned: new PolygonStyle({
                    strokeColor: '?sbColorWarning',
                    fillColor: '#00000000',
                    strokeWidth: 3.0,
                    cornerRadius: 5.0,
                }),
                rejected: new PolygonStyle({
                    strokeColor: '?sbColorSurface',
                    fillColor: '#00000000',
                    strokeWidth: 3.0,
                    cornerRadius: 5.0,
                }),
                completed: new PolygonStyle({
                    strokeColor: '?sbColorPositive',
                    fillColor: '#00000000',
                    strokeWidth: 3.0,
                    cornerRadius: 5.0,
                }),
            }),
            badge: new FindAndPickBadgeConfiguration({
                partiallyScanned: new BadgeStyle({
                    visible: true,
                    background: new BackgroundStyle({ strokeColor: '#000000FF', fillColor: '?sbColorWarning', strokeWidth: 0.0 }),
                    foregroundColor: '?sbColorOnSurface',
                }),
                rejected: new BadgeStyle({
                    visible: true,
                    background: new BackgroundStyle({ strokeColor: '#000000FF', fillColor: '?sbColorSurface', strokeWidth: 0.0 }),
                    foregroundColor: '?sbColorOnSurface',
                }),
                completed: new BadgeStyle({
                    visible: true,
                    background: new BackgroundStyle({ strokeColor: '#000000FF', fillColor: '?sbColorPositive', strokeWidth: 0.0 }),
                    foregroundColor: '?sbColorOnSurface',
                }),
            }),
        });
        /**
          If the partial scanned alert dialog is enabled.
          
          Default is true
          */
        this.partialScannedAlertDialogEnabled = true;
        /**
          Configuration of the partial scanned alert dialog.
          */
        this.partialScannedAlertDialog = new ScanbotAlertDialog({
            title: new StyledText({ text: '?findAndPickPartialAlertTitle', color: '?sbColorOnSurface' }),
            subtitle: new StyledText({ text: '?findAndPickPartialAlertSubtitle', color: '?sbColorOnSurfaceVariant' }),
            sheetColor: '?sbColorSurface',
            modalOverlayColor: '?sbColorModalOverlay',
            dividerColor: '?sbColorOutline',
            okButton: new ButtonConfiguration({
                visible: true,
                text: '?findAndPickPartialAlertSubmitButton',
                background: new BackgroundStyle({
                    strokeColor: '?sbColorPrimary',
                    fillColor: '?sbColorPrimary',
                    strokeWidth: 1.0,
                }),
                foreground: new ForegroundStyle({ iconVisible: true, color: '?sbColorOnPrimary', useShadow: false }),
            }),
            cancelButton: new ButtonConfiguration({
                visible: true,
                text: '?findAndPickPartialAlertCancelButton',
                background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorPrimary', useShadow: false }),
            }),
        });
        /**
          If the confirmation alert dialog is enabled.
          
          Default is false
          */
        this.confirmationAlertDialogEnabled = false;
        /**
          Configuration of the confirmation alert dialog.
          */
        this.confirmationAlertDialog = new ScanbotAlertDialog({
            title: new StyledText({ text: '?findAndPickCompleteAlertTitle', color: '?sbColorOnSurface' }),
            subtitle: new StyledText({ text: '?findAndPickCompleteAlertSubtitle', color: '?sbColorOnSurfaceVariant' }),
            sheetColor: '?sbColorSurface',
            modalOverlayColor: '?sbColorModalOverlay',
            dividerColor: '?sbColorOutline',
            okButton: new ButtonConfiguration({
                visible: true,
                text: '?findAndPickCompleteAlertSubmitButton',
                background: new BackgroundStyle({
                    strokeColor: '?sbColorPrimary',
                    fillColor: '?sbColorPrimary',
                    strokeWidth: 1.0,
                }),
                foreground: new ForegroundStyle({ iconVisible: true, color: '?sbColorOnPrimary', useShadow: false }),
            }),
            cancelButton: new ButtonConfiguration({
                visible: true,
                text: '?findAndPickCompleteAlertCancelButton',
                background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorPrimary', useShadow: false }),
            }),
        });
        if (source.scanningCompletedColor !== undefined) {
            this.scanningCompletedColor = source.scanningCompletedColor;
        }
        if (source.scanningPartiallyColor !== undefined) {
            this.scanningPartiallyColor = source.scanningPartiallyColor;
        }
        if (source.scanningNotScannedColor !== undefined) {
            this.scanningNotScannedColor = source.scanningNotScannedColor;
        }
        if (source.allowPartialScan !== undefined) {
            this.allowPartialScan = source.allowPartialScan;
        }
        if (source.expectedBarcodes !== undefined) {
            this.expectedBarcodes = source.expectedBarcodes.map((it) => {
                return new ExpectedBarcode(it);
            });
        }
        if (source.countingRepeatDelay !== undefined) {
            this.countingRepeatDelay = source.countingRepeatDelay;
        }
        if (source.sheet !== undefined) {
            this.sheet = new Sheet(source.sheet);
        }
        if (source.sheetContent !== undefined) {
            this.sheetContent = new SheetContent(source.sheetContent);
        }
        if (source.manualCountEditDialog !== undefined) {
            this.manualCountEditDialog = new ManualCountEditDialog(source.manualCountEditDialog);
        }
        if (source.arOverlay !== undefined) {
            this.arOverlay = new ArOverlayFindAndPickConfiguration(source.arOverlay);
        }
        if (source.partialScannedAlertDialogEnabled !== undefined) {
            this.partialScannedAlertDialogEnabled = source.partialScannedAlertDialogEnabled;
        }
        if (source.partialScannedAlertDialog !== undefined) {
            this.partialScannedAlertDialog = new ScanbotAlertDialog(source.partialScannedAlertDialog);
        }
        if (source.confirmationAlertDialogEnabled !== undefined) {
            this.confirmationAlertDialogEnabled = source.confirmationAlertDialogEnabled;
        }
        if (source.confirmationAlertDialog !== undefined) {
            this.confirmationAlertDialog = new ScanbotAlertDialog(source.confirmationAlertDialog);
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/barcode/SingleScanningModeUseCase.yaml
/**
Configuration of the single barcode scanning mode.
*/
class SingleScanningMode extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<SingleScanningMode>`} */
    constructor(source = {}) {
        super();
        this._type = 'SingleScanningMode';
        /**
          If enabled, the confirmation sheet will be shown after the barcode has been scanned.
          
          Default is false
          */
        this.confirmationSheetEnabled = false;
        /**
          If enabled, the barcode image will be shown on the confirmation sheet.
          
          Default is true
          */
        this.barcodeImageVisible = true;
        /**
          Color of the confirmation sheet's background.
          
          Default is "?sbColorSurface"
          */
        this.sheetColor = '?sbColorSurface';
        /**
          Color of the divider and separator lines in the confirmation sheet.
          
          Default is "?sbColorOutline"
          */
        this.dividerColor = '?sbColorOutline';
        /**
          Background color of the overlay surrounding the confirmation sheet.
          
          Default is "?sbColorModalOverlay"
          */
        this.modalOverlayColor = '?sbColorModalOverlay';
        /**
          Appearance of the barcode title (the barcode's value) on the confirmation sheet.
          */
        this.barcodeTitle = new StyledText({ text: 'BARCODE_TITLE', color: '?sbColorOnSurface' });
        /**
          Appearance of the barcode subtitle (the barcode's symbology) on the confirmation sheet.
          */
        this.barcodeSubtitle = new StyledText({ text: 'BARCODE_SUBTITLE', color: '?sbColorOnSurfaceVariant' });
        /**
          Appearance of the confirm button on the confirmation sheet.
          */
        this.submitButton = new ButtonConfiguration({
            visible: true,
            text: '?sheetSubmitButton',
            background: new BackgroundStyle({ strokeColor: '?sbColorPrimary', fillColor: '?sbColorPrimary', strokeWidth: 1.0 }),
            foreground: new ForegroundStyle({ iconVisible: true, color: '?sbColorOnPrimary' }),
        });
        /**
          Appearance of the cancel button on the confirmation sheet.
          */
        this.cancelButton = new ButtonConfiguration({
            visible: true,
            text: '?singleModeConfirmationCancelButton',
            background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
            foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorPrimary' }),
        });
        /**
          Appearance of the barcode info mapping.
          */
        this.barcodeInfoMapping = new BarcodeInfoMapping({
            sheetColor: '?sbColorSurface',
            dividerColor: '?sbColorOutline',
            modalOverlayColor: '?sbColorModalOverlay',
            loadingMessage: new StyledText({ text: '?barcodeInfoMappingLoadingMessage', color: '?sbColorPrimary' }),
            errorState: new BarcodeItemErrorState({
                title: new StyledText({ text: '?barcodeInfoMappingErrorStateTitle', color: '?sbColorOnSurface' }),
                subtitle: new StyledText({ text: '?barcodeInfoMappingErrorStateSubtitle', color: '?sbColorOnSurfaceVariant' }),
                retryButton: new ButtonConfiguration({
                    visible: true,
                    text: '?barcodeInfoMappingErrorStateRetryButton',
                    background: new BackgroundStyle({
                        strokeColor: '?sbColorPrimary',
                        fillColor: '?sbColorPrimary',
                        strokeWidth: 1.0,
                    }),
                    foreground: new ForegroundStyle({ iconVisible: true, color: '?sbColorOnPrimary' }),
                }),
                cancelButton: new ButtonConfiguration({
                    text: '?barcodeInfoMappingErrorStateCancelButton',
                    background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 1.0 }),
                    foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorPrimary' }),
                }),
            }),
        });
        /**
          Configuration of the AR overlay.
          */
        this.arOverlay = new ArOverlayGeneralConfiguration({
            visible: false,
            counterBadge: new BadgeStyle({
                visible: true,
                background: new BackgroundStyle({ strokeColor: '#000000FF', fillColor: '?sbColorPositive', strokeWidth: 0.0 }),
                foregroundColor: '?sbColorOnSurface',
            }),
            automaticSelectionEnabled: false,
            barcodeItemInfoPosition: 'BELOW',
            polygon: new ArOverlayPolygonConfiguration({
                visible: true,
                deselected: new PolygonStyle({
                    strokeColor: '?sbColorSurface',
                    fillColor: '#00000000',
                    strokeWidth: 3.0,
                    cornerRadius: 5.0,
                }),
                selected: new PolygonStyle({
                    strokeColor: '?sbColorPositive',
                    fillColor: '#00000000',
                    strokeWidth: 3.0,
                    cornerRadius: 5.0,
                }),
            }),
            barcodeItemConfiguration: new BarcodeItemConfiguration({
                imageVisible: true,
                titleSelected: new StyledText({ text: 'BARCODE_TITLE', color: '?sbColorOnSurface' }),
                subtitleSelected: new StyledText({ text: 'BARCODE_SUBTITLE', color: '?sbColorOnSurfaceVariant' }),
                titleDeselected: new StyledText({ text: 'BARCODE_TITLE', color: '?sbColorOnSurface' }),
                subtitleDeselected: new StyledText({
                    visible: true,
                    text: 'BARCODE_SUBTITLE',
                    color: '?sbColorOnSurfaceVariant',
                    useShadow: false,
                }),
                backgroundSelected: new PolygonStyle({
                    strokeColor: '?sbColorPositive',
                    fillColor: '?sbColorPositive',
                    strokeWidth: 1.0,
                    cornerRadius: 5.0,
                }),
                backgroundDeselected: new PolygonStyle({
                    strokeColor: '?sbColorSurface',
                    fillColor: '?sbColorSurface',
                    strokeWidth: 1.0,
                    cornerRadius: 5.0,
                }),
            }),
        });
        if (source.confirmationSheetEnabled !== undefined) {
            this.confirmationSheetEnabled = source.confirmationSheetEnabled;
        }
        if (source.barcodeImageVisible !== undefined) {
            this.barcodeImageVisible = source.barcodeImageVisible;
        }
        if (source.sheetColor !== undefined) {
            this.sheetColor = source.sheetColor;
        }
        if (source.dividerColor !== undefined) {
            this.dividerColor = source.dividerColor;
        }
        if (source.modalOverlayColor !== undefined) {
            this.modalOverlayColor = source.modalOverlayColor;
        }
        if (source.barcodeTitle !== undefined) {
            this.barcodeTitle = new StyledText(source.barcodeTitle);
        }
        if (source.barcodeSubtitle !== undefined) {
            this.barcodeSubtitle = new StyledText(source.barcodeSubtitle);
        }
        if (source.submitButton !== undefined) {
            this.submitButton = new ButtonConfiguration(source.submitButton);
        }
        if (source.cancelButton !== undefined) {
            this.cancelButton = new ButtonConfiguration(source.cancelButton);
        }
        if (source.barcodeInfoMapping !== undefined) {
            this.barcodeInfoMapping = new BarcodeInfoMapping(source.barcodeInfoMapping);
        }
        if (source.arOverlay !== undefined) {
            this.arOverlay = new ArOverlayGeneralConfiguration(source.arOverlay);
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/barcode/BarcodeUseCase.yaml
/** @internal */
exports.BarcodeUseCase = void 0;
(function (BarcodeUseCase) {
    /** @internal */
    function From(source) {
        const _type = source['_type'];
        switch (_type) {
            case 'SingleScanningMode':
                return new SingleScanningMode(source);
            case 'MultipleScanningMode':
                return new MultipleScanningMode(source);
            case 'FindAndPickScanningMode':
                return new FindAndPickScanningMode(source);
            default:
                throw `Unknown child class name: ${_type}`;
        }
    }
    BarcodeUseCase.From = From;
})(exports.BarcodeUseCase || (exports.BarcodeUseCase = {}));

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/common/ActionBarConfiguration.yaml
/**
Configuration of the buttons available in the action bar.
*/
class ActionBarConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ActionBarConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Configuration of the 'flash' button.
          */
        this.flashButton = new RoundButton({
            visible: true,
            accessibilityDescription: '?accessibilityDescriptionFlashButton',
            backgroundColor: '?sbColorSurfaceHigh',
            foregroundColor: '?sbColorOnPrimary',
            activeBackgroundColor: '?sbColorWarning',
            activeForegroundColor: '#1C1B1F',
        });
        /**
          Configuration of the 'zoom' button.
          */
        this.zoomButton = new RoundButton({
            visible: true,
            accessibilityDescription: '?accessibilityDescriptionZoomButton',
            backgroundColor: '?sbColorSurfaceHigh',
            foregroundColor: '?sbColorOnPrimary',
            activeBackgroundColor: '?sbColorSurfaceHigh',
            activeForegroundColor: '?sbColorOnPrimary',
        });
        /**
          Configuration of the 'flip camera' button.
          */
        this.flipCameraButton = new RoundButton({
            visible: true,
            accessibilityDescription: '?accessibilityDescriptionFlipCameraButton',
            backgroundColor: '?sbColorSurfaceHigh',
            foregroundColor: '?sbColorOnPrimary',
            activeBackgroundColor: '?sbColorWarning',
            activeForegroundColor: '#1C1B1F',
        });
        if (source.flashButton !== undefined) {
            this.flashButton = new RoundButton(source.flashButton);
        }
        if (source.zoomButton !== undefined) {
            this.zoomButton = new RoundButton(source.zoomButton);
        }
        if (source.flipCameraButton !== undefined) {
            this.flipCameraButton = new RoundButton(source.flipCameraButton);
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/common/CameraConfiguration.yaml
const CameraModuleValues = ['FRONT', 'BACK', 'BACK_WIDEST'];
/**
Configuration of the camera settings to be used while scanning.
*/
class CameraConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<CameraConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Determines which camera module to use on start-up.
          
          Default is BACK
          */
        this.cameraModule = 'BACK';
        /**
          The zoom steps available to the user.
          */
        this.zoomSteps = [1.0, 2.0, 5.0];
        /**
          The default zoom factor on start-up.
          
          Default is 1.0
          */
        this.defaultZoomFactor = 1.0;
        /**
          Determines whether the flash is enabled on start-up.
          
          Default is false
          */
        this.flashEnabled = false;
        /**
          Determines whether to lock the focus at the minimum possible distance (device-specific).
          
          Default is false
          */
        this.minFocusDistanceLock = false;
        /**
          Determines whether touch-to-focus is enabled or not. Android only.
          
          Default is false
          */
        this.touchToFocusEnabled = false;
        /**
          Determines whether pinch-to-zoom is enabled or not.
          
          Default is true
          */
        this.pinchToZoomEnabled = true;
        /**
          Determines which mode to use when orientation should be locked to landscape or portrait.
          
          Default is NONE
          */
        this.orientationLockMode = 'NONE';
        /**
          Determines which camera preview mode to use.
          
          Default is FILL_IN
          */
        this.cameraPreviewMode = 'FILL_IN';
        if (source.cameraModule !== undefined) {
            this.cameraModule = source.cameraModule;
        }
        if (source.zoomSteps !== undefined) {
            this.zoomSteps = source.zoomSteps.map((it) => {
                return it;
            });
        }
        if (source.defaultZoomFactor !== undefined) {
            this.defaultZoomFactor = source.defaultZoomFactor;
        }
        if (source.flashEnabled !== undefined) {
            this.flashEnabled = source.flashEnabled;
        }
        if (source.minFocusDistanceLock !== undefined) {
            this.minFocusDistanceLock = source.minFocusDistanceLock;
        }
        if (source.touchToFocusEnabled !== undefined) {
            this.touchToFocusEnabled = source.touchToFocusEnabled;
        }
        if (source.pinchToZoomEnabled !== undefined) {
            this.pinchToZoomEnabled = source.pinchToZoomEnabled;
        }
        if (source.orientationLockMode !== undefined) {
            this.orientationLockMode = source.orientationLockMode;
        }
        if (source.cameraPreviewMode !== undefined) {
            this.cameraPreviewMode = source.cameraPreviewMode;
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/common/CameraPermission.yaml
/**
Configuration of the camera permission request view.
*/
class CameraPermissionScreen extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<CameraPermissionScreen>`} */
    constructor(source = {}) {
        super();
        /**
          Determines the visual mode for displaying the contents of the status bar.
          
          Default is DARK
          */
        this.statusBarMode = 'DARK';
        /**
          The background color of the camera permission request.
          
          Default is "?sbColorSurface"
          */
        this.background = '?sbColorSurface';
        /**
          The background color of the icon used in the camera permission request.
          
          Default is "?sbColorOutline"
          */
        this.iconBackground = '?sbColorOutline';
        /**
          Configuration of the icon used in the camera permission request.
          */
        this.icon = new IconStyle({ color: '?sbColorOnSurface' });
        /**
          Configuration of the camera permission request's confirmation button.
          */
        this.enableCameraButton = new ButtonConfiguration({
            text: '?cameraPermissionEnableCameraButton',
            background: new BackgroundStyle({ strokeColor: '?sbColorPrimary', fillColor: '?sbColorPrimary', strokeWidth: 0.0 }),
            foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorOnPrimary' }),
        });
        /**
          Configuration of the camera permission request's close button.
          */
        this.closeButton = new ButtonConfiguration({
            text: '?cameraPermissionCloseButton',
            background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 0.0 }),
            foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorPrimary' }),
        });
        /**
          Configuration of the camera permission request's title.
          */
        this.enableCameraTitle = new StyledText({
            text: '?cameraPermissionEnableCameraTitle',
            color: '?sbColorOnSurface',
        });
        /**
          Configuration of the camera permission request's explanatory text.
          */
        this.enableCameraExplanation = new StyledText({
            text: '?cameraPermissionEnableCameraExplanation',
            color: '?sbColorOnSurfaceVariant',
        });
        if (source.statusBarMode !== undefined) {
            this.statusBarMode = source.statusBarMode;
        }
        if (source.background !== undefined) {
            this.background = source.background;
        }
        if (source.iconBackground !== undefined) {
            this.iconBackground = source.iconBackground;
        }
        if (source.icon !== undefined) {
            this.icon = new IconStyle(source.icon);
        }
        if (source.enableCameraButton !== undefined) {
            this.enableCameraButton = new ButtonConfiguration(source.enableCameraButton);
        }
        if (source.closeButton !== undefined) {
            this.closeButton = new ButtonConfiguration(source.closeButton);
        }
        if (source.enableCameraTitle !== undefined) {
            this.enableCameraTitle = new StyledText(source.enableCameraTitle);
        }
        if (source.enableCameraExplanation !== undefined) {
            this.enableCameraExplanation = new StyledText(source.enableCameraExplanation);
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/common/TopBarConfiguration.yaml
/**
Configuration of the top bar's appearance.
*/
class TopBarConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<TopBarConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Appearance of the top bar's title.
          */
        this.title = new StyledText({ visible: false, text: 'Scan Item', color: '?sbColorOnPrimary' });
        /**
          The visual mode used for the top bar.
          
          Default is SOLID
          */
        this.mode = 'SOLID';
        /**
          The visual mode used for the status bar icons.
          
          Default is LIGHT
          */
        this.statusBarMode = 'LIGHT';
        /**
          The background color of the top bar to be used when the visual mode is specified as SOLID. Otherwise ignored.
          
          Default is "?sbColorPrimary"
          */
        this.backgroundColor = '?sbColorPrimary';
        /**
          Configuration of the 'cancel' button's appearance.
          */
        this.cancelButton = new ButtonConfiguration({
            text: 'Cancel',
            background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 0.0 }),
            foreground: new ForegroundStyle({ color: '?sbColorOnPrimary' }),
        });
        if (source.title !== undefined) {
            this.title = new StyledText(source.title);
        }
        if (source.mode !== undefined) {
            this.mode = source.mode;
        }
        if (source.statusBarMode !== undefined) {
            this.statusBarMode = source.statusBarMode;
        }
        if (source.backgroundColor !== undefined) {
            this.backgroundColor = source.backgroundColor;
        }
        if (source.cancelButton !== undefined) {
            this.cancelButton = new ButtonConfiguration(source.cancelButton);
        }
    }
}
const StatusBarModeValues = ['DARK', 'LIGHT', 'HIDDEN'];
const TopBarModeValues = ['SOLID', 'GRADIENT', 'HIDDEN'];

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/common/UserGuidanceConfiguration.yaml
/**
Configuration of the hint guiding users through the scanning process.
*/
class UserGuidanceConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<UserGuidanceConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Determines whether the user guidance is visible or not.
          
          Default is true
          */
        this.visible = true;
        /**
          The title of the user guidance.
          */
        this.title = new StyledText({ color: '?sbColorOnPrimary' });
        /**
          The background style used for the user guidance.
          */
        this.background = new BackgroundStyle({
            strokeColor: '#00000000',
            fillColor: '?sbColorSurfaceLow',
        });
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.title !== undefined) {
            this.title = new StyledText(source.title);
        }
        if (source.background !== undefined) {
            this.background = new BackgroundStyle(source.background);
        }
    }
}
/**
Configuration of the hint (containing an icon) guiding users through the scanning process.
*/
class IconUserGuidanceConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<IconUserGuidanceConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Determines whether the user guidance is visible or not.
          
          Default is true
          */
        this.visible = true;
        /**
          Configuration of the icon appearance.
          */
        this.icon = new IconStyle({ color: '?sbColorOnPrimary' });
        /**
          The title of the user guidance.
          */
        this.title = new StyledText({ color: '?sbColorOnPrimary' });
        /**
          Configuration of the background appearance for the user guidance hints.
          */
        this.background = new BackgroundStyle({ fillColor: '?sbColorSurfaceLow' });
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
        if (source.icon !== undefined) {
            this.icon = new IconStyle(source.icon);
        }
        if (source.title !== undefined) {
            this.title = new StyledText(source.title);
        }
        if (source.background !== undefined) {
            this.background = new BackgroundStyle(source.background);
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from core/schemas/Geometry.yaml
/**
Represents a line segment in 2D space.
*/
class LineSegmentInt extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<LineSegmentInt>`} */
    constructor(source = {}) {
        super();
        if (source.start !== undefined) {
            this.start = { x: source.start.x, y: source.start.y };
        }
        else {
            throw new Error('start must be present in constructor argument');
        }
        if (source.end !== undefined) {
            this.end = { x: source.end.x, y: source.end.y };
        }
        else {
            throw new Error('end must be present in constructor argument');
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            start: this.start,
            end: this.end,
        };
    }
}
/**
Represents a line segment in 2D space.
*/
class LineSegmentFloat extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<LineSegmentFloat>`} */
    constructor(source = {}) {
        super();
        if (source.start !== undefined) {
            this.start = { x: source.start.x, y: source.start.y };
        }
        else {
            throw new Error('start must be present in constructor argument');
        }
        if (source.end !== undefined) {
            this.end = { x: source.end.x, y: source.end.y };
        }
        else {
            throw new Error('end must be present in constructor argument');
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            start: this.start,
            end: this.end,
        };
    }
}
/**
Aspect ratio is the ratio of the width to the height of an image or screen.
*/
class AspectRatio extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<AspectRatio>`} */
    constructor(source = {}) {
        super();
        /**
          Width component of the aspect ratio.
          
          Default is 1.0
          */
        this.width = 1.0;
        /**
          Height component of the aspect ratio.
          
          Default is 1.0
          */
        this.height = 1.0;
        if (source.width !== undefined) {
            this.width = source.width;
        }
        if (source.height !== undefined) {
            this.height = source.height;
        }
    }
    serialize(config = new ToJsonConfiguration()) {
        return {
            width: this.width,
            height: this.height,
        };
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/common/ViewFinderConfiguration.yaml
/** @internal */
exports.BaseViewFinderConfiguration = void 0;
(function (BaseViewFinderConfiguration) {
    /** @internal */
    function From(source) {
        const _type = source['_type'];
        switch (_type) {
            case 'ViewFinderConfiguration':
                return new ViewFinderConfiguration(source);
            case 'PermanentViewFinderConfiguration':
                return new PermanentViewFinderConfiguration(source);
            default:
                throw `Unknown child class name: ${_type}`;
        }
    }
    BaseViewFinderConfiguration.From = From;
})(exports.BaseViewFinderConfiguration || (exports.BaseViewFinderConfiguration = {}));
/**
Configuration of the scanning interface’s viewfinder, allowing it to be shown or hidden as guidance to the user.
*/
class ViewFinderConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ViewFinderConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'ViewFinderConfiguration';
        /**
          The visual appearance of the viewfinder.
          */
        this.style = new FinderCorneredStyle({
            strokeColor: '?sbColorSurface',
            strokeWidth: 2.0,
            cornerRadius: 10.0,
        });
        /**
          The color of the viewfinder overlay.
          
          Default is "?sbColorSurfaceLow"
          */
        this.overlayColor = '?sbColorSurfaceLow';
        /**
          The viewfinder's aspect ratio.
          */
        this.aspectRatio = new AspectRatio({ width: 1.0, height: 1.0 });
        /**
          The minimum insets of the viewfinder.
          */
        this.minimumInsets = new EdgeInsets({ top: 16.0, left: 16.0, bottom: 16.0, right: 16.0 });
        /**
          The preferred height of the viewfinder.
          
          Default is -1.0
          */
        this.preferredHeight = -1;
        /**
          Whether the viewfinder is visible.
          
          Default is true
          */
        this.visible = true;
        if (source.style !== undefined) {
            this.style = exports.FinderStyle.From(source.style);
        }
        if (source.overlayColor !== undefined) {
            this.overlayColor = source.overlayColor;
        }
        if (source.aspectRatio !== undefined) {
            this.aspectRatio = new AspectRatio(source.aspectRatio);
        }
        if (source.minimumInsets !== undefined) {
            this.minimumInsets = new EdgeInsets(source.minimumInsets);
        }
        if (source.preferredHeight !== undefined) {
            this.preferredHeight = source.preferredHeight;
        }
        if (source.visible !== undefined) {
            this.visible = source.visible;
        }
    }
}
/**
Configuration of the scanning interface’s viewfinder, which is always visible to guide the user.
*/
class PermanentViewFinderConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<PermanentViewFinderConfiguration>`} */
    constructor(source = {}) {
        super();
        this._type = 'PermanentViewFinderConfiguration';
        /**
          The visual appearance of the viewfinder.
          */
        this.style = new FinderCorneredStyle({
            strokeColor: '?sbColorSurface',
            strokeWidth: 2.0,
            cornerRadius: 10.0,
        });
        /**
          The color of the viewfinder overlay.
          
          Default is "?sbColorSurfaceLow"
          */
        this.overlayColor = '?sbColorSurfaceLow';
        /**
          The viewfinder's aspect ratio.
          */
        this.aspectRatio = new AspectRatio({ width: 1.0, height: 1.0 });
        /**
          The minimum insets of the viewfinder.
          */
        this.minimumInsets = new EdgeInsets({ top: 16.0, left: 16.0, bottom: 16.0, right: 16.0 });
        /**
          The preferred height of the viewfinder.
          
          Default is -1.0
          */
        this.preferredHeight = -1;
        if (source.style !== undefined) {
            this.style = exports.FinderStyle.From(source.style);
        }
        if (source.overlayColor !== undefined) {
            this.overlayColor = source.overlayColor;
        }
        if (source.aspectRatio !== undefined) {
            this.aspectRatio = new AspectRatio(source.aspectRatio);
        }
        if (source.minimumInsets !== undefined) {
            this.minimumInsets = new EdgeInsets(source.minimumInsets);
        }
        if (source.preferredHeight !== undefined) {
            this.preferredHeight = source.preferredHeight;
        }
    }
}
/** @internal */
exports.FinderStyle = void 0;
(function (FinderStyle) {
    /** @internal */
    function From(source) {
        const _type = source['_type'];
        switch (_type) {
            case 'FinderCorneredStyle':
                return new FinderCorneredStyle(source);
            case 'FinderStrokedStyle':
                return new FinderStrokedStyle(source);
            default:
                throw `Unknown child class name: ${_type}`;
        }
    }
    FinderStyle.From = From;
})(exports.FinderStyle || (exports.FinderStyle = {}));
/**
A variant of the viewfinder displaying only the four corners of the scanning area.
*/
class FinderCorneredStyle extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<FinderCorneredStyle>`} */
    constructor(source = {}) {
        super();
        this._type = 'FinderCorneredStyle';
        /**
          The color of the viewfinder corner's outlines.
          
          Default is "#FFFFFFFF"
          */
        this.strokeColor = '#FFFFFFFF';
        /**
          The width of the viewfinder corner's outlines.
          
          Default is 3.0
          */
        this.strokeWidth = 3.0;
        /**
          The radius of the viewfinder's corners.
          
          Default is 10.0
          */
        this.cornerRadius = 10.0;
        if (source.strokeColor !== undefined) {
            this.strokeColor = source.strokeColor;
        }
        if (source.strokeWidth !== undefined) {
            this.strokeWidth = source.strokeWidth;
        }
        if (source.cornerRadius !== undefined) {
            this.cornerRadius = source.cornerRadius;
        }
    }
}
/**
A variant of the viewfinder displaying a full outline of the scanning area.
*/
class FinderStrokedStyle extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<FinderStrokedStyle>`} */
    constructor(source = {}) {
        super();
        this._type = 'FinderStrokedStyle';
        /**
          The color of the viewfinder corner's outlines.
          
          Default is "#FFFFFFFF"
          */
        this.strokeColor = '#FFFFFFFF';
        /**
          The width of the viewfinder corner's outlines.
          
          Default is 3.0
          */
        this.strokeWidth = 3.0;
        /**
          The radius of the viewfinder's corners.
          
          Default is 10.0
          */
        this.cornerRadius = 10.0;
        if (source.strokeColor !== undefined) {
            this.strokeColor = source.strokeColor;
        }
        if (source.strokeWidth !== undefined) {
            this.strokeWidth = source.strokeWidth;
        }
        if (source.cornerRadius !== undefined) {
            this.cornerRadius = source.cornerRadius;
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/barcode/BarcodeScannerScreenConfiguration.yaml
/**
Configuration of the barcode scanner screen.
*/
class BarcodeScannerScreenConfiguration extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeScannerScreenConfiguration>`} */
    constructor(source = {}) {
        super();
        /**
          Version number of the configuration object.
          
          Default is "1.0"
          */
        this.version = '1.0';
        /**
          The configuration object should be applied for this screen.
          
          Default is "BarcodeScanner"
          */
        this.screen = 'BarcodeScanner';
        /**
          Define the screen's base color values from which other colors are derived.
          */
        this.palette = new Palette({
            sbColorPrimary: '#C8193C',
            sbColorPrimaryDisabled: '#F5F5F5',
            sbColorNegative: '#FF3737',
            sbColorPositive: '#4EFFB4',
            sbColorWarning: '#FFCE5C',
            sbColorSecondary: '#FFEDEE',
            sbColorSecondaryDisabled: '#F5F5F5',
            sbColorOnPrimary: '#FFFFFF',
            sbColorOnSecondary: '#C8193C',
            sbColorSurface: '#FFFFFF',
            sbColorOutline: '#EFEFEF',
            sbColorOnSurfaceVariant: '#707070',
            sbColorOnSurface: '#000000',
            sbColorSurfaceLow: '#00000026',
            sbColorSurfaceHigh: '#0000007A',
            sbColorModalOverlay: '#000000A3',
        });
        /**
          Configuration of the all strings for barcode scanner.
          */
        this.localization = new BarcodeTextLocalization({});
        /**
          Color of the screen's background.
          
          Default is "?sbColorSurfaceLow"
          */
        this.backgroundColor = '?sbColorSurfaceLow';
        /**
          Configuration of the top bar.
          */
        this.topBar = new TopBarConfiguration({
            title: new StyledText({ text: '?topBarTitle', color: '?sbColorOnPrimary' }),
            mode: 'SOLID',
            statusBarMode: 'LIGHT',
            backgroundColor: '?sbColorPrimary',
            cancelButton: new ButtonConfiguration({
                visible: true,
                text: '?topBarCancelButton',
                accessibilityDescription: '?accessibilityDescriptionCancelButton',
                background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 0.0 }),
                foreground: new ForegroundStyle({ iconVisible: true, color: '?sbColorOnPrimary', useShadow: false }),
            }),
        });
        /**
          Configuration of the action bar.
          */
        this.actionBar = new ActionBarConfiguration({
            flashButton: new RoundButton({
                visible: true,
                accessibilityDescription: '?accessibilityDescriptionFlashButton',
                backgroundColor: '?sbColorSurfaceHigh',
                foregroundColor: '?sbColorOnPrimary',
                activeBackgroundColor: '?sbColorWarning',
                activeForegroundColor: '#1C1B1F',
            }),
            zoomButton: new RoundButton({
                visible: true,
                accessibilityDescription: '?accessibilityDescriptionZoomButton',
                backgroundColor: '?sbColorSurfaceHigh',
                foregroundColor: '?sbColorOnPrimary',
                activeBackgroundColor: '?sbColorSurfaceHigh',
                activeForegroundColor: '?sbColorOnPrimary',
            }),
            flipCameraButton: new RoundButton({
                visible: true,
                accessibilityDescription: '?accessibilityDescriptionFlipCameraButton',
                backgroundColor: '?sbColorSurfaceHigh',
                foregroundColor: '?sbColorOnPrimary',
                activeBackgroundColor: '?sbColorWarning',
                activeForegroundColor: '#1C1B1F',
            }),
        });
        /**
          Configuration of the view finder.
          */
        this.viewFinder = new ViewFinderConfiguration({
            style: new FinderCorneredStyle({ strokeColor: '?sbColorSurface', strokeWidth: 2.0, cornerRadius: 10.0 }),
            overlayColor: '?sbColorSurfaceLow',
            aspectRatio: new AspectRatio({ width: 1.0, height: 1.0 }),
            visible: true,
        });
        /**
          Configuration of the text hint guiding users to move the view finder over a barcode.
          */
        this.userGuidance = new UserGuidanceConfiguration({
            visible: true,
            title: new StyledText({ text: '?userGuidance', color: '?sbColorOnPrimary' }),
            background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '?sbColorSurfaceLow', strokeWidth: 0.0 }),
        });
        /**
          Configuration of the dialog for requesting camera permissions.
          */
        this.cameraPermission = new CameraPermissionScreen({
            statusBarMode: 'DARK',
            background: '?sbColorSurface',
            iconBackground: '?sbColorOutline',
            icon: new IconStyle({ visible: true, color: '?sbColorOnSurface' }),
            enableCameraButton: new ButtonConfiguration({
                visible: true,
                text: '?cameraPermissionEnableCameraButton',
                accessibilityDescription: '?accessibilityDescriptionCameraPermissionEnableCameraButton',
                background: new BackgroundStyle({
                    strokeColor: '?sbColorPrimary',
                    fillColor: '?sbColorPrimary',
                    strokeWidth: 0.0,
                }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorOnPrimary', useShadow: false }),
            }),
            closeButton: new ButtonConfiguration({
                visible: true,
                text: '?cameraPermissionCloseButton',
                accessibilityDescription: '?accessibilityDescriptionCameraPermissionCloseButton',
                background: new BackgroundStyle({ strokeColor: '#00000000', fillColor: '#00000000', strokeWidth: 0.0 }),
                foreground: new ForegroundStyle({ iconVisible: false, color: '?sbColorPrimary', useShadow: false }),
            }),
            enableCameraTitle: new StyledText({ text: '?cameraPermissionEnableCameraTitle', color: '?sbColorOnSurface' }),
            enableCameraExplanation: new StyledText({
                text: '?cameraPermissionEnableCameraExplanation',
                color: '?sbColorOnSurfaceVariant',
            }),
        });
        /**
          Configuration of the camera behavior.
          */
        this.cameraConfiguration = new CameraConfiguration({});
        /**
          Configuration of the scanning behavior.
          */
        this.scannerConfiguration = new CommonBarcodeScannerConfiguration({});
        /**
          Configuration of the barcode scanner screen's behavior.
          */
        this.useCase = new SingleScanningMode({});
        /**
          Configuration of the scan confirmation sound.
          */
        this.sound = new Sound({ successBeepEnabled: true, soundType: 'MODERN_BEEP' });
        /**
          Configuration of the scan scan confirmation vibration.
          */
        this.vibration = new Vibration({ enabled: true });
        /**
          Configuration of timeouts.
          */
        this.timeouts = new Timeouts({ autoCancelTimeout: 0, initialScanDelay: 0 });
        /**
          If enabled, the screen will not turn off while the barcode scanner is active. (Android only).
          
          Default is true
          */
        this.keepScreenOn = true;
        if (source.version !== undefined) {
            this.version = source.version;
        }
        if (source.screen !== undefined) {
            this.screen = source.screen;
        }
        if (source.palette !== undefined) {
            this.palette = new Palette(source.palette);
        }
        if (source.localization !== undefined) {
            this.localization = new BarcodeTextLocalization(source.localization);
        }
        if (source.backgroundColor !== undefined) {
            this.backgroundColor = source.backgroundColor;
        }
        if (source.topBar !== undefined) {
            this.topBar = new TopBarConfiguration(source.topBar);
        }
        if (source.actionBar !== undefined) {
            this.actionBar = new ActionBarConfiguration(source.actionBar);
        }
        if (source.viewFinder !== undefined) {
            this.viewFinder = new ViewFinderConfiguration(source.viewFinder);
        }
        if (source.userGuidance !== undefined) {
            this.userGuidance = new UserGuidanceConfiguration(source.userGuidance);
        }
        if (source.cameraPermission !== undefined) {
            this.cameraPermission = new CameraPermissionScreen(source.cameraPermission);
        }
        if (source.cameraConfiguration !== undefined) {
            this.cameraConfiguration = new CameraConfiguration(source.cameraConfiguration);
        }
        if (source.scannerConfiguration !== undefined) {
            this.scannerConfiguration = new CommonBarcodeScannerConfiguration(source.scannerConfiguration);
        }
        if (source.useCase !== undefined) {
            this.useCase = exports.BarcodeUseCase.From(source.useCase);
        }
        if (source.sound !== undefined) {
            this.sound = new Sound(source.sound);
        }
        if (source.vibration !== undefined) {
            this.vibration = new Vibration(source.vibration);
        }
        if (source.timeouts !== undefined) {
            this.timeouts = new Timeouts(source.timeouts);
        }
        if (source.keepScreenOn !== undefined) {
            this.keepScreenOn = source.keepScreenOn;
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/barcode/BarcodeScannerUIResult.yaml
/**
Data about the scanned barcode.
*/
class BarcodeScannerUiItem extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeScannerUiItem>`} */
    constructor(source = {}) {
        super();
        this._released = false;
        if (source.barcode !== undefined) {
            this.barcode = new BarcodeItem(source.barcode);
        }
        else {
            throw new Error('barcode must be present in constructor argument');
        }
        if (source.count !== undefined) {
            this.count = source.count;
        }
        else {
            throw new Error('count must be present in constructor argument');
        }
    }
    async serialize(config = new ToJsonConfiguration()) {
        return {
            barcode: await this.barcode.serialize(config),
            count: this.count,
        };
    }
    release() {
        if (this._released) {
            return;
        }
        this.barcode.release();
        this._released = true;
    }
    async encodeImages() {
        await this.barcode.encodeImages();
    }
}
/**
Results of the barcode scan.
*/
class BarcodeScannerUiResult extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeScannerUiResult>`} */
    constructor(source = {}) {
        super();
        /**
          Scanned barcode items.
          */
        this.items = [];
        this._released = false;
        if (source.items !== undefined) {
            this.items = source.items.map((it) => {
                return new BarcodeScannerUiItem(it);
            });
        }
    }
    async serialize(config = new ToJsonConfiguration()) {
        return {
            items: await Promise.all(this.items.map(async (it) => {
                return await it.serialize(config);
            })),
        };
    }
    release() {
        if (this._released) {
            return;
        }
        this.items.forEach((it) => {
            it.release();
        });
        this._released = true;
    }
    async encodeImages() {
        await Promise.all(this.items.map(async (it) => {
            await it.encodeImages();
        }));
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/common/NavigationBarConfiguration.yaml
const NavigationBarModeValues = ['DARK', 'LIGHT', 'HIDDEN'];

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from rtu-ui-v2/schemas/common/ScanCompletionOverlay.yaml
/**
Configuration of the overlay to be shown after the successful scan.
*/
class ScanCompletionOverlay extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<ScanCompletionOverlay>`} */
    constructor(source = {}) {
        super();
        /**
          A caption below the icon.
          */
        this.message = new StyledText({ text: '?completionOverlaySuccessMessage', color: '?sbColorOnPrimary' });
        /**
          Color of the icon.
          
          Default is "?sbColorOnPrimary"
          */
        this.iconColor = '?sbColorOnPrimary';
        /**
          Background color of the overlay.
          
          Default is "?sbColorSurfaceHigh"
          */
        this.overlayBackgroundColor = '?sbColorSurfaceHigh';
        /**
          Timeout in milliseconds after which the overlay is automatically dismissed.
          
          Default is 1000
          */
        this.timeout = 1000;
        if (source.message !== undefined) {
            this.message = new StyledText(source.message);
        }
        if (source.iconColor !== undefined) {
            this.iconColor = source.iconColor;
        }
        if (source.overlayBackgroundColor !== undefined) {
            this.overlayBackgroundColor = source.overlayBackgroundColor;
        }
        if (source.timeout !== undefined) {
            this.timeout = source.timeout;
        }
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from core/schemas/BarcodeDocumentTypes.yaml
const BarcodeDocumentFormatValues = [
    'AAMVA',
    'BOARDING_PASS',
    'DE_MEDICAL_PLAN',
    'MEDICAL_CERTIFICATE',
    'ID_CARD_PDF_417',
    'SEPA',
    'SWISS_QR',
    'VCARD',
    'GS1',
    'HIBC',
];
/**
Barcode document formats.
*/
class BarcodeDocumentFormats extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeDocumentFormats>`} */
    constructor(source = {}) {
        super();
    }
    serialize(config = new ToJsonConfiguration()) {
        return {};
    }
}
(function (BarcodeDocumentFormats) {
    /**
      All barcode document formats.
      */
    BarcodeDocumentFormats.all = [
        'AAMVA',
        'BOARDING_PASS',
        'DE_MEDICAL_PLAN',
        'MEDICAL_CERTIFICATE',
        'ID_CARD_PDF_417',
        'SEPA',
        'SWISS_QR',
        'VCARD',
        'GS1',
        'HIBC',
    ];
    /**
      Barcode types that are used to encode documents.
      */
    BarcodeDocumentFormats.documentBarcodeFormats = {
        AAMVA: ['PDF_417'],
        ID_CARD_PDF_417: ['PDF_417'],
        SEPA: ['QR_CODE'],
        MEDICAL_CERTIFICATE: ['PDF_417'],
        DE_MEDICAL_PLAN: ['DATA_MATRIX'],
        BOARDING_PASS: ['PDF_417', 'AZTEC', 'QR_CODE'],
        VCARD: ['QR_CODE', 'DATA_MATRIX'],
        SWISS_QR: ['QR_CODE'],
        GS1: [
            'CODE_128',
            'AZTEC',
            'DATA_MATRIX',
            'DATABAR',
            'DATABAR_EXPANDED',
            'DATABAR_LIMITED',
            'EAN_13',
            'EAN_8',
            'GS1_COMPOSITE',
            'ITF',
            'MICRO_PDF_417',
            'PDF_417',
            'QR_CODE',
            'UPC_A',
            'UPC_E',
        ],
        HIBC: ['CODE_39', 'CODE_128', 'AZTEC', 'DATA_MATRIX', 'MICRO_PDF_417', 'PDF_417', 'QR_CODE'],
    };
})(BarcodeDocumentFormats || (BarcodeDocumentFormats = {}));

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from core/schemas/BarcodeTypes.yaml
const BarcodeFormatValues = [
    'NONE',
    'AZTEC',
    'CODABAR',
    'CODE_39',
    'CODE_93',
    'CODE_128',
    'DATA_MATRIX',
    'EAN_8',
    'EAN_13',
    'ITF',
    'MAXI_CODE',
    'PDF_417',
    'QR_CODE',
    'DATABAR',
    'DATABAR_EXPANDED',
    'UPC_A',
    'UPC_E',
    'MSI_PLESSEY',
    'IATA_2_OF_5',
    'INDUSTRIAL_2_OF_5',
    'CODE_25',
    'MICRO_QR_CODE',
    'USPS_INTELLIGENT_MAIL',
    'ROYAL_MAIL',
    'JAPAN_POST',
    'ROYAL_TNT_POST',
    'AUSTRALIA_POST',
    'DATABAR_LIMITED',
    'MICRO_PDF_417',
    'GS1_COMPOSITE',
    'RMQR_CODE',
    'CODE_11',
    'CODE_32',
    'PHARMA_CODE',
    'PHARMA_CODE_TWO_TRACK',
    'PZN_7',
    'PZN_8',
];
/**
Lists of barcode formats to decode.
*/
class BarcodeFormats extends PartiallyConstructible {
    /** @param source {@displayType `DeepPartial<BarcodeFormats>`} */
    constructor(source = {}) {
        super();
    }
    serialize(config = new ToJsonConfiguration()) {
        return {};
    }
}
(function (BarcodeFormats) {
    /**
      List of 1D barcode formats.
      */
    BarcodeFormats.oned = [
        'CODABAR',
        'CODE_11',
        'CODE_25',
        'CODE_32',
        'CODE_39',
        'CODE_93',
        'CODE_128',
        'DATABAR',
        'DATABAR_EXPANDED',
        'DATABAR_LIMITED',
        'EAN_8',
        'EAN_13',
        'IATA_2_OF_5',
        'INDUSTRIAL_2_OF_5',
        'ITF',
        'MSI_PLESSEY',
        'PHARMA_CODE',
        'PZN_7',
        'PZN_8',
        'UPC_A',
        'UPC_E',
    ];
    /**
      List of 2D barcode formats.
      */
    BarcodeFormats.twod = [
        'AZTEC',
        'DATA_MATRIX',
        'MAXI_CODE',
        'MICRO_QR_CODE',
        'MICRO_PDF_417',
        'PDF_417',
        'QR_CODE',
        'RMQR_CODE',
    ];
    /**
      List of postal barcode formats.
      */
    BarcodeFormats.postal = [
        'AUSTRALIA_POST',
        'JAPAN_POST',
        'ROYAL_MAIL',
        'ROYAL_TNT_POST',
        'USPS_INTELLIGENT_MAIL',
    ];
    /**
      List of pharmaceutical barcode formats.
      */
    BarcodeFormats.pharma = ['CODE_32', 'PHARMA_CODE', 'PHARMA_CODE_TWO_TRACK', 'PZN_7', 'PZN_8'];
    /**
      List of common barcode formats.
      */
    BarcodeFormats.common = [
        'AZTEC',
        'CODABAR',
        'CODE_39',
        'CODE_93',
        'CODE_128',
        'DATA_MATRIX',
        'DATABAR',
        'DATABAR_EXPANDED',
        'DATABAR_LIMITED',
        'EAN_13',
        'EAN_8',
        'ITF',
        'MICRO_QR_CODE',
        'PDF_417',
        'QR_CODE',
        'UPC_A',
        'UPC_E',
    ];
    /**
      List of all barcode formats.
      */
    BarcodeFormats.all = [
        'AUSTRALIA_POST',
        'AZTEC',
        'CODABAR',
        'CODE_11',
        'CODE_25',
        'CODE_32',
        'CODE_39',
        'CODE_93',
        'CODE_128',
        'DATA_MATRIX',
        'DATABAR',
        'DATABAR_EXPANDED',
        'DATABAR_LIMITED',
        'EAN_13',
        'EAN_8',
        'GS1_COMPOSITE',
        'IATA_2_OF_5',
        'INDUSTRIAL_2_OF_5',
        'ITF',
        'JAPAN_POST',
        'MAXI_CODE',
        'MICRO_PDF_417',
        'MICRO_QR_CODE',
        'MSI_PLESSEY',
        'PDF_417',
        'PHARMA_CODE',
        'PHARMA_CODE_TWO_TRACK',
        'PZN_7',
        'PZN_8',
        'QR_CODE',
        'RMQR_CODE',
        'ROYAL_MAIL',
        'ROYAL_TNT_POST',
        'UPC_A',
        'UPC_E',
        'USPS_INTELLIGENT_MAIL',
    ];
})(BarcodeFormats || (BarcodeFormats = {}));
const Gs1HandlingValues = [
    'PARSE',
    'VALIDATE_STRUCTURE',
    'DECODE_STRUCTURE',
    'VALIDATE_FULL',
    'DECODE_FULL',
];
const UpcEanExtensionBehaviorValues = [
    'REQUIRE_2',
    'REQUIRE_5',
    'REQUIRE_ANY',
    'IGNORE',
    'ALLOW_2',
    'ALLOW_5',
    'ALLOW_ANY',
];

/// Auto-generated. Modifications will be overwritten.
/// Generated from core/document-schemas/BarcodeDocumentModel.yaml
const BoardingPassDocumentType = 'BoardingPass';
const BoardingPassLegDocumentType = 'Leg';
const SwissQRDocumentType = 'SwissQR';
const DEMedicalPlanDocumentType = 'DEMedicalPlan';
const DEMedicalPlanPatientDocumentType = 'Patient';
const DEMedicalPlanDoctorDocumentType = 'Doctor';
const DEMedicalPlanSubheadingDocumentType = 'Subheading';
const DEMedicalPlanSubheadingMedicineDocumentType = 'Medicine';
const DEMedicalPlanSubheadingMedicineSubstanceDocumentType = 'Substance';
const DEMedicalPlanSubheadingPrescriptionDocumentType = 'Prescription';
const IDCardPDF417DocumentType = 'IDCardPDF417';
const GS1DocumentType = 'GS1';
const GS1ElementDocumentType = 'Element';
const GS1ElementValidationErrorDocumentType = 'ValidationError';
const SEPADocumentType = 'SEPA';
const MedicalCertificateDocumentType = 'MedicalCertificate';
const VCardDocumentType = 'VCard';
const VCardEntryDocumentType = 'Entry';
const VCardVersionDocumentType = 'Version';
const VCardSourceDocumentType = 'Source';
const VCardKindDocumentType = 'Kind';
const VCardXMLDocumentType = 'XML';
const VCardNameDocumentType = 'Name';
const VCardFirstNameDocumentType = 'FirstName';
const VCardNicknameDocumentType = 'Nickname';
const VCardBirthdayDocumentType = 'Birthday';
const VCardAnniversaryDocumentType = 'Anniversary';
const VCardGenderDocumentType = 'Gender';
const VCardDeliveryAddressDocumentType = 'DeliveryAddress';
const VCardPhotoDocumentType = 'Photo';
const VCardTelephoneNumberDocumentType = 'TelephoneNumber';
const VCardEmailDocumentType = 'Email';
const VCardIMPPDocumentType = 'IMPP';
const VCardLanguagesDocumentType = 'Languages';
const VCardTimeZoneDocumentType = 'TimeZone';
const VCardGeoLocationDocumentType = 'GeoLocation';
const VCardTitleDocumentType = 'Title';
const VCardRoleDocumentType = 'Role';
const VCardLogoDocumentType = 'Logo';
const VCardOrganisationDocumentType = 'Organisation';
const VCardMemberDocumentType = 'Member';
const VCardRelatedDocumentType = 'Related';
const VCardCategoriesDocumentType = 'Categories';
const VCardNoteDocumentType = 'Note';
const VCardProductIdDocumentType = 'ProductId';
const VCardRevisionDocumentType = 'Revision';
const VCardSoundDocumentType = 'Sound';
const VCardUIDDocumentType = 'UID';
const VCardClientPIDMapDocumentType = 'ClientPIDMap';
const VCardURLDocumentType = 'URL';
const VCardPublicKeyDocumentType = 'PublicKey';
const VCardBusyTimeURLDocumentType = 'BusyTimeURL';
const VCardCalendarURIForRequestsDocumentType = 'CalendarURIForRequests';
const VCardCalendarURIDocumentType = 'CalendarURI';
const VCardCustomDocumentType = 'Custom';
const AAMVADocumentType = 'AAMVA';
const AAMVATitleDataDocumentType = 'TitleData';
const AAMVARegistrationDataDocumentType = 'RegistrationData';
const AAMVAMotorCarrierDataDocumentType = 'MotorCarrierData';
const AAMVARegistrantAndVehicleDataDocumentType = 'RegistrantAndVehicleData';
const AAMVAVehicleOwnerDataDocumentType = 'VehicleOwnerData';
const AAMVAVehicleDataDocumentType = 'VehicleData';
const AAMVAVehicleSafetyInspectionDataDocumentType = 'VehicleSafetyInspectionData';
const AAMVADLIDDocumentType = 'DLID';
const AAMVADriverLicenseDocumentType = 'DriverLicense';
const AAMVAIDCardDocumentType = 'IDCard';
const AAMVAEnhancedDriverLicenseDocumentType = 'EnhancedDriverLicense';
const AAMVARawDocumentDocumentType = 'RawDocument';
const HIBCDocumentType = 'HIBC';
/** Boarding Pass */
class BoardingPass {
    get document() {
        return this._document;
    }
    constructor(document) {
        if (document.type.name !== this.requiredDocumentType()) {
            throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
        }
        this._document = document;
    }
    requiredDocumentType() {
        return BoardingPassDocumentType;
    }
    /** Electronic Ticket */
    get electronicTicket() {
        return this.document.fields.find((f) => f.type.name === 'ElectronicTicket');
    }
    /** Name */
    get name() {
        return this.document.fields.find((f) => f.type.name === 'Name');
    }
    /** Number Of Legs */
    get numberOfLegs() {
        return this.document.fields.find((f) => f.type.name === 'NumberOfLegs');
    }
    /** Security Data */
    get securityData() {
        return this.document.fields.find((f) => f.type.name === 'SecurityData');
    }
    /** An array of all children of type "Leg". */
    get legs() {
        return this.document.children
            .filter((c) => c.type.name === 'Leg')
            .map((c) => new BoardingPass.Leg(c));
    }
}
(function (BoardingPass) {
    /** Leg of the journey */
    class Leg {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        requiredDocumentType() {
            return BoardingPassLegDocumentType;
        }
        /** Airline Designator Of Boarding Pass Issuer */
        get airlineDesignatorOfBoardingPassIssuer() {
            return this.document.fields.find((f) => f.type.name === 'AirlineDesignatorOfBoardingPassIssuer');
        }
        /** Airline Numeric Code */
        get airlineNumericCode() {
            return this.document.fields.find((f) => f.type.name === 'AirlineNumericCode');
        }
        /** Baggage Tag License Plate Numbers */
        get baggageTagLicensePlateNumbers() {
            return this.document.fields.find((f) => f.type.name === 'BaggageTagLicensePlateNumbers');
        }
        /** Check In Sequence Number */
        get checkInSequenceNumber() {
            return this.document.fields.find((f) => f.type.name === 'CheckInSequenceNumber');
        }
        /** Compartment Code */
        get compartmentCode() {
            return this.document.fields.find((f) => f.type.name === 'CompartmentCode');
        }
        /** Date Of Boarding Pass Issuance Julian */
        get dateOfBoardingPassIssuanceJulian() {
            return this.document.fields.find((f) => f.type.name === 'DateOfBoardingPassIssuanceJulian');
        }
        /** Date Of Flight Julian */
        get dateOfFlightJulian() {
            return this.document.fields.find((f) => f.type.name === 'DateOfFlightJulian');
        }
        /** Departure Airport Code */
        get departureAirportCode() {
            return this.document.fields.find((f) => f.type.name === 'DepartureAirportCode');
        }
        /** Destination Airport Code */
        get destinationAirportCode() {
            return this.document.fields.find((f) => f.type.name === 'DestinationAirportCode');
        }
        /** Document Form Serial Number */
        get documentFormSerialNumber() {
            return this.document.fields.find((f) => f.type.name === 'DocumentFormSerialNumber');
        }
        /** Document Type */
        get documentType() {
            return this.document.fields.find((f) => f.type.name === 'DocumentType');
        }
        /** Fast Track */
        get fastTrack() {
            return this.document.fields.find((f) => f.type.name === 'FastTrack');
        }
        /** First Non Consecutive Baggage Tag License Plate Number */
        get firstNonConsecutiveBaggageTagLicensePlateNumber() {
            return this.document.fields.find((f) => f.type.name === 'FirstNonConsecutiveBaggageTagLicensePlateNumber');
        }
        /** Flight Number */
        get flightNumber() {
            return this.document.fields.find((f) => f.type.name === 'FlightNumber');
        }
        /** For Individual Airline Use */
        get forIndividualAirlineUse() {
            return this.document.fields.find((f) => f.type.name === 'ForIndividualAirlineUse');
        }
        /** Free Baggage Allowance */
        get freeBaggageAllowance() {
            return this.document.fields.find((f) => f.type.name === 'FreeBaggageAllowance');
        }
        /** Frequent Flyer Airline Designator */
        get frequentFlyerAirlineDesignator() {
            return this.document.fields.find((f) => f.type.name === 'FrequentFlyerAirlineDesignator');
        }
        /** Frequent Flyer Number */
        get frequentFlyerNumber() {
            return this.document.fields.find((f) => f.type.name === 'FrequentFlyerNumber');
        }
        /** IDAD Indicator */
        get idadIndicator() {
            return this.document.fields.find((f) => f.type.name === 'IDADIndicator');
        }
        /** International Documentation Verification */
        get internationalDocumentationVerification() {
            return this.document.fields.find((f) => f.type.name === 'InternationalDocumentationVerification');
        }
        /** Marketing Carrier Designator */
        get marketingCarrierDesignator() {
            return this.document.fields.find((f) => f.type.name === 'MarketingCarrierDesignator');
        }
        /** Operating Carrier Designator */
        get operatingCarrierDesignator() {
            return this.document.fields.find((f) => f.type.name === 'OperatingCarrierDesignator');
        }
        /** Operating Carrier PNR Code */
        get operatingCarrierPNRCode() {
            return this.document.fields.find((f) => f.type.name === 'OperatingCarrierPNRCode');
        }
        /** Passenger Description */
        get passengerDescription() {
            return this.document.fields.find((f) => f.type.name === 'PassengerDescription');
        }
        /** Passenger Status */
        get passengerStatus() {
            return this.document.fields.find((f) => f.type.name === 'PassengerStatus');
        }
        /** Seat Number */
        get seatNumber() {
            return this.document.fields.find((f) => f.type.name === 'SeatNumber');
        }
        /** Second Non Consecutive Baggage Tag License Plate Number */
        get secondNonConsecutiveBaggageTagLicensePlateNumber() {
            return this.document.fields.find((f) => f.type.name === 'SecondNonConsecutiveBaggageTagLicensePlateNumber');
        }
        /** Selectee Indicator */
        get selecteeIndicator() {
            return this.document.fields.find((f) => f.type.name === 'SelecteeIndicator');
        }
        /** Source Of Boarding Pass Issuance */
        get sourceOfBoardingPassIssuance() {
            return this.document.fields.find((f) => f.type.name === 'SourceOfBoardingPassIssuance');
        }
        /** Source Of Check In */
        get sourceOfCheckIn() {
            return this.document.fields.find((f) => f.type.name === 'SourceOfCheckIn');
        }
        /** VersionNumber */
        get versionNumber() {
            return this.document.fields.find((f) => f.type.name === 'VersionNumber');
        }
    }
    BoardingPass.Leg = Leg;
})(BoardingPass || (BoardingPass = {}));
/** SwissQR */
class SwissQR {
    get document() {
        return this._document;
    }
    constructor(document) {
        if (document.type.name !== this.requiredDocumentType()) {
            throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
        }
        this._document = document;
    }
    requiredDocumentType() {
        return SwissQRDocumentType;
    }
    /** Additional Billing Information */
    get additionalBillingInformation() {
        return this.document.fields.find((f) => f.type.name === 'AdditionalBillingInformation');
    }
    /** Additional Info Trailer */
    get additionalInfoTrailer() {
        return this.document.fields.find((f) => f.type.name === 'AdditionalInfoTrailer');
    }
    /** Additional Info Unstructured */
    get additionalInfoUnstructured() {
        return this.document.fields.find((f) => f.type.name === 'AdditionalInfoUnstructured');
    }
    /** Alternative Procedure Parameter */
    get alternativeProcedureParameter() {
        return this.document.fields.find((f) => f.type.name === 'AlternativeProcedureParameter');
    }
    /** Amount */
    get amount() {
        return this.document.fields.find((f) => f.type.name === 'Amount');
    }
    /** Currency */
    get currency() {
        return this.document.fields.find((f) => f.type.name === 'Currency');
    }
    /** Debtor Address Type */
    get debtorAddressType() {
        return this.document.fields.find((f) => f.type.name === 'DebtorAddressType');
    }
    /** Debtor Building Or Address Line 2 */
    get debtorBuildingOrAddressLine2() {
        return this.document.fields.find((f) => f.type.name === 'DebtorBuildingOrAddressLine2');
    }
    /** Debtor Country */
    get debtorCountry() {
        return this.document.fields.find((f) => f.type.name === 'DebtorCountry');
    }
    /** Debtor Name */
    get debtorName() {
        return this.document.fields.find((f) => f.type.name === 'DebtorName');
    }
    /** Debtor Place */
    get debtorPlace() {
        return this.document.fields.find((f) => f.type.name === 'DebtorPlace');
    }
    /** Debtor Postal Code */
    get debtorPostalCode() {
        return this.document.fields.find((f) => f.type.name === 'DebtorPostalCode');
    }
    /** Debtor Street Or Address Line 1 */
    get debtorStreetOrAddressLine1() {
        return this.document.fields.find((f) => f.type.name === 'DebtorStreetOrAddressLine1');
    }
    /** Due Date */
    get dueDate() {
        return this.document.fields.find((f) => f.type.name === 'DueDate');
    }
    /** Encoding */
    get encoding() {
        return this.document.fields.find((f) => f.type.name === 'Encoding');
    }
    /** Final Payee Address Type */
    get finalPayeeAddressType() {
        return this.document.fields.find((f) => f.type.name === 'FinalPayeeAddressType');
    }
    /** Final Payee Building Or Address Line 2 */
    get finalPayeeBuildingOrAddressLine2() {
        return this.document.fields.find((f) => f.type.name === 'FinalPayeeBuildingOrAddressLine2');
    }
    /** Final Payee Country */
    get finalPayeeCountry() {
        return this.document.fields.find((f) => f.type.name === 'FinalPayeeCountry');
    }
    /** Final Payee Name */
    get finalPayeeName() {
        return this.document.fields.find((f) => f.type.name === 'FinalPayeeName');
    }
    /** Final Payee Place */
    get finalPayeePlace() {
        return this.document.fields.find((f) => f.type.name === 'FinalPayeePlace');
    }
    /** Final Payee Postal Code */
    get finalPayeePostalCode() {
        return this.document.fields.find((f) => f.type.name === 'FinalPayeePostalCode');
    }
    /** Final Payee Street Or Address Line 1 */
    get finalPayeeStreetOrAddressLine1() {
        return this.document.fields.find((f) => f.type.name === 'FinalPayeeStreetOrAddressLine1');
    }
    /** IBAN */
    get iban() {
        return this.document.fields.find((f) => f.type.name === 'IBAN');
    }
    /** Major Version */
    get majorVersion() {
        return this.document.fields.find((f) => f.type.name === 'MajorVersion');
    }
    /** Payee Address Type */
    get payeeAddressType() {
        return this.document.fields.find((f) => f.type.name === 'PayeeAddressType');
    }
    /** Payee Building Or Address Line 2 */
    get payeeBuildingOrAddressLine2() {
        return this.document.fields.find((f) => f.type.name === 'PayeeBuildingOrAddressLine2');
    }
    /** Payee Country */
    get payeeCountry() {
        return this.document.fields.find((f) => f.type.name === 'PayeeCountry');
    }
    /** Payee Name */
    get payeeName() {
        return this.document.fields.find((f) => f.type.name === 'PayeeName');
    }
    /** Payee Place */
    get payeePlace() {
        return this.document.fields.find((f) => f.type.name === 'PayeePlace');
    }
    /** Payee Postal Code */
    get payeePostalCode() {
        return this.document.fields.find((f) => f.type.name === 'PayeePostalCode');
    }
    /** Payee Street Or Address Line 1 */
    get payeeStreetOrAddressLine1() {
        return this.document.fields.find((f) => f.type.name === 'PayeeStreetOrAddressLine1');
    }
    /** Payment Reference */
    get paymentReference() {
        return this.document.fields.find((f) => f.type.name === 'PaymentReference');
    }
    /** Payment Reference Type */
    get paymentReferenceType() {
        return this.document.fields.find((f) => f.type.name === 'PaymentReferenceType');
    }
}
/** Medical Plan */
class DEMedicalPlan {
    get document() {
        return this._document;
    }
    constructor(document) {
        if (document.type.name !== this.requiredDocumentType()) {
            throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
        }
        this._document = document;
    }
    requiredDocumentType() {
        return DEMedicalPlanDocumentType;
    }
    /** Current Page */
    get currentPage() {
        return this.document.fields.find((f) => f.type.name === 'CurrentPage');
    }
    /** Document Version Number */
    get documentVersionNumber() {
        return this.document.fields.find((f) => f.type.name === 'DocumentVersionNumber');
    }
    /** GUID */
    get guid() {
        return this.document.fields.find((f) => f.type.name === 'GUID');
    }
    /** Language Country Code */
    get languageCountryCode() {
        return this.document.fields.find((f) => f.type.name === 'LanguageCountryCode');
    }
    /** Patch Version Number */
    get patchVersionNumber() {
        return this.document.fields.find((f) => f.type.name === 'PatchVersionNumber');
    }
    /** Total Number Of Pages */
    get totalNumberOfPages() {
        return this.document.fields.find((f) => f.type.name === 'TotalNumberOfPages');
    }
    /** The child document of type "Patient". */
    get patient() {
        const child = this.document.children.find((c) => c.type.name === 'Patient');
        return new DEMedicalPlan.Patient(child);
    }
    /** The child document of type "Doctor". */
    get doctor() {
        const child = this.document.children.find((c) => c.type.name === 'Doctor');
        return new DEMedicalPlan.Doctor(child);
    }
    /** An array of all children of type "Subheading". */
    get subheadings() {
        return this.document.children
            .filter((c) => c.type.name === 'Subheading')
            .map((c) => new DEMedicalPlan.Subheading(c));
    }
}
(function (DEMedicalPlan) {
    /** Patient */
    class Patient {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        requiredDocumentType() {
            return DEMedicalPlanPatientDocumentType;
        }
        /** Allergies And Intolerances */
        get allergiesAndIntolerances() {
            return this.document.fields.find((f) => f.type.name === 'AllergiesAndIntolerances');
        }
        /** Birth Date */
        get birthDate() {
            return this.document.fields.find((f) => f.type.name === 'BirthDate');
        }
        /** Breast Feeding */
        get breastFeeding() {
            return this.document.fields.find((f) => f.type.name === 'BreastFeeding');
        }
        /** Creatinine Value */
        get creatinineValue() {
            return this.document.fields.find((f) => f.type.name === 'CreatinineValue');
        }
        /** First Name */
        get firstName() {
            return this.document.fields.find((f) => f.type.name === 'FirstName');
        }
        /** Gender */
        get gender() {
            return this.document.fields.find((f) => f.type.name === 'Gender');
        }
        /** Height */
        get height() {
            return this.document.fields.find((f) => f.type.name === 'Height');
        }
        /** Last Name */
        get lastName() {
            return this.document.fields.find((f) => f.type.name === 'LastName');
        }
        /** Patient Free Text */
        get patientFreeText() {
            return this.document.fields.find((f) => f.type.name === 'PatientFreeText');
        }
        /** Patient ID */
        get patientID() {
            return this.document.fields.find((f) => f.type.name === 'PatientID');
        }
        /** Pre Name */
        get preName() {
            return this.document.fields.find((f) => f.type.name === 'PreName');
        }
        /** Pregnant */
        get pregnant() {
            return this.document.fields.find((f) => f.type.name === 'Pregnant');
        }
        /** Name Suffix */
        get suffix() {
            return this.document.fields.find((f) => f.type.name === 'Suffix');
        }
        /** Title */
        get title() {
            return this.document.fields.find((f) => f.type.name === 'Title');
        }
        /** Weight */
        get weight() {
            return this.document.fields.find((f) => f.type.name === 'Weight');
        }
    }
    DEMedicalPlan.Patient = Patient;
    /** Doctor */
    class Doctor {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        requiredDocumentType() {
            return DEMedicalPlanDoctorDocumentType;
        }
        /** Doctor Number */
        get doctorNumber() {
            return this.document.fields.find((f) => f.type.name === 'DoctorNumber');
        }
        /** Email */
        get email() {
            return this.document.fields.find((f) => f.type.name === 'Email');
        }
        /** Hospital ID */
        get hospitalID() {
            return this.document.fields.find((f) => f.type.name === 'HospitalID');
        }
        /** Issuer Name */
        get issuerName() {
            return this.document.fields.find((f) => f.type.name === 'IssuerName');
        }
        /** Issuing Date And Time */
        get issuingDateAndTime() {
            return this.document.fields.find((f) => f.type.name === 'IssuingDateAndTime');
        }
        /** Pharmacy ID */
        get pharmacyID() {
            return this.document.fields.find((f) => f.type.name === 'PharmacyID');
        }
        /** Place */
        get place() {
            return this.document.fields.find((f) => f.type.name === 'Place');
        }
        /** Postal Code */
        get postalCode() {
            return this.document.fields.find((f) => f.type.name === 'PostalCode');
        }
        /** Street */
        get street() {
            return this.document.fields.find((f) => f.type.name === 'Street');
        }
        /** Telephone Number */
        get telephoneNumber() {
            return this.document.fields.find((f) => f.type.name === 'TelephoneNumber');
        }
    }
    DEMedicalPlan.Doctor = Doctor;
    /** Subheading */
    class Subheading {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        requiredDocumentType() {
            return DEMedicalPlanSubheadingDocumentType;
        }
        /** General Note */
        get generalNotes() {
            return this.document.fields.filter((f) => f.type.name === 'GeneralNote');
        }
        /** Key Words */
        get keyWords() {
            return this.document.fields.find((f) => f.type.name === 'KeyWords');
        }
        /** Subheading Free Text */
        get subheadingFreeText() {
            return this.document.fields.find((f) => f.type.name === 'SubheadingFreeText');
        }
        /** An array of all children of type "Medicine". */
        get medicines() {
            return this.document.children
                .filter((c) => c.type.name === 'Medicine')
                .map((c) => new DEMedicalPlan.Subheading.Medicine(c));
        }
        /** An array of all children of type "Prescription". */
        get prescriptions() {
            return this.document.children
                .filter((c) => c.type.name === 'Prescription')
                .map((c) => new DEMedicalPlan.Subheading.Prescription(c));
        }
    }
    DEMedicalPlan.Subheading = Subheading;
    (function (Subheading) {
        /** Medicine */
        class Medicine {
            get document() {
                return this._document;
            }
            constructor(document) {
                if (document.type.name !== this.requiredDocumentType()) {
                    throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
                }
                this._document = document;
            }
            requiredDocumentType() {
                return DEMedicalPlanSubheadingMedicineDocumentType;
            }
            /** Dosage Form */
            get dosageForm() {
                return this.document.fields.find((f) => f.type.name === 'DosageForm');
            }
            /** Dosage Form Free Text */
            get dosageFormFreeText() {
                return this.document.fields.find((f) => f.type.name === 'DosageFormFreeText');
            }
            /** Dosage Free Text */
            get dosageFreeText() {
                return this.document.fields.find((f) => f.type.name === 'DosageFreeText');
            }
            /** Dosing Unit */
            get dosingUnit() {
                return this.document.fields.find((f) => f.type.name === 'DosingUnit');
            }
            /** Dosing Unit Free Text */
            get dosingUnitFreeText() {
                return this.document.fields.find((f) => f.type.name === 'DosingUnitFreeText');
            }
            /** Drug Name */
            get drugName() {
                return this.document.fields.find((f) => f.type.name === 'DrugName');
            }
            /** Evening Intake Dose */
            get evening() {
                return this.document.fields.find((f) => f.type.name === 'Evening');
            }
            /** General Notes */
            get generalNotes() {
                return this.document.fields.find((f) => f.type.name === 'GeneralNotes');
            }
            /** Midday Intake Dose */
            get midday() {
                return this.document.fields.find((f) => f.type.name === 'Midday');
            }
            /** Morning Intake Dose */
            get morning() {
                return this.document.fields.find((f) => f.type.name === 'Morning');
            }
            /** Night Intake Dose */
            get night() {
                return this.document.fields.find((f) => f.type.name === 'Night');
            }
            /** Pharmaceutical Number */
            get pharmaceuticalNumber() {
                return this.document.fields.find((f) => f.type.name === 'PharmaceuticalNumber');
            }
            /** Reason For Treatment */
            get reasonForTreatment() {
                return this.document.fields.find((f) => f.type.name === 'ReasonForTreatment');
            }
            /** Relevant Info */
            get relevantInfo() {
                return this.document.fields.find((f) => f.type.name === 'RelevantInfo');
            }
            /** An array of all children of type "Substance". */
            get substances() {
                return this.document.children
                    .filter((c) => c.type.name === 'Substance')
                    .map((c) => new DEMedicalPlan.Subheading.Medicine.Substance(c));
            }
        }
        Subheading.Medicine = Medicine;
        (function (Medicine) {
            /** Substance */
            class Substance {
                get document() {
                    return this._document;
                }
                constructor(document) {
                    if (document.type.name !== this.requiredDocumentType()) {
                        throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
                    }
                    this._document = document;
                }
                requiredDocumentType() {
                    return DEMedicalPlanSubheadingMedicineSubstanceDocumentType;
                }
                /** Active Substance */
                get activeSubstance() {
                    return this.document.fields.find((f) => f.type.name === 'ActiveSubstance');
                }
                /** Potency */
                get potency() {
                    return this.document.fields.find((f) => f.type.name === 'Potency');
                }
            }
            Medicine.Substance = Substance;
        })(Medicine = Subheading.Medicine || (Subheading.Medicine = {}));
        /** Prescription */
        class Prescription {
            get document() {
                return this._document;
            }
            constructor(document) {
                if (document.type.name !== this.requiredDocumentType()) {
                    throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
                }
                this._document = document;
            }
            requiredDocumentType() {
                return DEMedicalPlanSubheadingPrescriptionDocumentType;
            }
            /** General Information */
            get generalInformation() {
                return this.document.fields.find((f) => f.type.name === 'GeneralInformation');
            }
            /** Prescription Free Text */
            get prescriptionFreeText() {
                return this.document.fields.find((f) => f.type.name === 'PrescriptionFreeText');
            }
        }
        Subheading.Prescription = Prescription;
    })(Subheading = DEMedicalPlan.Subheading || (DEMedicalPlan.Subheading = {}));
})(DEMedicalPlan || (DEMedicalPlan = {}));
/** ID Card */
class IDCardPDF417 {
    get document() {
        return this._document;
    }
    constructor(document) {
        if (document.type.name !== this.requiredDocumentType()) {
            throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
        }
        this._document = document;
    }
    requiredDocumentType() {
        return IDCardPDF417DocumentType;
    }
    /** Birth Date. The format is ISO8601 with delimiters */
    get birthDate() {
        return this.document.fields.find((f) => f.type.name === 'BirthDate');
    }
    /** Date Expired. The format is ISO8601 with delimiters */
    get dateExpired() {
        return this.document.fields.find((f) => f.type.name === 'DateExpired');
    }
    /** Date Issued. The format is ISO8601 with delimiters */
    get dateIssued() {
        return this.document.fields.find((f) => f.type.name === 'DateIssued');
    }
    /** Document Code */
    get documentCode() {
        return this.document.fields.find((f) => f.type.name === 'DocumentCode');
    }
    /** First Name */
    get firstName() {
        return this.document.fields.find((f) => f.type.name === 'FirstName');
    }
    /** Last Name */
    get lastName() {
        return this.document.fields.find((f) => f.type.name === 'LastName');
    }
    /** Optional */
    get optional() {
        return this.document.fields.find((f) => f.type.name === 'Optional');
    }
}
/** GS1 */
class GS1 {
    get document() {
        return this._document;
    }
    constructor(document) {
        if (document.type.name !== this.requiredDocumentType()) {
            throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
        }
        this._document = document;
    }
    requiredDocumentType() {
        return GS1DocumentType;
    }
    /** An array of all children of type "Element". */
    get elements() {
        return this.document.children
            .filter((c) => c.type.name === 'Element')
            .map((c) => new GS1.Element(c));
    }
}
(function (GS1) {
    /** GS1 Element */
    class Element {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        requiredDocumentType() {
            return GS1ElementDocumentType;
        }
        /** Application Identifier */
        get applicationIdentifier() {
            return this.document.fields.find((f) => f.type.name === 'ApplicationIdentifier');
        }
        /** Data Title */
        get dataTitle() {
            return this.document.fields.find((f) => f.type.name === 'DataTitle');
        }
        /** Description */
        get elementDescription() {
            return this.document.fields.find((f) => f.type.name === 'ElementDescription');
        }
        /** Raw Value */
        get rawValue() {
            return this.document.fields.find((f) => f.type.name === 'RawValue');
        }
        /** An array of all children of type "ValidationError". */
        get validationErrors() {
            return this.document.children
                .filter((c) => c.type.name === 'ValidationError')
                .map((c) => new GS1.Element.ValidationError(c));
        }
    }
    GS1.Element = Element;
    (function (Element) {
        /** Validation Errors */
        class ValidationError {
            get document() {
                return this._document;
            }
            constructor(document) {
                if (document.type.name !== this.requiredDocumentType()) {
                    throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
                }
                this._document = document;
            }
            requiredDocumentType() {
                return GS1ElementValidationErrorDocumentType;
            }
            /** Error Code */
            get code() {
                return this.document.fields.find((f) => f.type.name === 'Code');
            }
            /** Reason */
            get reason() {
                return this.document.fields.find((f) => f.type.name === 'Reason');
            }
        }
        Element.ValidationError = ValidationError;
    })(Element = GS1.Element || (GS1.Element = {}));
})(GS1 || (GS1 = {}));
/** SEPA */
class SEPA {
    get document() {
        return this._document;
    }
    constructor(document) {
        if (document.type.name !== this.requiredDocumentType()) {
            throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
        }
        this._document = document;
    }
    requiredDocumentType() {
        return SEPADocumentType;
    }
    /** Amount */
    get amount() {
        return this.document.fields.find((f) => f.type.name === 'Amount');
    }
    /** Character Set */
    get characterSet() {
        return this.document.fields.find((f) => f.type.name === 'CharacterSet');
    }
    /** Identification */
    get identification() {
        return this.document.fields.find((f) => f.type.name === 'Identification');
    }
    /** Information */
    get information() {
        return this.document.fields.find((f) => f.type.name === 'Information');
    }
    /** Amount */
    get purpose() {
        return this.document.fields.find((f) => f.type.name === 'Purpose');
    }
    /** Receiver BIC */
    get receiverBIC() {
        return this.document.fields.find((f) => f.type.name === 'ReceiverBIC');
    }
    /** Receiver IBAN */
    get receiverIBAN() {
        return this.document.fields.find((f) => f.type.name === 'ReceiverIBAN');
    }
    /** Receiver Name */
    get receiverName() {
        return this.document.fields.find((f) => f.type.name === 'ReceiverName');
    }
    /** Remittance */
    get remittance() {
        return this.document.fields.find((f) => f.type.name === 'Remittance');
    }
    /** Service Tag */
    get serviceTag() {
        return this.document.fields.find((f) => f.type.name === 'ServiceTag');
    }
    /** Version */
    get version() {
        return this.document.fields.find((f) => f.type.name === 'Version');
    }
}
/** Medical Certificate */
class MedicalCertificate {
    get document() {
        return this._document;
    }
    constructor(document) {
        if (document.type.name !== this.requiredDocumentType()) {
            throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
        }
        this._document = document;
    }
    requiredDocumentType() {
        return MedicalCertificateDocumentType;
    }
    /** Accident */
    get accident() {
        return this.document.fields.find((f) => f.type.name === 'Accident');
    }
    /** Assigned To Accident Insurance Doctor */
    get assignedToAccidentInsuranceDoctor() {
        return this.document.fields.find((f) => f.type.name === 'AssignedToAccidentInsuranceDoctor');
    }
    /** Birth Date. The format is ISO8601 with delimiters */
    get birthDate() {
        return this.document.fields.find((f) => f.type.name === 'BirthDate');
    }
    /** Child Needs Care From */
    get childNeedsCareFrom() {
        return this.document.fields.find((f) => f.type.name === 'ChildNeedsCareFrom');
    }
    /** Child Needs Care Until */
    get childNeedsCareUntil() {
        return this.document.fields.find((f) => f.type.name === 'ChildNeedsCareUntil');
    }
    /** Diagnose */
    get diagnose() {
        return this.document.fields.find((f) => f.type.name === 'Diagnose');
    }
    /** Diagnosed On. The format is ISO8601 with delimiters */
    get diagnosedOn() {
        return this.document.fields.find((f) => f.type.name === 'DiagnosedOn');
    }
    /** Doctor Number */
    get doctorNumber() {
        return this.document.fields.find((f) => f.type.name === 'DoctorNumber');
    }
    /** Document Date. The format is ISO8601 with delimiters */
    get documentDate() {
        return this.document.fields.find((f) => f.type.name === 'DocumentDate');
    }
    /** First Name */
    get firstName() {
        return this.document.fields.find((f) => f.type.name === 'FirstName');
    }
    /** Health Insurance Number */
    get healthInsuranceNumber() {
        return this.document.fields.find((f) => f.type.name === 'HealthInsuranceNumber');
    }
    /** Incapable Of Work Since. The format is ISO8601 with delimiters */
    get incapableOfWorkSince() {
        return this.document.fields.find((f) => f.type.name === 'IncapableOfWorkSince');
    }
    /** Incapable Of Work Until. The format is ISO8601 with delimiters */
    get incapableOfWorkUntil() {
        return this.document.fields.find((f) => f.type.name === 'IncapableOfWorkUntil');
    }
    /** Initial Certificate */
    get initialCertificate() {
        return this.document.fields.find((f) => f.type.name === 'InitialCertificate');
    }
    /** Insured Person Number */
    get insuredPersonNumber() {
        return this.document.fields.find((f) => f.type.name === 'InsuredPersonNumber');
    }
    /** Last Name */
    get lastName() {
        return this.document.fields.find((f) => f.type.name === 'LastName');
    }
    /** Place Of Operation Number */
    get placeOfOperationNumber() {
        return this.document.fields.find((f) => f.type.name === 'PlaceOfOperationNumber');
    }
    /** Renewed Certificate */
    get renewedCertificate() {
        return this.document.fields.find((f) => f.type.name === 'RenewedCertificate');
    }
    /** Requires Care */
    get requiresCare() {
        return this.document.fields.find((f) => f.type.name === 'RequiresCare');
    }
    /** Status */
    get status() {
        return this.document.fields.find((f) => f.type.name === 'Status');
    }
    /** Work Accident */
    get workAccident() {
        return this.document.fields.find((f) => f.type.name === 'WorkAccident');
    }
}
/** VCard */
class VCard {
    get document() {
        return this._document;
    }
    constructor(document) {
        if (document.type.name !== this.requiredDocumentType()) {
            throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
        }
        this._document = document;
    }
    requiredDocumentType() {
        return VCardDocumentType;
    }
    /** The child document of type "Version". */
    get version() {
        const child = this.document.children.find((c) => c.type.name === 'Version');
        return new VCard.Version(child);
    }
    /** The child document of type "Source". */
    get source() {
        const child = this.document.children.find((c) => c.type.name === 'Source');
        return child ? new VCard.Source(child) : undefined;
    }
    /** The child document of type "Kind". */
    get kind() {
        const child = this.document.children.find((c) => c.type.name === 'Kind');
        return child ? new VCard.Kind(child) : undefined;
    }
    /** The child document of type "XML". */
    get xml() {
        const child = this.document.children.find((c) => c.type.name === 'XML');
        return child ? new VCard.XML(child) : undefined;
    }
    /** The child document of type "Name". */
    get name() {
        const child = this.document.children.find((c) => c.type.name === 'Name');
        return child ? new VCard.Name(child) : undefined;
    }
    /** The child document of type "FirstName". */
    get firstName() {
        const child = this.document.children.find((c) => c.type.name === 'FirstName');
        return child ? new VCard.FirstName(child) : undefined;
    }
    /** The child document of type "Nickname". */
    get nickname() {
        const child = this.document.children.find((c) => c.type.name === 'Nickname');
        return child ? new VCard.Nickname(child) : undefined;
    }
    /** The child document of type "Birthday". */
    get birthday() {
        const child = this.document.children.find((c) => c.type.name === 'Birthday');
        return child ? new VCard.Birthday(child) : undefined;
    }
    /** The child document of type "Anniversary". */
    get anniversary() {
        const child = this.document.children.find((c) => c.type.name === 'Anniversary');
        return child ? new VCard.Anniversary(child) : undefined;
    }
    /** The child document of type "Gender". */
    get gender() {
        const child = this.document.children.find((c) => c.type.name === 'Gender');
        return child ? new VCard.Gender(child) : undefined;
    }
    /** The child document of type "DeliveryAddress". */
    get deliveryAddress() {
        const child = this.document.children.find((c) => c.type.name === 'DeliveryAddress');
        return child ? new VCard.DeliveryAddress(child) : undefined;
    }
    /** The child document of type "Photo". */
    get photo() {
        const child = this.document.children.find((c) => c.type.name === 'Photo');
        return child ? new VCard.Photo(child) : undefined;
    }
    /** The child document of type "TelephoneNumber". */
    get telephoneNumber() {
        const child = this.document.children.find((c) => c.type.name === 'TelephoneNumber');
        return child ? new VCard.TelephoneNumber(child) : undefined;
    }
    /** The child document of type "Email". */
    get email() {
        const child = this.document.children.find((c) => c.type.name === 'Email');
        return child ? new VCard.Email(child) : undefined;
    }
    /** The child document of type "IMPP". */
    get impp() {
        const child = this.document.children.find((c) => c.type.name === 'IMPP');
        return child ? new VCard.IMPP(child) : undefined;
    }
    /** The child document of type "Languages". */
    get languages() {
        const child = this.document.children.find((c) => c.type.name === 'Languages');
        return child ? new VCard.Languages(child) : undefined;
    }
    /** The child document of type "TimeZone". */
    get timeZone() {
        const child = this.document.children.find((c) => c.type.name === 'TimeZone');
        return child ? new VCard.TimeZone(child) : undefined;
    }
    /** The child document of type "GeoLocation". */
    get geoLocation() {
        const child = this.document.children.find((c) => c.type.name === 'GeoLocation');
        return child ? new VCard.GeoLocation(child) : undefined;
    }
    /** The child document of type "Title". */
    get title() {
        const child = this.document.children.find((c) => c.type.name === 'Title');
        return child ? new VCard.Title(child) : undefined;
    }
    /** The child document of type "Role". */
    get role() {
        const child = this.document.children.find((c) => c.type.name === 'Role');
        return child ? new VCard.Role(child) : undefined;
    }
    /** The child document of type "Logo". */
    get logo() {
        const child = this.document.children.find((c) => c.type.name === 'Logo');
        return child ? new VCard.Logo(child) : undefined;
    }
    /** The child document of type "Organisation". */
    get organisation() {
        const child = this.document.children.find((c) => c.type.name === 'Organisation');
        return child ? new VCard.Organisation(child) : undefined;
    }
    /** The child document of type "Member". */
    get member() {
        const child = this.document.children.find((c) => c.type.name === 'Member');
        return child ? new VCard.Member(child) : undefined;
    }
    /** The child document of type "Related". */
    get related() {
        const child = this.document.children.find((c) => c.type.name === 'Related');
        return child ? new VCard.Related(child) : undefined;
    }
    /** The child document of type "Categories". */
    get categories() {
        const child = this.document.children.find((c) => c.type.name === 'Categories');
        return child ? new VCard.Categories(child) : undefined;
    }
    /** The child document of type "Note". */
    get note() {
        const child = this.document.children.find((c) => c.type.name === 'Note');
        return child ? new VCard.Note(child) : undefined;
    }
    /** The child document of type "ProductId". */
    get productId() {
        const child = this.document.children.find((c) => c.type.name === 'ProductId');
        return child ? new VCard.ProductId(child) : undefined;
    }
    /** The child document of type "Revision". */
    get revision() {
        const child = this.document.children.find((c) => c.type.name === 'Revision');
        return child ? new VCard.Revision(child) : undefined;
    }
    /** The child document of type "Sound". */
    get sound() {
        const child = this.document.children.find((c) => c.type.name === 'Sound');
        return child ? new VCard.Sound(child) : undefined;
    }
    /** The child document of type "UID". */
    get uid() {
        const child = this.document.children.find((c) => c.type.name === 'UID');
        return child ? new VCard.UID(child) : undefined;
    }
    /** The child document of type "ClientPIDMap". */
    get clientPIDMap() {
        const child = this.document.children.find((c) => c.type.name === 'ClientPIDMap');
        return child ? new VCard.ClientPIDMap(child) : undefined;
    }
    /** The child document of type "URL". */
    get url() {
        const child = this.document.children.find((c) => c.type.name === 'URL');
        return child ? new VCard.URL(child) : undefined;
    }
    /** The child document of type "PublicKey". */
    get publicKey() {
        const child = this.document.children.find((c) => c.type.name === 'PublicKey');
        return child ? new VCard.PublicKey(child) : undefined;
    }
    /** The child document of type "BusyTimeURL". */
    get busyTimeURL() {
        const child = this.document.children.find((c) => c.type.name === 'BusyTimeURL');
        return child ? new VCard.BusyTimeURL(child) : undefined;
    }
    /** The child document of type "CalendarURIForRequests". */
    get calendarURIForRequests() {
        const child = this.document.children.find((c) => c.type.name === 'CalendarURIForRequests');
        return child ? new VCard.CalendarURIForRequests(child) : undefined;
    }
    /** The child document of type "CalendarURI". */
    get calendarURI() {
        const child = this.document.children.find((c) => c.type.name === 'CalendarURI');
        return child ? new VCard.CalendarURI(child) : undefined;
    }
    /** An array of all children of type "Custom". */
    get customs() {
        return this.document.children
            .filter((c) => c.type.name === 'Custom')
            .map((c) => new VCard.Custom(c));
    }
}
(function (VCard) {
    /** VCard Entry */
    class Entry {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        /** Raw Value */
        get rawValue() {
            return this.document.fields.find((f) => f.type.name === 'RawValue');
        }
        /** Type Modifier */
        get typeModifiers() {
            return this.document.fields.filter((f) => f.type.name === 'TypeModifier');
        }
        /** Value */
        get values() {
            return this.document.fields.filter((f) => f.type.name === 'Value');
        }
    }
    VCard.Entry = Entry;
    /** Version */
    class Version extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardVersionDocumentType;
        }
    }
    VCard.Version = Version;
    /** Source */
    class Source extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardSourceDocumentType;
        }
    }
    VCard.Source = Source;
    /** Kind */
    class Kind extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardKindDocumentType;
        }
    }
    VCard.Kind = Kind;
    /** XML */
    class XML extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardXMLDocumentType;
        }
    }
    VCard.XML = XML;
    /** Name */
    class Name extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardNameDocumentType;
        }
    }
    VCard.Name = Name;
    /** First Name */
    class FirstName extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardFirstNameDocumentType;
        }
    }
    VCard.FirstName = FirstName;
    /** Nickname */
    class Nickname extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardNicknameDocumentType;
        }
    }
    VCard.Nickname = Nickname;
    /** Birthday */
    class Birthday extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardBirthdayDocumentType;
        }
    }
    VCard.Birthday = Birthday;
    /** Anniversary */
    class Anniversary extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardAnniversaryDocumentType;
        }
    }
    VCard.Anniversary = Anniversary;
    /** Gender */
    class Gender extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardGenderDocumentType;
        }
    }
    VCard.Gender = Gender;
    /** Delivery Address */
    class DeliveryAddress extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardDeliveryAddressDocumentType;
        }
    }
    VCard.DeliveryAddress = DeliveryAddress;
    /** Photo */
    class Photo extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardPhotoDocumentType;
        }
    }
    VCard.Photo = Photo;
    /** Telephone Number */
    class TelephoneNumber extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardTelephoneNumberDocumentType;
        }
    }
    VCard.TelephoneNumber = TelephoneNumber;
    /** Email */
    class Email extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardEmailDocumentType;
        }
    }
    VCard.Email = Email;
    /** IMPP */
    class IMPP extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardIMPPDocumentType;
        }
    }
    VCard.IMPP = IMPP;
    /** Languages */
    class Languages extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardLanguagesDocumentType;
        }
    }
    VCard.Languages = Languages;
    /** Time Zone */
    class TimeZone extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardTimeZoneDocumentType;
        }
    }
    VCard.TimeZone = TimeZone;
    /** Geo Location */
    class GeoLocation extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardGeoLocationDocumentType;
        }
    }
    VCard.GeoLocation = GeoLocation;
    /** Title */
    class Title extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardTitleDocumentType;
        }
    }
    VCard.Title = Title;
    /** Role */
    class Role extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardRoleDocumentType;
        }
    }
    VCard.Role = Role;
    /** Logo */
    class Logo extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardLogoDocumentType;
        }
    }
    VCard.Logo = Logo;
    /** Organisation */
    class Organisation extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardOrganisationDocumentType;
        }
    }
    VCard.Organisation = Organisation;
    /** Member */
    class Member extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardMemberDocumentType;
        }
    }
    VCard.Member = Member;
    /** Related */
    class Related extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardRelatedDocumentType;
        }
    }
    VCard.Related = Related;
    /** Categories */
    class Categories extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardCategoriesDocumentType;
        }
    }
    VCard.Categories = Categories;
    /** Note */
    class Note extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardNoteDocumentType;
        }
    }
    VCard.Note = Note;
    /** ProductId */
    class ProductId extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardProductIdDocumentType;
        }
    }
    VCard.ProductId = ProductId;
    /** Revision */
    class Revision extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardRevisionDocumentType;
        }
    }
    VCard.Revision = Revision;
    /** Sound */
    class Sound extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardSoundDocumentType;
        }
    }
    VCard.Sound = Sound;
    /** UID */
    class UID extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardUIDDocumentType;
        }
    }
    VCard.UID = UID;
    /** Client PID Map */
    class ClientPIDMap extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardClientPIDMapDocumentType;
        }
    }
    VCard.ClientPIDMap = ClientPIDMap;
    /** URL */
    class URL extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardURLDocumentType;
        }
    }
    VCard.URL = URL;
    /** Public Key */
    class PublicKey extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardPublicKeyDocumentType;
        }
    }
    VCard.PublicKey = PublicKey;
    /** Busy Time URL */
    class BusyTimeURL extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardBusyTimeURLDocumentType;
        }
    }
    VCard.BusyTimeURL = BusyTimeURL;
    /** Calendar URI For Requests */
    class CalendarURIForRequests extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardCalendarURIForRequestsDocumentType;
        }
    }
    VCard.CalendarURIForRequests = CalendarURIForRequests;
    /** Calendar URI */
    class CalendarURI extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardCalendarURIDocumentType;
        }
    }
    VCard.CalendarURI = CalendarURI;
    /** Custom */
    class Custom extends Entry {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return VCardCustomDocumentType;
        }
    }
    VCard.Custom = Custom;
})(VCard || (VCard = {}));
/** AAMVA */
class AAMVA {
    get document() {
        return this._document;
    }
    constructor(document) {
        if (document.type.name !== this.requiredDocumentType()) {
            throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
        }
        this._document = document;
    }
    requiredDocumentType() {
        return AAMVADocumentType;
    }
    /** Issuer Identification Number */
    get issuerIdentificationNumber() {
        return this.document.fields.find((f) => f.type.name === 'IssuerIdentificationNumber');
    }
    /** Jurisdiction Version Number */
    get jurisdictionVersionNumber() {
        return this.document.fields.find((f) => f.type.name === 'JurisdictionVersionNumber');
    }
    /** Version */
    get version() {
        return this.document.fields.find((f) => f.type.name === 'Version');
    }
    /** The child document of type "TitleData". */
    get titleData() {
        const child = this.document.children.find((c) => c.type.name === 'TitleData');
        return child ? new AAMVA.TitleData(child) : undefined;
    }
    /** The child document of type "RegistrationData". */
    get registrationData() {
        const child = this.document.children.find((c) => c.type.name === 'RegistrationData');
        return child ? new AAMVA.RegistrationData(child) : undefined;
    }
    /** The child document of type "MotorCarrierData". */
    get motorCarrierData() {
        const child = this.document.children.find((c) => c.type.name === 'MotorCarrierData');
        return child ? new AAMVA.MotorCarrierData(child) : undefined;
    }
    /** The child document of type "RegistrantAndVehicleData". */
    get registrantAndVehicleData() {
        const child = this.document.children.find((c) => c.type.name === 'RegistrantAndVehicleData');
        return child ? new AAMVA.RegistrantAndVehicleData(child) : undefined;
    }
    /** The child document of type "VehicleOwnerData". */
    get vehicleOwnerData() {
        const child = this.document.children.find((c) => c.type.name === 'VehicleOwnerData');
        return child ? new AAMVA.VehicleOwnerData(child) : undefined;
    }
    /** The child document of type "VehicleData". */
    get vehicleData() {
        const child = this.document.children.find((c) => c.type.name === 'VehicleData');
        return child ? new AAMVA.VehicleData(child) : undefined;
    }
    /** The child document of type "VehicleSafetyInspectionData". */
    get vehicleSafetyInspectionData() {
        const child = this.document.children.find((c) => c.type.name === 'VehicleSafetyInspectionData');
        return child ? new AAMVA.VehicleSafetyInspectionData(child) : undefined;
    }
    /** The child document of type "DriverLicense". */
    get driverLicense() {
        const child = this.document.children.find((c) => c.type.name === 'DriverLicense');
        return child ? new AAMVA.DriverLicense(child) : undefined;
    }
    /** The child document of type "IDCard". */
    get idCard() {
        const child = this.document.children.find((c) => c.type.name === 'IDCard');
        return child ? new AAMVA.IDCard(child) : undefined;
    }
    /** The child document of type "EnhancedDriverLicense". */
    get enhancedDriverLicense() {
        const child = this.document.children.find((c) => c.type.name === 'EnhancedDriverLicense');
        return child ? new AAMVA.EnhancedDriverLicense(child) : undefined;
    }
    /** The child document of type "RawDocument". */
    get rawDocument() {
        const child = this.document.children.find((c) => c.type.name === 'RawDocument');
        return new AAMVA.RawDocument(child);
    }
}
(function (AAMVA) {
    /** Title Data. File type "TD". */
    class TitleData {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        requiredDocumentType() {
            return AAMVATitleDataDocumentType;
        }
        /** Data element ID "NAT". City portion of the owner’s address. */
        get addressCity() {
            return this.document.fields.find((f) => f.type.name === 'AddressCity');
        }
        /** Data element ID "NAU". Jurisdiction portion of the owner’s address. */
        get addressJurisdictionCode() {
            return this.document.fields.find((f) => f.type.name === 'AddressJurisdictionCode');
        }
        /** Data element ID "NAR". Street portion of the owner’s address. */
        get addressStreet() {
            return this.document.fields.find((f) => f.type.name === 'AddressStreet');
        }
        /** Data element ID "NAV". The ZIP code or Postal code portion of the owner’s address. */
        get addressZipCode() {
            return this.document.fields.find((f) => f.type.name === 'AddressZipCode');
        }
        /** Data element ID "BBC". The name of business that owns the vehicle. */
        get businessName() {
            return this.document.fields.find((f) => f.type.name === 'BusinessName');
        }
        /** Data element ID "NAA". Family name (commonly called surname or last name) of the owner of the vehicle. */
        get familyName() {
            return this.document.fields.find((f) => f.type.name === 'FamilyName');
        }
        /** Data element ID "LAF". A code that uniquely identifies the first holder of a lien. */
        get firstLienHolderId() {
            return this.document.fields.find((f) => f.type.name === 'FirstLienHolderId');
        }
        /** Data element ID "LAA". Name of the first lien holder of the vehicle. */
        get firstLienHolderName() {
            return this.document.fields.find((f) => f.type.name === 'FirstLienHolderName');
        }
        /** Data element ID "NAE". Given name or names (includes all of what are commonly referred to as first and middle names) of the owner of the vehicle. */
        get givenName() {
            return this.document.fields.find((f) => f.type.name === 'GivenName');
        }
        /** Data element ID "TAW". This code represents whether the vehicle/vessel is new or used. Note: jurisdictions’ definitions of these classifications may vary a little due to state regulations on demo vehicles, slates between dealers, application of state taxes, etc. N = New, U = Used. */
        get newUsedIndicator() {
            return this.document.fields.find((f) => f.type.name === 'NewUsedIndicator');
        }
        /** Data element ID "TAH". The date the odometer reading was recorded by the jurisdiction. */
        get odometerDate() {
            return this.document.fields.find((f) => f.type.name === 'OdometerDate');
        }
        /** Data element ID "TAG". This is the federal odometer mileage disclosure. The mandatory information is: (1) Actual vehicle mileage; (2) Mileage exceeds mechanical limitations; (3) Not actual mileage; (4) Mileage disclosure not required. */
        get odometerDisclosure() {
            return this.document.fields.find((f) => f.type.name === 'OdometerDisclosure');
        }
        /** Data element ID "TAI". This is the odometer reading registered with the DMV either at the time of titling or registration renewal in kilometers. */
        get odometerReadingKilometers() {
            return this.document.fields.find((f) => f.type.name === 'OdometerReadingKilometers');
        }
        /** Data element ID "TAF". This is the odometer reading registered with the DMV either at the time of titling or registration renewal. */
        get odometerReadingMileage() {
            return this.document.fields.find((f) => f.type.name === 'OdometerReadingMileage');
        }
        /** Data element ID "TAZ". The title number assigned to the vehicle by the previous titling jurisdiction. */
        get previousTitleNumber() {
            return this.document.fields.find((f) => f.type.name === 'PreviousTitleNumber');
        }
        /** Data element ID "TPJ". The code for the jurisdiction (U.S., Canadian, or Mexican) that titled the vehicle immediately prior to the current titling jurisdiction. */
        get previousTitlingJurisdiction() {
            return this.document.fields.find((f) => f.type.name === 'PreviousTitlingJurisdiction');
        }
        /** Data element ID "TAY". Code providing information about the brand applied to the title. */
        get titleBrand() {
            return this.document.fields.find((f) => f.type.name === 'TitleBrand');
        }
        /** Data element ID "TAV". The date the jurisdiction’s titling authority issued a title to the owner of the vehicle. The format is CCYYMMDD. */
        get titleIssueDate() {
            return this.document.fields.find((f) => f.type.name === 'TitleIssueDate');
        }
        /** Data element ID "TAA". The date the jurisdiction’s titling authority issued a title to the owner of the vehicle. The format is CCYYMMDD. */
        get titleNumber() {
            return this.document.fields.find((f) => f.type.name === 'TitleNumber');
        }
        /** Data element ID "TAC". A unique set of alphanumeric characters assigned by the titling jurisdiction to the certificate of title of a vehicle. */
        get titlingJurisdiction() {
            return this.document.fields.find((f) => f.type.name === 'TitlingJurisdiction');
        }
        /** Data element ID "VAO". The general configuration or shape of a vehicle distinguished by characteristics such as number of doors, seats, windows, roofline, and type of top. The vehicle body type is 2-character alphanumeric. */
        get vehicleBodyStyle() {
            return this.document.fields.find((f) => f.type.name === 'VehicleBodyStyle');
        }
        /** Data element ID "VBD". Where the vehicle/vessel is one color, this is the appropriate code describing that color. When the vehicle is two colors, this is the code for the top-most or front-most color. */
        get vehicleColor() {
            return this.document.fields.find((f) => f.type.name === 'VehicleColor');
        }
        /** Data element ID "VAD". A unique combination of alphanumeric characters that identifies a specific vehicle or component. The VIN is affixed to the vehicle in specific locations and formulated by the manufacturer. State agencies under some controlled instances may assign a VIN to a vehicle. */
        get vehicleIdentificationNumber() {
            return this.document.fields.find((f) => f.type.name === 'VehicleIdentificationNumber');
        }
        /** Data element ID "VAK". The distinctive (coded) name applied to a group of vehicles by a manufacturer. */
        get vehicleMake() {
            return this.document.fields.find((f) => f.type.name === 'VehicleMake');
        }
        /** Data element ID "VAM". A code denoting a family of vehicles (within a make), which has a degree of similarity in construction, such as body, chassis, etc. The field does not necessarily contain a standard code; it may contain a value provided by the originator of the field. */
        get vehicleModel() {
            return this.document.fields.find((f) => f.type.name === 'VehicleModel');
        }
        /** Data element ID "VAL". The year that is assigned to a vehicle by the manufacturer. The format is CCYY. */
        get vehicleModelYear() {
            return this.document.fields.find((f) => f.type.name === 'VehicleModelYear');
        }
        /** Data element ID "TAU". The date a vehicle was purchased by the current owner. The format is ISO8601 with delimiters. */
        get vehiclePurchaseDate() {
            return this.document.fields.find((f) => f.type.name === 'VehiclePurchaseDate');
        }
    }
    AAMVA.TitleData = TitleData;
    /** Registration Data. File type "RG". */
    class RegistrationData {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        requiredDocumentType() {
            return AAMVARegistrationDataDocumentType;
        }
        /** Data element ID "RBK". City portion of the owner’s address. */
        get addressCity() {
            return this.document.fields.find((f) => f.type.name === 'AddressCity');
        }
        /** Data element ID "RBL". Jurisdiction portion of the owner’s address. */
        get addressJurisdictionCode() {
            return this.document.fields.find((f) => f.type.name === 'AddressJurisdictionCode');
        }
        /** Data element ID "RBI". Street portion of the owner’s address. */
        get addressStreet() {
            return this.document.fields.find((f) => f.type.name === 'AddressStreet');
        }
        /** Data element ID "RBM". The Zip code or Postal code of the vehicle owner’s residence address. */
        get addressZipCode() {
            return this.document.fields.find((f) => f.type.name === 'AddressZipCode');
        }
        /** Data element ID "VBC". The number of common axles of rotation of one or more wheels of a vehicle, whether power driven or freely rotating. */
        get axles() {
            return this.document.fields.find((f) => f.type.name === 'Axles');
        }
        /** Data element ID "BBC". The business name of the first registrant of a vehicle. */
        get businessName() {
            return this.document.fields.find((f) => f.type.name === 'BusinessName');
        }
        /** Data element ID "FUL". The type of fuel used by the vehicle. In most cases, the fuel type would be diesel. */
        get fuel() {
            return this.document.fields.find((f) => f.type.name === 'Fuel');
        }
        /** Data element ID "VAT". The unladen weight of the vehicle (e.g., the single-unit truck, truck combination) plus the weight of the load being carried at a specific point in time. */
        get grossVehicleWeight() {
            return this.document.fields.find((f) => f.type.name === 'GrossVehicleWeight');
        }
        /** Data element ID "RBD". Family name (commonly called surname or last name) of the registered owner of a vehicle. */
        get registrantFamilyName() {
            return this.document.fields.find((f) => f.type.name === 'RegistrantFamilyName');
        }
        /** Data element ID "RBE". Given name or names (includes all of what are commonly referred to as first and middle names) of the registered owner of a vehicle. */
        get registrantGivenName() {
            return this.document.fields.find((f) => f.type.name === 'RegistrantGivenName');
        }
        /** Data element ID "RAG". The date in which the registration expired. The format is ISO8601 with delimiters. */
        get registrationExpiryDate() {
            return this.document.fields.find((f) => f.type.name === 'RegistrationExpiryDate');
        }
        /** Data element ID "RBB". The date in which the registration was issued. The format is ISO8601 with delimiters. */
        get registrationIssueDate() {
            return this.document.fields.find((f) => f.type.name === 'RegistrationIssueDate');
        }
        /** Data element ID "RAM". The characters assigned to a registration plate or tag affixed to the vehicle, assigned by the jurisdiction. */
        get registrationPlateNumber() {
            return this.document.fields.find((f) => f.type.name === 'RegistrationPlateNumber');
        }
        /** Data element ID "RBU". A unique number printed on the tab/decal and stored as part of the registration record. */
        get registrationWindowStickerDecal() {
            return this.document.fields.find((f) => f.type.name === 'RegistrationWindowStickerDecal');
        }
        /** Data element ID "RBT". The year of registration. */
        get registrationYear() {
            return this.document.fields.find((f) => f.type.name === 'RegistrationYear');
        }
        /** Data element ID "VAO". The general configuration or shape of a vehicle distinguished by characteristics such as number of doors, seats, windows, roofline, and type of top. The vehicle body type is 2-character alphanumeric. */
        get vehicleBodyStyle() {
            return this.document.fields.find((f) => f.type.name === 'VehicleBodyStyle');
        }
        /** Data element ID "VBD". Where the vehicle is one color, this is the appropriate code describing that color. When the vehicle is two colors, this is the code for the top-most or front-most color. */
        get vehicleColor() {
            return this.document.fields.find((f) => f.type.name === 'VehicleColor');
        }
        /** Data element ID "VAD". A unique combination of alphanumeric characters that identifies a specific vehicle or component. The VIN is affixed to the vehicle in specific locations and formulated by the manufacturer. State agencies under some controlled instances my assign a VIN to a vehicle. */
        get vehicleIdentificationNumber() {
            return this.document.fields.find((f) => f.type.name === 'VehicleIdentificationNumber');
        }
        /** Data element ID "VAK". The distinctive (coded) name applied to a group of vehicles by a manufacturer. */
        get vehicleMake() {
            return this.document.fields.find((f) => f.type.name === 'VehicleMake');
        }
        /** Data element ID "VAM". A code denoting a family of vehicles (within a make), which has a degree of similarity in construction, such as body, chassis, etc. The field does not necessarily contain a standard code; it may contain a value provided by the originator of the field. */
        get vehicleModel() {
            return this.document.fields.find((f) => f.type.name === 'VehicleModel');
        }
        /** Data element ID "VAL". The year which is assigned to a vehicle by the manufacturer. The format is CCYY. */
        get vehicleModelYear() {
            return this.document.fields.find((f) => f.type.name === 'VehicleModelYear');
        }
        /** Data element ID "VPC". Indicates the use of the vehicle. */
        get vehicleUse() {
            return this.document.fields.find((f) => f.type.name === 'VehicleUse');
        }
    }
    AAMVA.RegistrationData = RegistrationData;
    /** Motor Carrier Data. File type "MC". */
    class MotorCarrierData {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        requiredDocumentType() {
            return AAMVAMotorCarrierDataDocumentType;
        }
        /** Data element ID "MAA". The name of the carrier responsible for safety. This can be an individual, partnership or corporation responsible for the transportation of persons or property. This is the name that is recognized by law. */
        get carrierName() {
            return this.document.fields.find((f) => f.type.name === 'CarrierName');
        }
        /** Data element ID "MAL". This is the city for the mailing address of the individual carrier. This information is utilized by the base jurisdiction to send information to the carrier that purchased the IRP credentials. */
        get city() {
            return this.document.fields.find((f) => f.type.name === 'City');
        }
        /** Data element ID "MAI". This is the jurisdiction of the residential address of the individual carrier. This information is utilized by the base jurisdiction to send information to the carrier that purchased the IRP credentials. */
        get jurisdiction() {
            return this.document.fields.find((f) => f.type.name === 'Jurisdiction');
        }
        /** Data element ID "MAK". This is the mailing address of the individual carrier. This information is utilized by the base jurisdiction to send information to the carrier that purchased the IRP credentials. */
        get streetAddress() {
            return this.document.fields.find((f) => f.type.name === 'StreetAddress');
        }
        /** Data element ID "MAN". A unique identifier assigned to the carrier responsible for safety issued by the U.S. Department of Transportation – Federal Motor Carrier Safety Administration. */
        get usdotNumber() {
            return this.document.fields.find((f) => f.type.name === 'USDOTNumber');
        }
        /** Data element ID "MAO". The ZIP or Postal code of the resident address of the vehicle owner. */
        get zip() {
            return this.document.fields.find((f) => f.type.name === 'Zip');
        }
    }
    AAMVA.MotorCarrierData = MotorCarrierData;
    /** Registrant And Vehicle Data. File type "IR". */
    class RegistrantAndVehicleData {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        requiredDocumentType() {
            return AAMVARegistrantAndVehicleDataDocumentType;
        }
        /** Data element ID "RBI". The first line of the registrant’s residence address. */
        get address() {
            return this.document.fields.find((f) => f.type.name === 'Address');
        }
        /** Data element ID "RAU". The declared base jurisdiction registration weight. */
        get baseJurisdictionRegisteredWeight() {
            return this.document.fields.find((f) => f.type.name === 'BaseJurisdictionRegisteredWeight');
        }
        /** Data element ID "RBC". The name of the first registrant of a vehicle. Registrant’s name may be a combined individual name or the name of a business */
        get carrierNameRegistrant() {
            return this.document.fields.find((f) => f.type.name === 'CarrierNameRegistrant');
        }
        /** Data element ID "RBK". The registrant’s residence city name. */
        get city() {
            return this.document.fields.find((f) => f.type.name === 'City');
        }
        /** Data element ID "VAT". The unladen weight of the vehicle (e.g., single-unit truck, truck combination) plus the weight of the maximum load for which vehicle registration fees have been paid within a particular jurisdiction. */
        get grossVehicleWeight() {
            return this.document.fields.find((f) => f.type.name === 'GrossVehicleWeight');
        }
        /** Data element ID "RBL". The state or province of the registrant’s residence address. */
        get jurisdiction() {
            return this.document.fields.find((f) => f.type.name === 'Jurisdiction');
        }
        /** Data element ID "VAL". The year which is assigned to a vehicle by the manufacturer. The format is YY. */
        get modelYear() {
            return this.document.fields.find((f) => f.type.name === 'ModelYear');
        }
        /** Data element IDs "RAP", "VBC". The seat capacity of a commercial vehicle designed for transportation of more than then passengers. The number of common axles of rotation of one or more wheels of a vehicle, whether power design or freely rotating. */
        get numberOfSeats() {
            return this.document.fields.find((f) => f.type.name === 'NumberOfSeats');
        }
        /** Data element ID "RAD". The number assigned to the registration decal in those jurisdictions that issue decals. */
        get registrationDecalNumber() {
            return this.document.fields.find((f) => f.type.name === 'RegistrationDecalNumber');
        }
        /** Data element ID "RAF". The registration enforcement date is the date that the current registration was enforced. This may or may not be the original registration date. The format is ISO8601 with delimiters */
        get registrationEnforcementDate() {
            return this.document.fields.find((f) => f.type.name === 'RegistrationEnforcementDate');
        }
        /** Data element ID "RAG". The date in which the registration expired. The format is ISO8601 with delimiters. */
        get registrationExpirationDate() {
            return this.document.fields.find((f) => f.type.name === 'RegistrationExpirationDate');
        }
        /** Data element ID "IFJ". The date in which the registration was issued. The format is ISO8601 with delimiters. */
        get registrationIssueDate() {
            return this.document.fields.find((f) => f.type.name === 'RegistrationIssueDate');
        }
        /** Data element ID "RAM". The characters assigned to a registration plate or tag affixed to the vehicle, assigned by the jurisdiction. */
        get registrationPlateNumber() {
            return this.document.fields.find((f) => f.type.name === 'RegistrationPlateNumber');
        }
        /** Data element ID "RBT". This field is the registration year assigned by the jurisdiction. The format is CCYY. */
        get registrationYear() {
            return this.document.fields.find((f) => f.type.name === 'RegistrationYear');
        }
        /** Data element ID "VBB". The type of vehicle operated for the transportation of persons or property in the furtherance of any commercial or industrial enterprise, for hire or not for hire. Not all states will use all values. */
        get typeOfVehicle() {
            return this.document.fields.find((f) => f.type.name === 'TypeOfVehicle');
        }
        /** Data element ID "IEG". A number, assigned by the registrant of the commercial vehicle or trailer, to identify the vehicle or trailer in the fleet. No two units in a fleet can have the same number. A.K.A vehicle unit number or owner’s equipment number. */
        get unitNumber() {
            return this.document.fields.find((f) => f.type.name === 'UnitNumber');
        }
        /** Data element ID "VAD". A unique combination of alphanumeric characters that identifies a specific vehicle or component. The VIN is affixed to the vehicle in specific locations and formulated by the manufacturer. State agencies under some controlled instances may assign a VIN to a vehicle. */
        get vehicleIdentificationNumber() {
            return this.document.fields.find((f) => f.type.name === 'VehicleIdentificationNumber');
        }
        /** Data element ID "VAK". The distinctive (coded) name applied to a group of vehicles by a manufacturer. */
        get vehicleMake() {
            return this.document.fields.find((f) => f.type.name === 'VehicleMake');
        }
        /** Data element ID "RBM". The ZIP or Postal code of the resident address of the registrant. */
        get zipCode() {
            return this.document.fields.find((f) => f.type.name === 'ZipCode');
        }
    }
    AAMVA.RegistrantAndVehicleData = RegistrantAndVehicleData;
    /** Vehicle Owner Data. File type "OW". */
    class VehicleOwnerData {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        requiredDocumentType() {
            return AAMVAVehicleOwnerDataDocumentType;
        }
        /** Data element ID "NAX". The unique customer number/ID of the first vehicle owner. */
        get firstOwnerIdNumber() {
            return this.document.fields.find((f) => f.type.name === 'FirstOwnerIdNumber');
        }
        /** Data element ID "NAB". Last Name or Surname of the Owner. Hyphenated names acceptable, spaces between names acceptable, but no other use of special symbols. */
        get firstOwnerLastName() {
            return this.document.fields.find((f) => f.type.name === 'FirstOwnerLastName');
        }
        /** Data element ID "NBA". The legal status of the first vehicle owner. This is only used when a vehicle has multiple owners. A legal status may be ("AND", "OR"). */
        get firstOwnerLegalStatus() {
            return this.document.fields.find((f) => f.type.name === 'FirstOwnerLegalStatus');
        }
        /** Data element ID "NAD". Middle Name(s) or Initial(s) of the Owner. Hyphenated names acceptable, spaces, between names acceptable, but no other use of special symbols. */
        get firstOwnerMiddleName() {
            return this.document.fields.find((f) => f.type.name === 'FirstOwnerMiddleName');
        }
        /** Data element ID "NAC". First Name or Given Name of the Owner. Hyphenated names acceptable, but no other use of special symbols. */
        get firstOwnerName() {
            return this.document.fields.find((f) => f.type.name === 'FirstOwnerName');
        }
        /** Data element ID "NAA". Name of the (or one of the) individual(s) who owns the Vehicle as defined in the ANSI D- 20 Data Element Dictionary. (Lastname@Firstname@MI@Suffix if any.) */
        get firstOwnerTotalName() {
            return this.document.fields.find((f) => f.type.name === 'FirstOwnerTotalName');
        }
        /** Data element ID "NAR". Street address line 1. (Mailing) */
        get mailingAddress1() {
            return this.document.fields.find((f) => f.type.name === 'MailingAddress1');
        }
        /** Data element ID "NAS". Street address line 2. (Mailing) */
        get mailingAddress2() {
            return this.document.fields.find((f) => f.type.name === 'MailingAddress2');
        }
        /** Data element ID "NAT". Name of city for mailing address. */
        get mailingCity() {
            return this.document.fields.find((f) => f.type.name === 'MailingCity');
        }
        /** Data element ID "NAU". Jurisdiction code for mailing address. Conforms to Canadian, Mexican and US jurisdictions as appropriate. Codes for provinces (Canada) and states (US and Mexico). */
        get mailingJurisdictionCode() {
            return this.document.fields.find((f) => f.type.name === 'MailingJurisdictionCode');
        }
        /** Data element ID "NAV". The ZIP code or Postal code used for mailing. (As used by Canadian, Mexican and US jurisdictions.) */
        get mailingZipCode() {
            return this.document.fields.find((f) => f.type.name === 'MailingZipCode');
        }
        /** Data element ID "NAM". Street address line 1. (Mailing) */
        get residenceAddress1() {
            return this.document.fields.find((f) => f.type.name === 'ResidenceAddress1');
        }
        /** Data element ID "NAN". Street address line 2. (Mailing) */
        get residenceAddress2() {
            return this.document.fields.find((f) => f.type.name === 'ResidenceAddress2');
        }
        /** Data element ID "NAO". Name of city for mailing address. */
        get residenceCity() {
            return this.document.fields.find((f) => f.type.name === 'ResidenceCity');
        }
        /** Data element ID "NAP". Jurisdiction code for mailing address. Conforms to Canadian, Mexican and US jurisdictions as appropriate. Codes for provinces (Canada) and states (US and Mexico). */
        get residenceJurisdictionCode() {
            return this.document.fields.find((f) => f.type.name === 'ResidenceJurisdictionCode');
        }
        /** Data element ID "NAQ". The ZIP code or Postal code used for mailing. (As used by Canadian, Mexican and US jurisdictions). */
        get residenceZipCode() {
            return this.document.fields.find((f) => f.type.name === 'ResidenceZipCode');
        }
        /** Data element ID "NAY". The unique customer number/ID of the second vehicle owner. */
        get secondOwnerIdNumber() {
            return this.document.fields.find((f) => f.type.name === 'SecondOwnerIdNumber');
        }
        /** Data element ID "NAF". Last Name or Surname of the Owner. Hyphenated names acceptable, spaces between names acceptable, but no other use of special symbols. */
        get secondOwnerLastName() {
            return this.document.fields.find((f) => f.type.name === 'SecondOwnerLastName');
        }
        /** Data element ID "NBB". The legal status of the second vehicle owner. This is only used when a vehicle has multiple owners. A legal status may be ("AND", "OR"). */
        get secondOwnerLegalStatus() {
            return this.document.fields.find((f) => f.type.name === 'SecondOwnerLegalStatus');
        }
        /** Data element ID "NAH". Middle Name(s) or Initial(s) of the Owner. Hyphenated names acceptable, spaces between names acceptable, but no other use of special symbols. */
        get secondOwnerMiddleName() {
            return this.document.fields.find((f) => f.type.name === 'SecondOwnerMiddleName');
        }
        /** Data element ID "NAG". First Name or Given Name of the Owner. Hyphenated names acceptable, but no other use of special symbols. */
        get secondOwnerName() {
            return this.document.fields.find((f) => f.type.name === 'SecondOwnerName');
        }
        /** Data element ID "NAE". Name of the (or one of the) individual(s) who owns the Vehicle as defined in the ANSI D- 20 Data Element Dictionary. (Lastname@Firstname@MI@Suffix if any.) */
        get secondOwnerTotalName() {
            return this.document.fields.find((f) => f.type.name === 'SecondOwnerTotalName');
        }
    }
    AAMVA.VehicleOwnerData = VehicleOwnerData;
    /** Vehicle Data. File type "VH". */
    class VehicleData {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        requiredDocumentType() {
            return AAMVAVehicleDataDocumentType;
        }
        /** Data element ID "VAO". Vehicle manufacture body style. */
        get bodyStyle() {
            return this.document.fields.find((f) => f.type.name === 'BodyStyle');
        }
        /** Data element ID "VAG". Date vehicle reported junked. The format is ISO8601 with delimiters. */
        get dateJunked() {
            return this.document.fields.find((f) => f.type.name === 'DateJunked');
        }
        /** Data element ID "VAJ". Date vehicle reported recovered. The format is ISO8601 with delimiters. */
        get dateRecovered() {
            return this.document.fields.find((f) => f.type.name === 'DateRecovered');
        }
        /** Data element ID "VAI". Date vehicle reported stolen. The format is ISO8601 with delimiters. */
        get dateStolen() {
            return this.document.fields.find((f) => f.type.name === 'DateStolen');
        }
        /** Data element ID "VAW". Manufacturer’s rated engine displacement. */
        get engineDisplacement() {
            return this.document.fields.find((f) => f.type.name === 'EngineDisplacement');
        }
        /** Data element ID "VAR". The size of a vehicle’s engine. */
        get engineSize() {
            return this.document.fields.find((f) => f.type.name === 'EngineSize');
        }
        /** Data element ID "VAN". Type of fuel the vehicle utilizes. */
        get fuelType() {
            return this.document.fields.find((f) => f.type.name === 'FuelType');
        }
        /** Data element ID "VAU". Manufacturer’s rated horsepower. */
        get horsepower() {
            return this.document.fields.find((f) => f.type.name === 'Horsepower');
        }
        /** Data element ID "VAY". International fuel tax indicator */
        get iftaIndicator() {
            return this.document.fields.find((f) => f.type.name === 'IFTAIndicator');
        }
        /** Data element ID "VAX". International registration plan indicator. */
        get irpIndicator() {
            return this.document.fields.find((f) => f.type.name === 'IRPIndicator');
        }
        /** Data element ID "VAF". Vehicle has been junked. */
        get junkedIndicator() {
            return this.document.fields.find((f) => f.type.name === 'JunkedIndicator');
        }
        /** Data element ID "VAE". Manufacturer’s Suggested Retail Price. No decimal places. Right Justified Zero or space fill. */
        get msrp() {
            return this.document.fields.find((f) => f.type.name === 'MSRP');
        }
        /** Data element ID "VAA". State to provide definition. */
        get majorCode() {
            return this.document.fields.find((f) => f.type.name === 'MajorCode');
        }
        /** Data element ID "VAL". Vehicle manufacture year. */
        get makeYear() {
            return this.document.fields.find((f) => f.type.name === 'MakeYear');
        }
        /** Data element ID "VAT". Manufacturer’s gross vehicle weight rating. */
        get manufactureGrossWeight() {
            return this.document.fields.find((f) => f.type.name === 'ManufactureGrossWeight');
        }
        /** Data element ID "VAB". State to provide definition. */
        get minorCode() {
            return this.document.fields.find((f) => f.type.name === 'MinorCode');
        }
        /** Data element ID "VBC". Number of axles the vehicle has. */
        get numberOfAxles() {
            return this.document.fields.find((f) => f.type.name === 'NumberOfAxles');
        }
        /** Data element ID "VAQ". Number of cylinders the vehicle has. */
        get numberOfCylinders() {
            return this.document.fields.find((f) => f.type.name === 'NumberOfCylinders');
        }
        /** Data element ID "VAP". Number of doors on the vehicle. */
        get numberOfDoors() {
            return this.document.fields.find((f) => f.type.name === 'NumberOfDoors');
        }
        /** Data element ID "VAH". Indicates stolen vehicle. */
        get stolenIndicator() {
            return this.document.fields.find((f) => f.type.name === 'StolenIndicator');
        }
        /** Data element ID "VAC". Type of transmission the vehicle carries. */
        get transmissionCode() {
            return this.document.fields.find((f) => f.type.name === 'TransmissionCode');
        }
        /** Data element ID "VAV". Gross weight of the vehicle unloaded. */
        get unladenWeight() {
            return this.document.fields.find((f) => f.type.name === 'UnladenWeight');
        }
        /** Data element ID "VAZ". Vehicle license tax calculation from date of purchase. */
        get vltClacFromDate() {
            return this.document.fields.find((f) => f.type.name === 'VLTClacFromDate');
        }
        /** Data element ID "VBA". Unique number to identify the vehicle record. */
        get vehicleIdNumber() {
            return this.document.fields.find((f) => f.type.name === 'VehicleIdNumber');
        }
        /** Data element ID "VAD". A unique combination of alphanumeric characters that identifies a specific vehicle or component. The VIN is affixed to the vehicle in specific locations and formulated by the manufacturer. State agencies under some controlled instances may assign a VIN to a vehicle. */
        get vehicleIdentificationNumber() {
            return this.document.fields.find((f) => f.type.name === 'VehicleIdentificationNumber');
        }
        /** Data element ID "VAK". The distinctive (coded) name applied to a group of vehicles by a manufacturer. */
        get vehicleMake() {
            return this.document.fields.find((f) => f.type.name === 'VehicleMake');
        }
        /** Data element ID "VAM". Vehicle manufacture model. */
        get vehicleModel() {
            return this.document.fields.find((f) => f.type.name === 'VehicleModel');
        }
        /** Data element ID "VAS". This is the status of the vehicle (e.g., active, suspend, etc.) */
        get vehicleStatusCode() {
            return this.document.fields.find((f) => f.type.name === 'VehicleStatusCode');
        }
        /** Data element ID "VBB". EPA vehicle classification. */
        get vehicleTypeCode() {
            return this.document.fields.find((f) => f.type.name === 'VehicleTypeCode');
        }
    }
    AAMVA.VehicleData = VehicleData;
    /** Vehicle Safety Inspection Data. File type "VS". */
    class VehicleSafetyInspectionData {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        requiredDocumentType() {
            return AAMVAVehicleSafetyInspectionDataDocumentType;
        }
        /** Data element ID "IAN". The street name and number, city, state and zip code of the inspection facility. */
        get inspectionAddress() {
            return this.document.fields.find((f) => f.type.name === 'InspectionAddress');
        }
        /** Data element ID "IPD". Identifies whether the pollution control devices meet the minimum inspection criteria. */
        get inspectionAirPollutionDeviceConditions() {
            return this.document.fields.find((f) => f.type.name === 'InspectionAirPollutionDeviceConditions');
        }
        /** Data element ID "IFI". The unique number assigned to an inspection facility. */
        get inspectionFacilityIdentifier() {
            return this.document.fields.find((f) => f.type.name === 'InspectionFacilityIdentifier');
        }
        /** Data element ID "INC". A unique number assigned to a current vehicle inspection form for identification purposes or a preprinted unique number on the motor vehicle inspection sticker currently issued to a motor vehicle which has passed inspection. */
        get inspectionFormOrStickerNumberCurrent() {
            return this.document.fields.find((f) => f.type.name === 'InspectionFormOrStickerNumberCurrent');
        }
        /** Data element ID "INP". The number of the last inspection form excluding the current inspection or the certification number of the last inspection sticker, excluding the current inspection. */
        get inspectionFormOrStickerNumberPrevious() {
            return this.document.fields.find((f) => f.type.name === 'InspectionFormOrStickerNumberPrevious');
        }
        /** Data element ID "ISC". An indicator that specifies whether or not the vehicle has a current smog certificate. */
        get inspectionSmogCertificateIndicator() {
            return this.document.fields.find((f) => f.type.name === 'InspectionSmogCertificateIndicator');
        }
        /** Data element ID "ISN". Station number performing the inspection. */
        get inspectionStationNumber() {
            return this.document.fields.find((f) => f.type.name === 'InspectionStationNumber');
        }
        /** Data element ID "IIN". A unique number assigned to each licensed vehicle inspector. */
        get inspectorIdentificationNumber() {
            return this.document.fields.find((f) => f.type.name === 'InspectorIdentificationNumber');
        }
        /** Data element ID "ORI". The vehicle’s odometer reading (to the nearest mile or kilometer) at the time of inspection. */
        get odometerReadingAtInspection() {
            return this.document.fields.find((f) => f.type.name === 'OdometerReadingAtInspection');
        }
        /** Data element ID "VAO". The general configuration or shape of a vehicle distinguished by characteristics such as number of doors, seats, windows, roofline, and type of top. The vehicle body type is 2- character alphanumeric. */
        get vehicleBodyType() {
            return this.document.fields.find((f) => f.type.name === 'VehicleBodyType');
        }
        /** Data element ID "VAK". The distinctive (coded) name applied to a group of vehicles by a manufacturer. */
        get vehicleMake() {
            return this.document.fields.find((f) => f.type.name === 'VehicleMake');
        }
        /** Data element ID "VAL". The year which is assigned to a vehicle by the manufacturer. The format is CCYY. */
        get vehicleModelYear() {
            return this.document.fields.find((f) => f.type.name === 'VehicleModelYear');
        }
    }
    AAMVA.VehicleSafetyInspectionData = VehicleSafetyInspectionData;
    /** Driver License Or ID Document */
    class DLID {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        /** Data element ID "DAI". City portion of the cardholder address. */
        get addressCity() {
            return this.document.fields.find((f) => f.type.name === 'AddressCity');
        }
        /** Data element ID "DAJ". State portion of the cardholder address. */
        get addressJurisdictionCode() {
            return this.document.fields.find((f) => f.type.name === 'AddressJurisdictionCode');
        }
        /** Data element ID "DAK". Postal code portion of the cardholder address in the U.S. and Canada. If the trailing portion of the postal code in the U.S. is not known, zeros will be used to fill the trailing set of numbers up to nine (9) digits. */
        get addressPostalCode() {
            return this.document.fields.find((f) => f.type.name === 'AddressPostalCode');
        }
        /** Data element ID "DAG". Street portion of the cardholder address. */
        get addressStreet1() {
            return this.document.fields.find((f) => f.type.name === 'AddressStreet1');
        }
        /** Data element ID "DAH". Second line of street portion of the cardholder address. */
        get addressStreet2() {
            return this.document.fields.find((f) => f.type.name === 'AddressStreet2');
        }
        /** Data element ID "DCJ". A string of letters and/or numbers that identifies when, where, and by whom a driver license/ID card was made. If audit information is not used on the card or the MRT, it must be included in the driver record. */
        get adultInformation() {
            return this.document.fields.find((f) => f.type.name === 'AdultInformation');
        }
        /** Data element ID "DBN". Other family name by which cardholder is known. */
        get aliasFamilyName() {
            return this.document.fields.find((f) => f.type.name === 'AliasFamilyName');
        }
        /** Data element ID "DBG". Other given name by which cardholder is known. */
        get aliasGivenName() {
            return this.document.fields.find((f) => f.type.name === 'AliasGivenName');
        }
        /** Data element ID "DBQ". Other middle name by which cardholder is known. */
        get aliasMiddleName() {
            return this.document.fields.find((f) => f.type.name === 'AliasMiddleName');
        }
        /** Data element ID "DBR". Other prefix by which cardholder is known. */
        get aliasPrefixName() {
            return this.document.fields.find((f) => f.type.name === 'AliasPrefixName');
        }
        /** Data element ID "DBS". Other suffix by which cardholder is known. */
        get aliasSuffixName() {
            return this.document.fields.find((f) => f.type.name === 'AliasSuffixName');
        }
        /** Data element ID "DDB". DHS required field that indicates date of the most recent version change or modification to the visible format of the DL/ID. The format is ISO8601 with delimiters. */
        get cardRevisionDate() {
            return this.document.fields.find((f) => f.type.name === 'CardRevisionDate');
        }
        /** Data element ID "DDA". DHS required field that indicates compliance: "F" = compliant; and, "N" = non-compliant. */
        get complianceType() {
            return this.document.fields.find((f) => f.type.name === 'ComplianceType');
        }
        /** Data element ID "DCG". Country in which DL/ID is issued. U.S. = USA, Canada = CAN. */
        get countryIdentification() {
            return this.document.fields.find((f) => f.type.name === 'CountryIdentification');
        }
        /** Data element ID "DCS". Family name of the cardholder. (Family name is sometimes also called “last name” or “surname.”) Collect full name for record, print as many characters as possible on portrait side of DL/ID. */
        get customerFamilyName() {
            return this.document.fields.find((f) => f.type.name === 'CustomerFamilyName');
        }
        /** Data element ID "DAC". First name of the cardholder. */
        get customerFirstName() {
            return this.document.fields.find((f) => f.type.name === 'CustomerFirstName');
        }
        /** Data element ID "DCT". Given names of the cardholder. (Given names include all names other than the Family Name. This includes all those names sometimes also called “first” and “middle” names.) */
        get customerGivenNames() {
            return this.document.fields.find((f) => f.type.name === 'CustomerGivenNames');
        }
        /** Data element ID "DAQ". The number assigned or calculated by the issuing authority. */
        get customerIdNumber() {
            return this.document.fields.find((f) => f.type.name === 'CustomerIdNumber');
        }
        /** Data element ID "DAD". Middle name(s) of the cardholder. In the case of multiple middle names they shall be separated by a comma “,”. */
        get customerMiddleName() {
            return this.document.fields.find((f) => f.type.name === 'CustomerMiddleName');
        }
        /** Data element ID "DBB". Date on which the cardholder was born. The format is ISO8601 with delimiters. */
        get dateOfBirth() {
            return this.document.fields.find((f) => f.type.name === 'DateOfBirth');
        }
        /** Data element ID "DCF". Number must uniquely identify a particular document issued to that customer from others that may have been issued in the past. This number may serve multiple purposes of document discrimination, audit information number, and/or inventory control. */
        get documentDiscriminator() {
            return this.document.fields.find((f) => f.type.name === 'DocumentDiscriminator');
        }
        /** Data element ID "DBA". Date on which the driving and identification privileges granted by the document are no longer valid. The format is ISO8601 with delimtiers. */
        get documentExpirationDate() {
            return this.document.fields.find((f) => f.type.name === 'DocumentExpirationDate');
        }
        /** Data element ID "DBD". Date on which the document was issued. The format is ISO8601 with delimiters. */
        get documentIssueDate() {
            return this.document.fields.find((f) => f.type.name === 'DocumentIssueDate');
        }
        /** Data element ID "DBL". Alternative dates given as date of birth. */
        get driverAliasDateOfBirthField() {
            return this.document.fields.find((f) => f.type.name === 'DriverAliasDateOfBirthField');
        }
        /** Data element ID "DBP". Alternative fist name or given name of the individual holding the Driver License or ID. Hyphenated names acceptable, but no other use of special symbols. */
        get driverAliasFirstName() {
            return this.document.fields.find((f) => f.type.name === 'DriverAliasFirstName');
        }
        /** Data element ID "DBO". Alternative last name or surname of the individual holding the Driver License or ID. Hyphenated names acceptable, but no other use of special symbols. */
        get driverAliasLastName() {
            return this.document.fields.find((f) => f.type.name === 'DriverAliasLastName');
        }
        /** Data element ID "DBM". DriverAliasSocialSecurityNumber */
        get driverAliasSocialSecurityNumber() {
            return this.document.fields.find((f) => f.type.name === 'DriverAliasSocialSecurityNumber');
        }
        /** Data element ID "DAB". Last name or surname of the individual holding the Driver License or ID. Hyphenated names acceptable, but no other use of special symbols. */
        get driverLastName() {
            return this.document.fields.find((f) => f.type.name === 'DriverLastName');
        }
        /** Data element ID "DAR". A=Class A; B=Class B; C=Class C (Class A, B and C are defined by Federal Highway regulations); M=Class M motorcycle as defined by AAMVA; others are defined by DL Classification Code Standards. */
        get driverLicenseClassificationCode() {
            return this.document.fields.find((f) => f.type.name === 'DriverLicenseClassificationCode');
        }
        /** Data element ID "DAT". Any endorsements on a driver license which authorize the operation of specified types of vehicles or the operation of vehicles carrying specified loads. Endorsements shall be specific to classification of a driver license. */
        get driverLicenseEndorsementsCode() {
            return this.document.fields.find((f) => f.type.name === 'DriverLicenseEndorsementsCode');
        }
        /** Data element ID "DAA". Name of the individual holding the Driver License or ID as defined in ANSI D20 Data Dictionary. (Lastname@Firstname@MI@ suffix if any) (Machine, Mag Stripe uses ‘$’ and Bar Code uses ‘,’ in place of ‘@’) Firstname, Middle Initial, Lastname (Human) */
        get driverLicenseName() {
            return this.document.fields.find((f) => f.type.name === 'DriverLicenseName');
        }
        /** Data element ID "DAS". A restriction applicable to a driver license. */
        get driverLicenseRestrictionCode() {
            return this.document.fields.find((f) => f.type.name === 'DriverLicenseRestrictionCode');
        }
        /** Data element ID "DAF". Prefix to Driver Name. Not defined in ANSI D20. Freeform as defined by issuing jurisdiction. */
        get driverNamePrefix() {
            return this.document.fields.find((f) => f.type.name === 'DriverNamePrefix');
        }
        /** Data element ID "DAE". An affix occurring at the end of a word, e.g.; Sr., Jr., II, III, IV, etc. */
        get driverNameSuffix() {
            return this.document.fields.find((f) => f.type.name === 'DriverNameSuffix');
        }
        /** Data element ID "PAA". Identifies the type of permit as defined by ANSI D20. */
        get driverPermitClassificationCode() {
            return this.document.fields.find((f) => f.type.name === 'DriverPermitClassificationCode');
        }
        /** Data element ID "PAF". Permit endorsements as defined by ANSI D20. */
        get driverPermitEndorsementCode() {
            return this.document.fields.find((f) => f.type.name === 'DriverPermitEndorsementCode');
        }
        /** Data element ID "PAD".  Date permit was issued. The format is ISO8601 with delimiters. */
        get driverPermitIssueDate() {
            return this.document.fields.find((f) => f.type.name === 'DriverPermitIssueDate');
        }
        /** Data element ID "PAE". Permit restrictions as defined by ANSI D20. */
        get driverPermitRestrictionCode() {
            return this.document.fields.find((f) => f.type.name === 'DriverPermitRestrictionCode');
        }
        /** Data element ID "DAN". Name of city for mailing address. */
        get driverResidenceCity() {
            return this.document.fields.find((f) => f.type.name === 'DriverResidenceCity');
        }
        /** Data element ID "DAO". Jurisdiction code for mailing address. Conforms to Canadian, Mexican and US Jurisdictions as appropriate. Codes for provinces (Canada) and states (US and Mexico). */
        get driverResidenceJurisdictionCode() {
            return this.document.fields.find((f) => f.type.name === 'DriverResidenceJurisdictionCode');
        }
        /** Data element ID "DAP". Postal code of residence */
        get driverResidencePostalCode() {
            return this.document.fields.find((f) => f.type.name === 'DriverResidencePostalCode');
        }
        /** Data element ID "DAL". Street address line 1 (mailing). */
        get driverResidenceStreetAddress1() {
            return this.document.fields.find((f) => f.type.name === 'DriverResidenceStreetAddress1');
        }
        /** Data element ID "DAM". Street address line 2 (mailing). */
        get driverResidenceStreetAddress2() {
            return this.document.fields.find((f) => f.type.name === 'DriverResidenceStreetAddress2');
        }
        /** Data element ID "DDE". A code that indicates whether a field has been truncated (T), has not been truncated (N), or – unknown whether truncated (U). */
        get familyNameTruncation() {
            return this.document.fields.find((f) => f.type.name === 'FamilyNameTruncation');
        }
        /** Data element ID "DCH". Federal Commercial Vehicle Codes */
        get federalCommercialVehicleCodes() {
            return this.document.fields.find((f) => f.type.name === 'FederalCommercialVehicleCodes');
        }
        /** Data element ID "DDF". A code that indicates whether a field has been truncated (T), has not been truncated (N), or – unknown whether truncated (U). */
        get firstNameTruncation() {
            return this.document.fields.find((f) => f.type.name === 'FirstNameTruncation');
        }
        /** Data element ID "DDC". Date on which the hazardous material endorsement granted by the document is no longer valid. The format is ISO8601 with delimiters. */
        get hazmatEndorsementExpirationDate() {
            return this.document.fields.find((f) => f.type.name === 'HAZMATEndorsementExpirationDate');
        }
        /** Data element ID "DAZ". Color of cardholder's hair. ANSI D-20 codes converted to human readable format according to the ANSI D20 Data Dictionary. */
        get hairColor() {
            return this.document.fields.find((f) => f.type.name === 'HairColor');
        }
        /** Data element ID "DAV". Height in centimeters */
        get height() {
            return this.document.fields.find((f) => f.type.name === 'Height');
        }
        /** Data element ID "DCK". A string of letters and/or numbers that is affixed to the raw materials (card stock, laminate, etc.) used in producing driver licenses and ID cards. (DHS recommended field). */
        get inventoryControlNumber() {
            return this.document.fields.find((f) => f.type.name === 'InventoryControlNumber');
        }
        /** Data element ID "DBE". A string used by some jurisdictions to validate the document against their data base. */
        get issueTimeStamp() {
            return this.document.fields.find((f) => f.type.name === 'IssueTimeStamp');
        }
        /** Data element ID "DCQ". Text that explains the jurisdiction-specific code(s) that indicates additional driving privileges granted to the cardholder beyond the vehicle class. */
        get jurisdictionSpecificEndorsementCodeDescription() {
            return this.document.fields.find((f) => f.type.name === 'JurisdictionSpecificEndorsementCodeDescription');
        }
        /** Data element ID "DCD". Jurisdiction-specific codes that represent additional privileges granted to the cardholder beyond the vehicle class (such as transportation of passengers, hazardous materials, operation of motorcycles, etc.). */
        get jurisdictionSpecificEndorsementCodes() {
            return this.document.fields.find((f) => f.type.name === 'JurisdictionSpecificEndorsementCodes');
        }
        /** Data element ID "DCR". Text describing the jurisdiction-specific restriction code(s) that curtail driving privileges. */
        get jurisdictionSpecificRestrictionCodeDescription() {
            return this.document.fields.find((f) => f.type.name === 'JurisdictionSpecificRestrictionCodeDescription');
        }
        /** Data element ID "DCB". Jurisdiction-specific codes that represent restrictions to driving privileges (such as airbrakes, automatic transmission, daylight only, etc.). */
        get jurisdictionSpecificRestrictionCodes() {
            return this.document.fields.find((f) => f.type.name === 'JurisdictionSpecificRestrictionCodes');
        }
        /** Data element ID "DCA". Jurisdiction-specific vehicle class / group code, designating the type of vehicle the cardholder has privilege to drive. */
        get jurisdictionSpecificVehicleClass() {
            return this.document.fields.find((f) => f.type.name === 'JurisdictionSpecificVehicleClass');
        }
        /** Data element ID "DCP". Text that explains the jurisdiction-specific code(s) for classifications of vehicles cardholder is authorized to drive. */
        get jurisdictionSpecificVehicleClassificationDescription() {
            return this.document.fields.find((f) => f.type.name === 'JurisdictionSpecificVehicleClassificationDescription');
        }
        /** Data element ID "DDD". DHS required field that indicates that the cardholder has temporary lawful status = "1". */
        get limitedDurationDocumentIndicator() {
            return this.document.fields.find((f) => f.type.name === 'LimitedDurationDocumentIndicator');
        }
        /** Data element ID "DDG". A code that indicates whether a field has been truncated (T), has not been truncated (N), or – unknown whether truncated (U). */
        get middleNameTruncation() {
            return this.document.fields.find((f) => f.type.name === 'MiddleNameTruncation');
        }
        /** Data element ID "DCU". Name Suffix (If jurisdiction participates in systems requiring name suffix (PDPS, CDLIS, etc.), the suffix must be collected and displayed on the DL/ID and in the MRT). Collect full name for record, print as many characters as possible on portrait side of DL/ID. JR (Junior), SR (Senior), 1ST or I (First), 2ND or II (Second),  3RD or III (Third),  4TH or IV (Fourth), 5TH or V (Fifth), 6TH or VI (Sixth), 7TH or VII (Seventh), 8TH or VIII (Eighth), 9TH or IX (Ninth). */
        get nameSuffix() {
            return this.document.fields.find((f) => f.type.name === 'NameSuffix');
        }
        /** Data element ID "DBI". "Y"; Used by some jurisdictions to indicate holder of the document is a non-resident. */
        get nonResidentIndicator() {
            return this.document.fields.find((f) => f.type.name === 'NonResidentIndicator');
        }
        /** Data element ID "DBF". Number of duplicate cards issued for a license or ID if any. */
        get numberOfDuplicates() {
            return this.document.fields.find((f) => f.type.name === 'NumberOfDuplicates');
        }
        /** Data element ID "DBH". Organ Donor */
        get organDonor() {
            return this.document.fields.find((f) => f.type.name === 'OrganDonor');
        }
        /** Data element ID "DDK". Field that indicates that the cardholder is an organ donor = "1". */
        get organDonorIndicator() {
            return this.document.fields.find((f) => f.type.name === 'OrganDonorIndicator');
        }
        /** Data element ID "PAB". Date permit expires, The format is ISO8601 with delimiters. */
        get permitExpirationDate() {
            return this.document.fields.find((f) => f.type.name === 'PermitExpirationDate');
        }
        /** Data element ID "PAC". Type of permit. */
        get permitIdentifier() {
            return this.document.fields.find((f) => f.type.name === 'PermitIdentifier');
        }
        /** Data element ID "DAY". Color of cardholder's eyes. ANSI D-20 codes converted to human readable format according to the ANSI D20 Data Dictionary. */
        get physicalDescriptionEyeColor() {
            return this.document.fields.find((f) => f.type.name === 'PhysicalDescriptionEyeColor');
        }
        /** Data element ID "DAU". Height of cardholder. Inches (in): number of inches followed by " in" or Centimeters (cm): number of centimeters followed by " cm." */
        get physicalDescriptionHeight() {
            return this.document.fields.find((f) => f.type.name === 'PhysicalDescriptionHeight');
        }
        /** Data element ID "DBC". Gender of the cardholder. "Male" or "Female". */
        get physicalDescriptionSex() {
            return this.document.fields.find((f) => f.type.name === 'PhysicalDescriptionSex');
        }
        /** Data element ID "DCE". Indicates the approximate weight range of the cardholder: 0 = up to 31 kg (up to 70 lbs), 1 = 32 – 45 kg (71 – 100 lbs), 2 = 46 - 59 kg (101 – 130 lbs), 3 = 60 - 70 kg (131 – 160 lbs), 4 = 71 - 86 kg (161 – 190 lbs), 5 = 87 - 100 kg (191 – 220 lbs), 6 = 101 - 113 kg (221 – 250 lbs), 7 = 114 - 127 kg (251 – 280 lbs), 8 = 128 – 145 kg (281 – 320 lbs), 9 = 146+ kg (321+ lbs). */
        get physicalDescriptionWeightRange() {
            return this.document.fields.find((f) => f.type.name === 'PhysicalDescriptionWeightRange');
        }
        /** Data element ID "DCI". Country and municipality and/or state/province. */
        get placeOfBirth() {
            return this.document.fields.find((f) => f.type.name === 'PlaceOfBirth');
        }
        /** Data element ID "DCL". Codes for race or ethnicity of the cardholder. ANSI D-20 codes converted to human readable format according to the ANSI D20 Data Dictionary. */
        get raceEthnicity() {
            return this.document.fields.find((f) => f.type.name === 'RaceEthnicity');
        }
        /** Data element ID "DBK". The number assigned to an individual by the Social Security Administration. */
        get socialSecurityNumber() {
            return this.document.fields.find((f) => f.type.name === 'SocialSecurityNumber');
        }
        /** Data element ID "DCN". Standard endorsement code(s) for cardholder. See codes in D20. This data element is a placeholder for future efforts to standardize endorsement codes. */
        get standardEndorsementCode() {
            return this.document.fields.find((f) => f.type.name === 'StandardEndorsementCode');
        }
        /** Data element ID "DCO". Standard restriction code(s) for cardholder. See codes in D20. This data element is a placeholder for future efforts to standardize restriction codes. */
        get standardRestrictionCode() {
            return this.document.fields.find((f) => f.type.name === 'StandardRestrictionCode');
        }
        /** Data element ID "DCM". Standard vehicle classification code(s) for cardholder. This data element is a placeholder for future efforts to standardize vehicle classifications. */
        get standardVehicleClassification() {
            return this.document.fields.find((f) => f.type.name === 'StandardVehicleClassification');
        }
        /** Data element ID "DDH". Date on which the cardholder turns 18 years old. The format is ISO8601 with delimiters. */
        get under18Until() {
            return this.document.fields.find((f) => f.type.name === 'Under18Until');
        }
        /** Data element ID "DDI". Date on which the cardholder turns 19 years old. The format is ISO8601 with delimiters. */
        get under19Until() {
            return this.document.fields.find((f) => f.type.name === 'Under19Until');
        }
        /** Data element ID "DDJ". Date on which the cardholder turns 21 years old. The format is ISO8601 with delimiters. */
        get under21Until() {
            return this.document.fields.find((f) => f.type.name === 'Under21Until');
        }
        /** Data element ID "DBJ". A number or alphanumeric string used by some jurisdictions to identify a "customer" across multiple data bases. */
        get uniqueCustomerIdentifier() {
            return this.document.fields.find((f) => f.type.name === 'UniqueCustomerIdentifier');
        }
        /** Data element ID "DDL". Field that indicates that the cardholder is a veteran = "1". */
        get veteranIndicator() {
            return this.document.fields.find((f) => f.type.name === 'VeteranIndicator');
        }
        /** Data element ID "DAX". Cardholder weight in kilograms Ex. 84 kg = "084" */
        get weightKilograms() {
            return this.document.fields.find((f) => f.type.name === 'WeightKilograms');
        }
        /** Data element ID "DAW". Cardholder weight in pounds Ex. 185 lb = "185" */
        get weightPounds() {
            return this.document.fields.find((f) => f.type.name === 'WeightPounds');
        }
    }
    AAMVA.DLID = DLID;
    /** Driver License. File type "DL". */
    class DriverLicense extends DLID {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return AAMVADriverLicenseDocumentType;
        }
    }
    AAMVA.DriverLicense = DriverLicense;
    /** ID Card. File type "ID". */
    class IDCard extends DLID {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return AAMVAIDCardDocumentType;
        }
    }
    AAMVA.IDCard = IDCard;
    /** Enhanced Driver License. File type "EN". */
    class EnhancedDriverLicense extends DLID {
        constructor(document) {
            super(document);
        }
        requiredDocumentType() {
            return AAMVAEnhancedDriverLicenseDocumentType;
        }
    }
    AAMVA.EnhancedDriverLicense = EnhancedDriverLicense;
    /** The raw document as was parsed from the barcode. The original field key names and field values as they appear in the barcode are left as-is. The mnemonic field keys from the AAMVA specification are not replaced with human-readable names. No field value normalization, like ISO 8601 date reformatting, etc., is done. */
    class RawDocument {
        get document() {
            return this._document;
        }
        constructor(document) {
            if (document.type.name !== this.requiredDocumentType()) {
                throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
            }
            this._document = document;
        }
        requiredDocumentType() {
            return AAMVARawDocumentDocumentType;
        }
    }
    AAMVA.RawDocument = RawDocument;
})(AAMVA || (AAMVA = {}));
/** HIBC */
class HIBC {
    get document() {
        return this._document;
    }
    constructor(document) {
        if (document.type.name !== this.requiredDocumentType()) {
            throw new Error(`Expected document type ${this.requiredDocumentType()}, got ${document.type.name}`);
        }
        this._document = document;
    }
    requiredDocumentType() {
        return HIBCDocumentType;
    }
    /** Date of Manufacture */
    get dateOfManufacture() {
        return this.document.fields.find((f) => f.type.name === 'DateOfManufacture');
    }
    /** Expiry Date Day */
    get expiryDateDay() {
        return this.document.fields.find((f) => f.type.name === 'ExpiryDateDay');
    }
    /** Expiry Date Hour */
    get expiryDateHour() {
        return this.document.fields.find((f) => f.type.name === 'ExpiryDateHour');
    }
    /** Expiry Date Julian Day */
    get expiryDateJulianDay() {
        return this.document.fields.find((f) => f.type.name === 'ExpiryDateJulianDay');
    }
    /** Expiry Date Month */
    get expiryDateMonth() {
        return this.document.fields.find((f) => f.type.name === 'ExpiryDateMonth');
    }
    /** Expiry Date Year */
    get expiryDateYear() {
        return this.document.fields.find((f) => f.type.name === 'ExpiryDateYear');
    }
    /** Information whether primary data is present. */
    get hasPrimaryData() {
        return this.document.fields.find((f) => f.type.name === 'HasPrimaryData');
    }
    /** Information whether secondary data is present. */
    get hasSecondaryData() {
        return this.document.fields.find((f) => f.type.name === 'HasSecondaryData');
    }
    /** Labeler Identification Code (LIC) */
    get labelerIdentificationCode() {
        return this.document.fields.find((f) => f.type.name === 'LabelerIdentificationCode');
    }
    /** Labelers Product or Catalog Number (PCN). Alphanumeric data. */
    get labelersProductOrCatalogNumber() {
        return this.document.fields.find((f) => f.type.name === 'LabelersProductOrCatalogNumber');
    }
    /** Link character to link standalone primary and secondary barcodes together. */
    get linkCharacter() {
        return this.document.fields.find((f) => f.type.name === 'LinkCharacter');
    }
    /** Lot Number */
    get lotNumber() {
        return this.document.fields.find((f) => f.type.name === 'LotNumber');
    }
    /** Quantity */
    get quantity() {
        return this.document.fields.find((f) => f.type.name === 'Quantity');
    }
    /** Serial Number */
    get serialNumber() {
        return this.document.fields.find((f) => f.type.name === 'SerialNumber');
    }
    /** Unit of Measure ID, Numeric value only, 0 through 9, where 0 always represents
  a single unit. 1 to 8 are used to indicate different packaging levels above the unit of use.
  The value 9 is used for variable quantity containers when manual key entry or scan of
  a secondary will be used to collect specific quantity data.
  The labeler should ensure consistency in this field within their packaging process.
   */
    get unitOfMeasureID() {
        return this.document.fields.find((f) => f.type.name === 'UnitOfMeasureID');
    }
}

/// Auto-generated with ScanbotSDKCodegenV3. Modifications will be overwritten.
/// Generated from core/schemas/ImageTypes.yaml
const ImageRotationValues = ['NONE', 'CLOCKWISE_90', 'CLOCKWISE_180', 'COUNTERCLOCKWISE_90'];

/** @internal */
const ScanbotBarcodeSDKPlugin = core.registerPlugin('ScanbotBarcodeSDK', {});
const ScanbotBarcodeSDK = {
    /**
     * Initialize the Scanbot Barcode Scanner SDK with the preferred configuration.
     *
     * @param {ScanbotBarcodeSdkConfiguration} config
     * @returns {Promise<LicenseInfoResult>}
     */
    initializeSdk(config) {
        return ScanbotBarcodeSDKPlugin.initializeSdk(config);
    },
    /**
     * Provides complete information about the current license status.
     *
     * @returns {Promise<LicenseInfoResult>}
     */
    getLicenseInfo() {
        return ScanbotBarcodeSDKPlugin.getLicenseInfo();
    },
    /**
     * Remove all files generated by this plugin.
     *
     * @returns {Promise<string>}
     */
    async cleanup() {
        return ScanbotBarcodeSDKPlugin.cleanup().then((jsResultObject) => mapPlainResult(jsResultObject));
    },
    /**
     * Opens the Ready-To-Use UI screen for scanning barcodes with the desired configuration.
     *
     * @param {BarcodeScannerScreenConfiguration} config
     * @returns {Promise<ResultWrapper<BarcodeScannerUiResult>>}
     */
    async startBarcodeScanner(config) {
        if (config.useCase instanceof SingleScanningMode || config.useCase instanceof MultipleScanningMode) {
            const barcodeItemMapperCallback = config.useCase.barcodeInfoMapping.barcodeItemMapper;
            if (barcodeItemMapperCallback !== null) {
                ScanbotBarcodeSDKPlugin.registerBarcodeItemMapperCallback({}, (barcodeItem) => {
                    const barcodeItemUuid = `${barcodeItem.text}${barcodeItem.upcEanExtension}_${barcodeItem.format}`;
                    barcodeItemMapperCallback(barcodeItem, (barcodeMappedData) => ScanbotBarcodeSDKPlugin.onBarcodeItemMapper({
                        barcodeItemUuid,
                        barcodeMappedData,
                    }), () => ScanbotBarcodeSDKPlugin.onBarcodeItemMapper({
                        barcodeItemUuid,
                    }));
                });
                // On iOS, the communication with the native part is throwing an error (startBarcodeScannerV2) because of the barcodeItemMapper
                // callback in the configuration class (not parsable), that's why we need to remove it before executing startBarcodeScannerV2 method
                config.useCase.barcodeInfoMapping.barcodeItemMapper = null;
            }
        }
        return ScanbotBarcodeSDKPlugin.startBarcodeScanner(config).then((result) => mapRTUUIResult(result, BarcodeScannerUiResult));
    },
    /**
     * Detect barcodes on the image represented by the file URL. The image file URL is part of the input arguments.
     *
     * @param {{imageFileUri: string, configuration: BarcodeScannerConfiguration}} params
     * @returns {Promise<BarcodeScannerResult>}
     */
    async detectBarcodesOnImage(params) {
        return ScanbotBarcodeSDKPlugin.detectBarcodesOnImage(params).then((result) => new BarcodeScannerResult(result));
    },
    /**
     * Extract images from a PDF represented by the file URL. The PDF file URL is part of the input parameters.
     *
     * @param {ExtractImagesFromPdfArguments} params
     * @returns {Promise<string[]>}
     */
    async extractImagesFromPDF(params) {
        return ScanbotBarcodeSDKPlugin.extractImagesFromPDF(params).then((jsResultObject) => mapPlainResult(jsResultObject));
    },
    /**
     * Returns the Base 64 encoded representation of the image data.
     */
    async getImageData(params) {
        return ScanbotBarcodeSDKPlugin.getImageData(params).then((jsResultObject) => mapPlainResult(jsResultObject));
    },
};

exports.AAMVA = AAMVA;
exports.AAMVADLIDDocumentType = AAMVADLIDDocumentType;
exports.AAMVADocumentType = AAMVADocumentType;
exports.AAMVADriverLicenseDocumentType = AAMVADriverLicenseDocumentType;
exports.AAMVAEnhancedDriverLicenseDocumentType = AAMVAEnhancedDriverLicenseDocumentType;
exports.AAMVAIDCardDocumentType = AAMVAIDCardDocumentType;
exports.AAMVAMotorCarrierDataDocumentType = AAMVAMotorCarrierDataDocumentType;
exports.AAMVARawDocumentDocumentType = AAMVARawDocumentDocumentType;
exports.AAMVARegistrantAndVehicleDataDocumentType = AAMVARegistrantAndVehicleDataDocumentType;
exports.AAMVARegistrationDataDocumentType = AAMVARegistrationDataDocumentType;
exports.AAMVATitleDataDocumentType = AAMVATitleDataDocumentType;
exports.AAMVAVehicleDataDocumentType = AAMVAVehicleDataDocumentType;
exports.AAMVAVehicleOwnerDataDocumentType = AAMVAVehicleOwnerDataDocumentType;
exports.AAMVAVehicleSafetyInspectionDataDocumentType = AAMVAVehicleSafetyInspectionDataDocumentType;
exports.ActionBarConfiguration = ActionBarConfiguration;
exports.ArOverlayFindAndPickConfiguration = ArOverlayFindAndPickConfiguration;
exports.ArOverlayGeneralConfiguration = ArOverlayGeneralConfiguration;
exports.ArOverlayPolygonConfiguration = ArOverlayPolygonConfiguration;
exports.AspectRatio = AspectRatio;
exports.AustraliaPostCustomerFormatValues = AustraliaPostCustomerFormatValues;
exports.AutoReleasable = AutoReleasable;
exports.BackgroundStyle = BackgroundStyle;
exports.BadgeStyle = BadgeStyle;
exports.BadgedButton = BadgedButton;
exports.BarButtonConfiguration = BarButtonConfiguration;
exports.BarcodeDocumentFormatValues = BarcodeDocumentFormatValues;
exports.BarcodeDocumentFormats = BarcodeDocumentFormats;
exports.BarcodeFormatAustraliaPostConfiguration = BarcodeFormatAustraliaPostConfiguration;
exports.BarcodeFormatAztecConfiguration = BarcodeFormatAztecConfiguration;
exports.BarcodeFormatCodabarConfiguration = BarcodeFormatCodabarConfiguration;
exports.BarcodeFormatCode11Configuration = BarcodeFormatCode11Configuration;
exports.BarcodeFormatCode128Configuration = BarcodeFormatCode128Configuration;
exports.BarcodeFormatCode2Of5Configuration = BarcodeFormatCode2Of5Configuration;
exports.BarcodeFormatCode39Configuration = BarcodeFormatCode39Configuration;
exports.BarcodeFormatCode93Configuration = BarcodeFormatCode93Configuration;
exports.BarcodeFormatCommonConfiguration = BarcodeFormatCommonConfiguration;
exports.BarcodeFormatCommonFourStateConfiguration = BarcodeFormatCommonFourStateConfiguration;
exports.BarcodeFormatCommonOneDConfiguration = BarcodeFormatCommonOneDConfiguration;
exports.BarcodeFormatCommonTwoDConfiguration = BarcodeFormatCommonTwoDConfiguration;
exports.BarcodeFormatDataBarConfiguration = BarcodeFormatDataBarConfiguration;
exports.BarcodeFormatDataBarExpandedConfiguration = BarcodeFormatDataBarExpandedConfiguration;
exports.BarcodeFormatDataBarLimitedConfiguration = BarcodeFormatDataBarLimitedConfiguration;
exports.BarcodeFormatDataMatrixConfiguration = BarcodeFormatDataMatrixConfiguration;
exports.BarcodeFormatGs1CompositeConfiguration = BarcodeFormatGs1CompositeConfiguration;
exports.BarcodeFormatItfConfiguration = BarcodeFormatItfConfiguration;
exports.BarcodeFormatJapanPostConfiguration = BarcodeFormatJapanPostConfiguration;
exports.BarcodeFormatMaxiCodeConfiguration = BarcodeFormatMaxiCodeConfiguration;
exports.BarcodeFormatMicroPdf417Configuration = BarcodeFormatMicroPdf417Configuration;
exports.BarcodeFormatMsiPlesseyConfiguration = BarcodeFormatMsiPlesseyConfiguration;
exports.BarcodeFormatPdf417Configuration = BarcodeFormatPdf417Configuration;
exports.BarcodeFormatPharmaCodeConfiguration = BarcodeFormatPharmaCodeConfiguration;
exports.BarcodeFormatPharmaCodeTwoTrackConfiguration = BarcodeFormatPharmaCodeTwoTrackConfiguration;
exports.BarcodeFormatQrCodeConfiguration = BarcodeFormatQrCodeConfiguration;
exports.BarcodeFormatRoyalMailConfiguration = BarcodeFormatRoyalMailConfiguration;
exports.BarcodeFormatRoyalTntPostConfiguration = BarcodeFormatRoyalTntPostConfiguration;
exports.BarcodeFormatUpcEanConfiguration = BarcodeFormatUpcEanConfiguration;
exports.BarcodeFormatUspsIntelligentMailConfiguration = BarcodeFormatUspsIntelligentMailConfiguration;
exports.BarcodeFormatValues = BarcodeFormatValues;
exports.BarcodeFormats = BarcodeFormats;
exports.BarcodeInfoMapping = BarcodeInfoMapping;
exports.BarcodeItem = BarcodeItem;
exports.BarcodeItemConfiguration = BarcodeItemConfiguration;
exports.BarcodeItemErrorState = BarcodeItemErrorState;
exports.BarcodeItemInfoPositionValues = BarcodeItemInfoPositionValues;
exports.BarcodeMappedData = BarcodeMappedData;
exports.BarcodeScannerConfiguration = BarcodeScannerConfiguration;
exports.BarcodeScannerEngineModeValues = BarcodeScannerEngineModeValues;
exports.BarcodeScannerResult = BarcodeScannerResult;
exports.BarcodeScannerScreenConfiguration = BarcodeScannerScreenConfiguration;
exports.BarcodeScannerUiItem = BarcodeScannerUiItem;
exports.BarcodeScannerUiResult = BarcodeScannerUiResult;
exports.BarcodeTextLocalization = BarcodeTextLocalization;
exports.BasicImageLoadOptions = BasicImageLoadOptions;
exports.BoardingPass = BoardingPass;
exports.BoardingPassDocumentType = BoardingPassDocumentType;
exports.BoardingPassLegDocumentType = BoardingPassLegDocumentType;
exports.BufferImageLoadOptions = BufferImageLoadOptions;
exports.BufferLoadModeValues = BufferLoadModeValues;
exports.ButtonConfiguration = ButtonConfiguration;
exports.CameraConfiguration = CameraConfiguration;
exports.CameraModuleValues = CameraModuleValues;
exports.CameraPermissionScreen = CameraPermissionScreen;
exports.CameraPreviewModeValues = CameraPreviewModeValues;
exports.CollapsedVisibleHeightValues = CollapsedVisibleHeightValues;
exports.CommonBarcodeScannerConfiguration = CommonBarcodeScannerConfiguration;
exports.CommonFieldTypeValues = CommonFieldTypeValues;
exports.DEMedicalPlan = DEMedicalPlan;
exports.DEMedicalPlanDoctorDocumentType = DEMedicalPlanDoctorDocumentType;
exports.DEMedicalPlanDocumentType = DEMedicalPlanDocumentType;
exports.DEMedicalPlanPatientDocumentType = DEMedicalPlanPatientDocumentType;
exports.DEMedicalPlanSubheadingDocumentType = DEMedicalPlanSubheadingDocumentType;
exports.DEMedicalPlanSubheadingMedicineDocumentType = DEMedicalPlanSubheadingMedicineDocumentType;
exports.DEMedicalPlanSubheadingMedicineSubstanceDocumentType = DEMedicalPlanSubheadingMedicineSubstanceDocumentType;
exports.DEMedicalPlanSubheadingPrescriptionDocumentType = DEMedicalPlanSubheadingPrescriptionDocumentType;
exports.EdgeInsets = EdgeInsets;
exports.EncodeImageOptions = EncodeImageOptions;
exports.EncodingFormatValues = EncodingFormatValues;
exports.EncryptionModeValues = EncryptionModeValues;
exports.ExpectedBarcode = ExpectedBarcode;
exports.Field = Field;
exports.FieldDataFormatValues = FieldDataFormatValues;
exports.FieldParsedData = FieldParsedData;
exports.FieldType = FieldType;
exports.FieldValidationStatusValues = FieldValidationStatusValues;
exports.FindAndPickArOverlayPolygonConfiguration = FindAndPickArOverlayPolygonConfiguration;
exports.FindAndPickBadgeConfiguration = FindAndPickBadgeConfiguration;
exports.FindAndPickScanningMode = FindAndPickScanningMode;
exports.FinderCorneredStyle = FinderCorneredStyle;
exports.FinderStrokedStyle = FinderStrokedStyle;
exports.ForegroundStyle = ForegroundStyle;
exports.GS1 = GS1;
exports.GS1DocumentType = GS1DocumentType;
exports.GS1ElementDocumentType = GS1ElementDocumentType;
exports.GS1ElementValidationErrorDocumentType = GS1ElementValidationErrorDocumentType;
exports.GenericDocument = GenericDocument;
exports.GenericDocumentType = GenericDocumentType;
exports.Gs1HandlingValues = Gs1HandlingValues;
exports.HIBC = HIBC;
exports.HIBCDocumentType = HIBCDocumentType;
exports.IDCardPDF417 = IDCardPDF417;
exports.IDCardPDF417DocumentType = IDCardPDF417DocumentType;
exports.IconButton = IconButton;
exports.IconStyle = IconStyle;
exports.IconUserGuidanceConfiguration = IconUserGuidanceConfiguration;
exports.ImageInfo = ImageInfo;
exports.ImageProfile = ImageProfile;
exports.ImageRef = ImageRef;
exports.ImageRefPoolSnapshot = ImageRefPoolSnapshot;
exports.ImageRefPoolSnapshotsDiff = ImageRefPoolSnapshotsDiff;
exports.ImageRefProfile = ImageRefProfile;
exports.ImageRotationValues = ImageRotationValues;
exports.ImageSerializationModeValues = ImageSerializationModeValues;
exports.ImageSource = ImageSource;
exports.ImageSourceTypeValues = ImageSourceTypeValues;
exports.LineSegmentFloat = LineSegmentFloat;
exports.LineSegmentInt = LineSegmentInt;
exports.ManualCountEditDialog = ManualCountEditDialog;
exports.MedicalCertificate = MedicalCertificate;
exports.MedicalCertificateDocumentType = MedicalCertificateDocumentType;
exports.MsiPlesseyChecksumAlgorithmValues = MsiPlesseyChecksumAlgorithmValues;
exports.MultipleBarcodesScanningModeValues = MultipleBarcodesScanningModeValues;
exports.MultipleScanningMode = MultipleScanningMode;
exports.NavigationBarModeValues = NavigationBarModeValues;
exports.OcrResult = OcrResult;
exports.OrientationLockModeValues = OrientationLockModeValues;
exports.Palette = Palette;
exports.PartiallyConstructible = PartiallyConstructible;
exports.PathImageLoadOptions = PathImageLoadOptions;
exports.PathLoadModeValues = PathLoadModeValues;
exports.PermanentViewFinderConfiguration = PermanentViewFinderConfiguration;
exports.Point = Point;
exports.PolygonStyle = PolygonStyle;
exports.PopupMenuItem = PopupMenuItem;
exports.RawImageLoadOptions = RawImageLoadOptions;
exports.RefCountedObjectProfile = RefCountedObjectProfile;
exports.RoundButton = RoundButton;
exports.SEPA = SEPA;
exports.SEPADocumentType = SEPADocumentType;
exports.SaveImageOptions = SaveImageOptions;
exports.ScanCompletionOverlay = ScanCompletionOverlay;
exports.ScanbotAlertDialog = ScanbotAlertDialog;
exports.ScanbotBarcodeSDK = ScanbotBarcodeSDK;
exports.ScanbotBarcodeSDKPlugin = ScanbotBarcodeSDKPlugin;
exports.Sheet = Sheet;
exports.SheetContent = SheetContent;
exports.SheetModeValues = SheetModeValues;
exports.SingleScanningMode = SingleScanningMode;
exports.Sound = Sound;
exports.SoundTypeValues = SoundTypeValues;
exports.StatusBarModeValues = StatusBarModeValues;
exports.StyledText = StyledText;
exports.SwipeToDelete = SwipeToDelete;
exports.SwissQR = SwissQR;
exports.SwissQRDocumentType = SwissQRDocumentType;
exports.Timeouts = Timeouts;
exports.ToJsonConfiguration = ToJsonConfiguration;
exports.TopBarConfiguration = TopBarConfiguration;
exports.TopBarModeValues = TopBarModeValues;
exports.UpcEanExtensionBehaviorValues = UpcEanExtensionBehaviorValues;
exports.UserGuidanceConfiguration = UserGuidanceConfiguration;
exports.VCard = VCard;
exports.VCardAnniversaryDocumentType = VCardAnniversaryDocumentType;
exports.VCardBirthdayDocumentType = VCardBirthdayDocumentType;
exports.VCardBusyTimeURLDocumentType = VCardBusyTimeURLDocumentType;
exports.VCardCalendarURIDocumentType = VCardCalendarURIDocumentType;
exports.VCardCalendarURIForRequestsDocumentType = VCardCalendarURIForRequestsDocumentType;
exports.VCardCategoriesDocumentType = VCardCategoriesDocumentType;
exports.VCardClientPIDMapDocumentType = VCardClientPIDMapDocumentType;
exports.VCardCustomDocumentType = VCardCustomDocumentType;
exports.VCardDeliveryAddressDocumentType = VCardDeliveryAddressDocumentType;
exports.VCardDocumentType = VCardDocumentType;
exports.VCardEmailDocumentType = VCardEmailDocumentType;
exports.VCardEntryDocumentType = VCardEntryDocumentType;
exports.VCardFirstNameDocumentType = VCardFirstNameDocumentType;
exports.VCardGenderDocumentType = VCardGenderDocumentType;
exports.VCardGeoLocationDocumentType = VCardGeoLocationDocumentType;
exports.VCardIMPPDocumentType = VCardIMPPDocumentType;
exports.VCardKindDocumentType = VCardKindDocumentType;
exports.VCardLanguagesDocumentType = VCardLanguagesDocumentType;
exports.VCardLogoDocumentType = VCardLogoDocumentType;
exports.VCardMemberDocumentType = VCardMemberDocumentType;
exports.VCardNameDocumentType = VCardNameDocumentType;
exports.VCardNicknameDocumentType = VCardNicknameDocumentType;
exports.VCardNoteDocumentType = VCardNoteDocumentType;
exports.VCardOrganisationDocumentType = VCardOrganisationDocumentType;
exports.VCardPhotoDocumentType = VCardPhotoDocumentType;
exports.VCardProductIdDocumentType = VCardProductIdDocumentType;
exports.VCardPublicKeyDocumentType = VCardPublicKeyDocumentType;
exports.VCardRelatedDocumentType = VCardRelatedDocumentType;
exports.VCardRevisionDocumentType = VCardRevisionDocumentType;
exports.VCardRoleDocumentType = VCardRoleDocumentType;
exports.VCardSoundDocumentType = VCardSoundDocumentType;
exports.VCardSourceDocumentType = VCardSourceDocumentType;
exports.VCardTelephoneNumberDocumentType = VCardTelephoneNumberDocumentType;
exports.VCardTimeZoneDocumentType = VCardTimeZoneDocumentType;
exports.VCardTitleDocumentType = VCardTitleDocumentType;
exports.VCardUIDDocumentType = VCardUIDDocumentType;
exports.VCardURLDocumentType = VCardURLDocumentType;
exports.VCardVersionDocumentType = VCardVersionDocumentType;
exports.VCardXMLDocumentType = VCardXMLDocumentType;
exports.Vibration = Vibration;
exports.ViewFinderConfiguration = ViewFinderConfiguration;
exports.autorelease = autorelease;
exports.mapPlainResult = mapPlainResult;
exports.mapRTUUIResult = mapRTUUIResult;
//# sourceMappingURL=plugin.cjs.js.map
